<!-- # OMEinsum -->
<div align="center"> <img
src="ome-logo.png"
alt="OMEinsum logo" width="510"></img>
<h1>OMEinsum - One More Einsum</h1>
</div>

[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://under-Peter.github.io/OMEinsum.jl/dev)
[![CI](https://github.com/under-Peter/OMEinsum.jl/actions/workflows/ci.yml/badge.svg)](https://github.com/under-Peter/OMEinsum.jl/actions/workflows/ci.yml)
[![Codecov](https://codecov.io/gh/under-Peter/OMEinsum.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/under-Peter/OMEinsum.jl)

This is a repository for the _Google Summer of Code_ project on *Differentiable Tensor Networks*.
It implements one function that both computer scientists and physicists love, the *Einstein summation*

<img alt="einsum definition" src="https://github.com/under-Peter/OMEinsum.jl/blob/master/docs/einsum_define.png?raw=true" width=300/>

To find out the details about einsum, please check out my [nextjournal-article](https://nextjournal.com/under-Peter/julia-summer-of-einsum) or the [numpy-manual](https://docs.scipy.org/doc/numpy/reference/generated/numpy.einsum.html).

Einstein summation can be implemented in no more than 20 lines of Julia code, the automatic differentiation is also [straightforward](https://giggleliu.github.io/2019/04/02/einsumbp.html). The main effort of this package is improving the [performance](https://github.com/under-Peter/OMEinsum-Benchmarks) utilizing Julia [multiple dispatch on traits](https://white.ucc.asn.au/2018/10/03/Dispatch,-Traits-and-Metaprogramming-Over-Reflection.html). So that people can enjoy the speed of faster specific implementations like BLAS functions, `sum` and `permutedims` on both CPU and GPU without suffering from runtime overhead.

*Note: why the test coverage is not 100%* - GPU-code coverage is not evaluated although we test the GPU code properly on gitlab. Ignoring the GPU-code, the actual coverage is at about _97%_.

*Warning: since v0.4, OMEinsum does not optimize the contraction order anymore. One has to use nested einsum to specify the contraction order manually, e.g. `ein"(ijk,jkl),klm->im"(x, y, z)`.* Please check out the [documentation](https://under-Peter.github.io/OMEinsum.jl/dev/contractionorder/) for more details.

## Install

To install, type `]` in a julia (>=1.5) REPL and then input
```julia pkg
pkg> add OMEinsum
```

## Learn by Examples
To avoid runtime overhead, we recommend users to use [non-standard string literal](https://docs.julialang.org/en/v1/manual/metaprogramming/#Non-Standard-String-Literals-1) `@ein_str`. The following examples illustrates how `einsum` works

```julia
julia> using OMEinsum, SymEngine

julia> catty = fill(Basic(:🐱), 2, 2)
2×2 Array{Basic,2}:
 🐱  🐱
 🐱  🐱

julia> fish = fill(Basic(:🐟), 2, 3, 2)
2×3×2 Array{Basic,3}:
[:, :, 1] =
 🐟  🐟  🐟
 🐟  🐟  🐟

[:, :, 2] =
 🐟  🐟  🐟
 🐟  🐟  🐟

julia> snake = fill(Basic(:🐍), 3, 3)
3×3 Array{Basic,2}:
 🐍  🐍  🐍
 🐍  🐍  🐍
 🐍  🐍  🐍

julia> medicine = ein"ij,jki,kk->k"(catty, fish, snake)
3-element Array{Basic,1}:
 4*🐱*🐍*🐟
 4*🐱*🐍*🐟
 4*🐱*🐍*🐟

julia> ein"ik,kj -> ij"(catty, catty) # multiply two matrices `a` and `b`
2×2 Array{Basic,2}:
 2*🐱^2  2*🐱^2
 2*🐱^2  2*🐱^2

julia> ein"ij -> "(catty)[] # sum a matrix, output 0-dimensional array
4*🐱

julia> ein"->ii"(asarray(snake[1,1]), size_info=Dict('i'=>5)) # get 5 x 5 identity matrix
5×5 Array{Basic,2}:
 🐍  0  0  0  0
 0  🐍  0  0  0
 0  0  🐍  0  0
 0  0  0  🐍  0
 0  0  0  0  🐍
```

Alternatively, people can specify the contraction with a construction approach, which is useful when the contraction code can only be obtained at run time
```julia
julia> einsum(EinCode((('i','k'),('k','j')),('i','j')),(a,b))
```
or a macro based interface, `@ein` macro,
which is closer to the standard way of writing einsum-operations in physics
```julia
julia> @ein c[i,j] := a[i,k] * b[k,j];
```

It is sometimes helpful to specify the order of operations, by inserting brackets, either because you know this will be more efficient,  or to help the computer see what kernels can be used.  For example:
```julia
julia> @ein Z[o,s] := x[i,s] * (W[o,i,j] * y[j,s]);   # macro style

julia> Z = ein"is, (oij, js) -> os"(x, W, y);         # string style
```
This performs matrix multiplication (summing over `j`) 
followed by batched matrix multiplication (summing over `i`, batch label `s`). 
Without the brackets, instead it uses the fallback `loop_einsum`, which is slower.
Calling `allow_loops(false)` will print an error to help you spot such cases:
```julia
julia> @ein Zl[o,s] := x[i,s] * W[o,i,j] * y[j,s];

julia> Z ≈ Zl
true

julia> allow_loops(false);

julia> Zl = ein"is, oij, js -> os"(x, W, y);
┌ Error: using `loop_einsum` to evaluate
│   code = is, oij, js -> os
│   size.(xs) = ((10, 50), (20, 10, 10), (10, 50))
│   size(y) = (20, 50)
└ @ OMEinsum ~/.julia/dev/OMEinsum/src/loop_einsum.jl:26
```

## Comparison with other packages
Similar packages include:
- [TensorOperations.jl](https://github.com/Jutho/TensorOperations.jl) and [TensorKit.jl](https://github.com/Jutho/TensorKit.jl)
- [ITensors.jl](https://github.com/ITensor/ITensors.jl)

Comparing with the above packages, `OMEinsum` is optimized over large scale tensor network (or einsum, sum-product network) contraction.

## Contribute

Suggestions and Comments in the [_Issues_](https://github.com/under-Peter/OMEinsum.jl/issues) are welcome.

@doc raw"
    match_rule(ixs, iy)
    match_rule(code::EinCode)

Returns the rule that matches, otherwise use `DefaultRule` - the slow `loop_einsum` backend.
"
function match_rule(ixs, iy)
    if length(ixs) == 1
        return match_rule_unary(ixs[1], iy)
    elseif length(ixs) == 2
        return match_rule_binary(ixs[1], ixs[2], iy)
    else
        return DefaultRule()
    end
end

function match_rule_unary(ix, iy)
    Nx = length(ix)
    Ny = length(iy)
    # the first rule with the higher the priority
    if Ny == 0 && Nx == 2 && ix[1] == ix[2]
        return Tr()
    elseif allunique(iy)
        if ix == iy
            return Identity()
        elseif allunique(ix)
            if Nx == Ny
                if all(i -> i in iy, ix)
                    return Permutedims()
                else  # e.g. (abcd->bcde)
                    return DefaultRule()
                end
            else
                if all(i -> i in ix, iy)
                    return Sum()
                elseif all(i -> i in iy, ix)  # e.g. ij->ijk
                    return Repeat()
                else  # e.g. ijkxc,ijkl
                    return DefaultRule()
                end
            end
        else  # ix is not unique
            if all(i -> i in ix, iy) && all(i -> i in iy, ix)   # ijjj->ij
                return Diag()
            else
                return DefaultRule()
            end
        end
    else  # iy is not unique
        if allunique(ix) && all(x->x∈iy, ix)
            if all(y->y∈ix, iy)  # e.g. ij->ijjj
                return Duplicate()
            else  # e.g. ij->ijjl
                return DefaultRule()
            end
        else
            return DefaultRule()
        end
    end
end

match_rule(code::EinCode) = match_rule(getixs(code), getiy(code))


@inline function _add_batch(::SimpleBinaryRule{ix1,ix2,iy}) where {ix1,ix2,iy}
    SimpleBinaryRule{(ix1...,'l'), (ix2...,'l'), (iy...,'l')}()
end
@inline _add_batch(::DefaultRule) = DefaultRule()

function match_rule_binary(ix1, ix2, iy)
    Nx1, Nx2, Ny = length(ix1), length(ix2), length(iy)
    if !_isunique(ix1) || !_isunique(ix2) || !_isunique(iy)
        DefaultRule()
    elseif (Nx1 + Nx2 + Ny) % 2 == 0 # no batch
        _match_simple2(ix1,ix2,iy,Nx1,Nx2,Ny)
    elseif Nx1>0 && Nx2>0 && Ny>0 && ix1[Nx1]==ix2[Nx2]==iy[Ny]
        rule = _match_simple2(ix1,ix2,iy,Nx1-1,Nx2-1,Ny-1)
        _add_batch(rule)
    else
        DefaultRule()
    end
end
@inline function _isunique(ix)
    if length(ix) <= 1
        return true
    elseif length(ix) == 2
        return @inbounds ix[1] != ix[2]
    elseif length(ix) == 3
        @inbounds a, b, c = ix
        return a != c && a != c && a != b
    else  # to default rules
        return false
    end
end

function _match_simple2(ix1, ix2, iy, Nx1, Nx2, Ny)
    if Nx1==0
        if (Ny==Nx2==0)
            return SimpleBinaryRule((), (), ())
        elseif (Ny==Nx2==1 && ix2[1] == iy[1])
            return SimpleBinaryRule((), ('k',), ('k',))
        end
    elseif Nx1==1
        if (Nx2==0 && Ny==1 && iy[1]==ix1[1])
            return SimpleBinaryRule(('i',), (), ('i',))
        elseif (Nx2==1 && Ny==0 && ix1[1]==ix2[1])
            return SimpleBinaryRule(('j',), ('j',), ())
        elseif Nx2==1 && Ny==2
            if (iy[1]==ix1[1] && iy[2]==ix2[1])
                return SimpleBinaryRule(('i',), ('k',), ('i','k'))
            elseif iy[1]==ix2[1] && iy[2]==ix1[1]
                return SimpleBinaryRule(('i',), ('k',), ('k','i'))
            end
        elseif Nx2==2 && Ny==1
            if ix2[1]==ix1[1] && ix2[2]==iy[1]
                return SimpleBinaryRule(('j',), ('j','k'), ('k',))
            elseif ix2[1]==iy[1] && ix2[2]==ix1[1]
                return SimpleBinaryRule(('j',), ('k','j'), ('k',))
            end
        end
    elseif Nx1==2
        if Nx2==1 && Ny==1
            if ix1[1]==ix2[1] && ix1[2]==iy[1]
                return SimpleBinaryRule(('j','i'), ('j',), ('i',))
            elseif ix1[1]==iy[1] && ix1[2]==ix2[1]
                return SimpleBinaryRule(('i','j'), ('j',), ('i',))
            end
        elseif (Nx2==2 && Ny==2)
            if ix1[1]==ix2[1] && ix1[2]==iy[1] && ix2[2]==iy[2]
                return SimpleBinaryRule(('j','i'), ('j','k'), ('i','k'))
            elseif ix1[1]==ix2[2] && ix1[2]==iy[1] && ix2[1]==iy[2]
                return SimpleBinaryRule(('j','i'), ('k','j'), ('i','k'))
            elseif ix1[1]==ix2[1] && ix1[2]==iy[2] && ix2[2]==iy[1]
                return SimpleBinaryRule(('j','i'), ('j','k'), ('k','i'))
            elseif ix1[1]==ix2[2] && ix1[2]==iy[2] && ix2[1]==iy[1]
                return SimpleBinaryRule(('j','i'), ('k','j'), ('k','i'))
            elseif ix1[2]==ix2[1] && ix1[1]==iy[1] && ix2[2]==iy[2]
                return SimpleBinaryRule(('i','j'), ('j','k'), ('i','k'))
            elseif ix1[2]==ix2[2] && ix1[1]==iy[1] && ix2[1]==iy[2]
                return SimpleBinaryRule(('i','j'), ('k','j'), ('i','k'))
            elseif ix1[2]==ix2[1] && ix1[1]==iy[2] && ix2[2]==iy[1]
                return SimpleBinaryRule(('i','j'), ('j','k'), ('k','i'))
            elseif ix1[2]==ix2[2] && ix1[1]==iy[2] && ix2[1]==iy[1]
                return SimpleBinaryRule(('i','j'), ('k','j'), ('k','i'))
            end
        end
    end
    return DefaultRule()
end

using Test
using OMEinsum
using OMEinsum: get_size_dict

@testset "unspecified index sizes" begin
    v = randn(5)
    a = randn(6,6)
    xs = (v, a)
    ixs = (('j',), ('k', 'k'))
    @test einsum(ein"j,kk->j", xs, get_size_dict(ixs, xs)) ≈ ein"j,kk->j"(xs...)
    res = ein"j,kk->iij"(xs...; size_info=Dict('i'=>9))
    @test size(res) == (9,9,5)
    @test ein"ijk,
    ijk->
    ikl" == ein"ijk,ijk->ikl"
end

@testset "unicode index labels" begin
    # basic Greek letters (within α-ω range)
    ec1 = ein"aζ,ζβ->aβ"
    @test OMEinsum.getixs(ec1) == (('a', 'ζ'), ('ζ', 'β'))
    @test OMEinsum.getiy(ec1) == ('a', 'β')

    # Greek letters outside α-ω range (e.g. ϵ = U+03F5)
    ec2 = ein"abc,ζαfa,ϵβeb,δγdc,def,βγ,ϵζ->δα"
    @test length(OMEinsum.getixs(ec2)) == 7
    @test OMEinsum.getixs(ec2)[3] == ('ϵ', 'β', 'e', 'b')
    @test OMEinsum.getiy(ec2) == ('δ', 'α')

    # correctness: Greek indices contract properly
    A = rand(3, 3)
    B = rand(3, 3)
    @test ein"αβ,βγ->αγ"(A, B) ≈ A * B
    @test ein"αi,iγ->αγ"(A, B) ≈ A * B

    # nested einsum with Unicode
    ec3 = ein"(αβ,βγ),γδ->αδ"
    @test ec3 isa NestedEinsum
    C = rand(3, 3)
    @test ec3(A, B, C) ≈ A * B * C

    # invalid characters should error, not silently truncate
    @test_throws ArgumentError OMEinsum.ein("ab,b1->a1")
end

@testset "opein" begin
    code = optein"ij,jk,ki->"
    @test code isa NestedEinsum
end

using OMEinsum, BenchmarkTools

function benchmark_tensorpermute()
    # tensorpermute
    A = randn(fill(2, 28)...);
    C = zero(A);
    perm = [18  22  11  21  15  9  10  19  24  14  5  1  17  20 26 25 28 27 7  6  3  13  12  16  8  23  2  4] |> vec
    @btime OMEinsum.tensorpermute!($C, $A, $perm, true, false) evals=3
    nothing
end

module CUDAExt

import OMEinsum: asarray, get_output_array, einsum, loop_einsum!, _batched_gemm!, asscalar, @flatten_addmul!
using OMEinsum: EinArray, Diag, Repeat, Duplicate, DefaultRule, EinCode, DynamicEinCode, StaticEinCode, NestedEinsum, SimpleBinaryRule, match_rule, loop_einsum, getiy, getixs, _unique, einarray, align_eltypes, siblings, isleaf, tensorindex, _safe_set, rootcode
import OMEinsum
using LinearAlgebra
import LinearAlgebra: BlasFloat
using CUDA

const CuBlasFloat = Union{BlasFloat, Float16, ComplexF16}
const CUDAArrayTypes{T,N} = Union{LinearAlgebra.Transpose{T,<:CuArray{T,N}}, DenseCuArray{T,N}, LinearAlgebra.Adjoint{T,<:CuArray{T,N}}}
_unwrap(x::LinearAlgebra.Adjoint{T,<:CuArray{T}}) where T = CuArray(x)
_unwrap(x::LinearAlgebra.Transpose{T,<:CuArray{T}}) where T = CuArray(x)
_unwrap(x::CuArray) = x

asarray(x, arr::CuArray) = CuArray(fill(x, ()))
asarray(x::AbstractArray, y::CuArray) = x
asscalar(x::CUDAArrayTypes) = Array(x)[]

# to avoid returning a ReshapedArray
OMEinsum.safe_reshape(x::CuArray, sz) = reshape(x, (sz...,))
OMEinsum.safe_reshape(x::Adjoint{T, <:CuArray{T}} where T, sz) = reshape(CuArray(x), (sz...,))
OMEinsum.safe_reshape(x::Transpose{T, <:CuArray{T}} where T, sz) = reshape(CuArray(x), (sz...,))

Base.Array(x::Base.ReshapedArray{T,0,<:CuArray}) where T = Array(x.parent)

function get_output_array(xs::NTuple{N, CUDAArrayTypes{<:Any,M} where M}, size, fillzero::Bool) where N
    if fillzero
        return CUDA.zeros(promote_type(map(eltype,xs)...), size...)
    else
        return CuArray{promote_type(map(eltype,xs)...)}(undef, size...)
    end
end
function get_output_array(xs::NTuple{N, CUDAArrayTypes{T,M} where M}, size, fillzero::Bool) where {T,N}
    if fillzero
        return CUDA.zeros(T, size...)
    else
        return CuArray{T}(undef, size...)
    end
end

CUDA.cudaconvert(A::EinArray{T}) where T = EinArray{T}(cudaconvert.(A.xs), A.x_indexers, A.y_indexer, A.size, A.ICIS, A.OCIS)
CUDA.cu(A::EinArray{T}) where T = EinArray{T}(cu.(A.xs), A.x_indexers, A.y_indexer, A.size, A.ICIS, A.OCIS)

for TP in [:Diag, :Repeat, :Duplicate]
    @eval function OMEinsum.unary_einsum!(::$TP, ix, iy, x::CUDAArrayTypes, y::CUDAArrayTypes, sx, sy)
        @debug "cueinsum fallback to loop_einsum" rule ix => iy size(x)
        size_dict = OMEinsum.get_size_dict((ix, iy), (x, y))
        loop_einsum!((ix,), iy, (x,), y, sx, sy, size_dict)
    end
end

function loop_einsum!(ixs0, iy0,
                xs::NTuple{N, CUDAArrayTypes{<:Any,M} where M},
                y::CUDAArrayTypes{T,L}, sx, sy, size_dict::Dict{LT}) where {N,L,T, LT}
    iy = (iy0...,)
    ixs = (Tuple.(ixs0)...,)
    iy_ = _unique(LT,iy)
    NO = length(iy_)
    A = einarray(Val(ixs), Val((iy_...,)), xs, size_dict)
    if NO == length(iy)
        raw_ = similar(y, (fill(1, ndims(A)-NO)...,size(y)...,))
        fill!(raw_, zero(T))
        Base.mapreducedim!(x->x, +, raw_, A)
        if ndims(A)-NO > 0  # fix 1.7 compatibility
            raw = dropdims(raw_, dims=(1:ndims(A)-NO...,))
        else
            raw = raw_
        end
        return @flatten_addmul! sy * y + sx * raw
    else
        if iszero(sy)
            fill!(y, zero(T))
        else
            lmul!(sy, y)
        end
        y_ = similar(y, (fill(1, ndims(A)-NO)...,[size_dict[l] for l in iy_]...))
        fill!(y_, zero(T))
        raw = Base.mapreducedim!(x->x, +, y_, A)
        if ndims(A)-NO > 0  # fix 1.7 compatibility
            raw = dropdims(raw, dims=(1:ndims(A)-NO...,))
        end
        return expanddims!(Val{((iy_...,),)}(), Val{iy}(), raw, y, sx)
    end
end

@generated function expandind(::Val{ixs}, ::Val{iy}, ind) where {ixs, iy}
    ix = ixs[1]
    ids = map(ii->:(ind[$(findfirst(==(ii), ix))]), iy)
    Expr(:tuple, ids...)
end

function expanddims!(::Val{ixs}, ::Val{iy}, x, y, sx) where {ixs,iy}
    nthreads = 256
    nblocks = cld(prod(size(x)), nthreads)
    CIS = CartesianIndices(x)
    @inline function kernel(y, x)
        i = (blockIdx().x-1) * blockDim().x + threadIdx().x
        i > length(x) && return nothing
        @inbounds yi = expandind(Val{ixs}(), Val{iy}(), CIS[i].I)
        @inbounds y[CartesianIndex(yi)] += sx * x[i]
        nothing
    end
    @cuda(blocks=nblocks, threads=nthreads, kernel(y, x))
    return y
end

function _batched_gemm!(C1::Char, C2::Char, alpha, A::CUDAArrayTypes{T1,3}, B::CUDAArrayTypes{T2,3}, beta, C::CUDAArrayTypes{T3,3}) where {T1<:CuBlasFloat, T2<:CuBlasFloat, T3<:CuBlasFloat}
    CUDA.CUBLAS.gemm_strided_batched!(C1, C2, alpha, T1 == T3 ? A : T3.(A), T2 == T3 ? B : T3.(B), beta, C)
end

Base.ndims(::Base.Broadcast.Broadcasted{CUDA.CuArrayStyle{0}}) = 0

function einsum!(neinsum::NestedEinsum, @nospecialize(xs::NTuple{N,CUDAArrayTypes} where N), @nospecialize(y::CUDAArrayTypes), sx, sy, size_dict::Dict; active_free=false)
    # do not use map because the static overhead is too large
    # do not use `setindex!` because we need to make the AD work
    mxs = Vector{AbstractArray}(undef, length(siblings(neinsum)))
    for (i, arg) in enumerate(siblings(neinsum))
        mxs = _safe_set(mxs, i, isleaf(arg) ? xs[tensorindex(arg)] : einsum(arg, xs, similar(y, ([size_dict[l] for l in getiy(rootcode(arg))]...,)), true, false, size_dict; active_free=active_free))
    end
    res = einsum!(rootcode(neinsum), (mxs...,), y, sx, sy, size_dict)
    active_free && for mx in mxs  # free CuArray aggressively.
        CUDA.unsafe_free!(mx)
    end
    return res
end

function einsum(neinsum::NestedEinsum, @nospecialize(xs::NTuple{N,CUDAArrayTypes} where N), size_dict::Dict; active_free=false)
    # do not use map because the static overhead is too large
    # do not use `setindex!` because we need to make the AD work
    mxs = Vector{AbstractArray}(undef, length(siblings(neinsum)))
    for (i, arg) in enumerate(siblings(neinsum))
        mxs = _safe_set(mxs, i, isleaf(arg) ? xs[tensorindex(arg)] : einsum(arg, xs, size_dict; active_free=active_free))
    end
    res = einsum(rootcode(neinsum), (mxs...,), size_dict)
    active_free && for mx in mxs  # free CuArray aggressively.
        CUDA.unsafe_free!(mx)
    end
    return res
end

@info("OMEinsum loaded the CUDA module successfully")

end

using OMEinsum
using TropicalNumbers
using Test, Random

@testset "tree greedy" begin
    Random.seed!(2)
    #incidence_list = IncidenceList(Dict('A' => ['a', 'b'], 'B'=>['a', 'c', 'd'], 'C'=>['b', 'c', 'e', 'f'], 'D'=>['e'], 'E'=>['d', 'f']))
    #log2_edge_sizes = Dict([c=>i for (i,c) in enumerate(['a', 'b', 'c', 'd', 'e', 'f'])]...)
    edge_sizes = Dict([c=>(1<<i) for (i,c) in enumerate(['a', 'b', 'c', 'd', 'e', 'f'])]...)
    eincode = ein"ab,acd,bcef,e,df->"
    size_dict = Dict([c=>(1<<i) for (i,c) in enumerate(['a', 'b', 'c', 'd', 'e', 'f'])]...)
    Random.seed!(2)
    optcode2 = optimize_code(eincode, size_dict, GreedyMethod()) 
    tc, sc = contraction_complexity(optcode2, edge_sizes)
    # test flop
    @test tc ≈ log2(flop(optcode2, edge_sizes))
    @test flop(ein"i->", Dict('i'=>4)) == 4
    @test 16 <= tc <= log2(exp2(10)+exp2(16)+exp2(15)+exp2(9)+1e-8)
    @test sc == 11
    eincode3 = ein"(ab,acd),bcef,e,df->"
    Random.seed!(2)
    optcode3 = optimize_code(eincode3, size_dict, GreedyMethod()) 
    tc, sc = contraction_complexity(optcode3, edge_sizes)
    @test 16 <= tc <= log2(exp2(10)+exp2(16)+exp2(15)+exp2(9)+1e-8)

    optcode4 = optimize_code(eincode3, size_dict, ExactTreewidth()) 
    tc, sc = contraction_complexity(optcode4, edge_sizes)
    @test 16 <= tc <= log2(exp2(10)+exp2(16)+exp2(15)+exp2(9)+1e-8)
end

@testset "fullerene" begin
    function fullerene()
        φ = (1+√5)/2
        res = NTuple{3,Float64}[]
        for (x, y, z) in ((0.0, 1.0, 3φ), (1.0, 2 + φ, 2φ), (φ, 2.0, 2φ + 1.0))
            for (α, β, γ) in ((x,y,z), (y,z,x), (z,x,y))
                for loc in ((α,β,γ), (α,β,-γ), (α,-β,γ), (α,-β,-γ), (-α,β,γ), (-α,β,-γ), (-α,-β,γ), (-α,-β,-γ))
                    if loc ∉ res
                        push!(res, loc)
                    end
                end
            end
        end
        return res
    end

    c60_xy = fullerene()
    c60_edges = [(i,j) for (i,(i2,j2,k2)) in enumerate(c60_xy), (j,(i1,j1,k1)) in enumerate(c60_xy) if i<j && (i2-i1)^2+(j2-j1)^2+(k2-k1)^2 < 5.0]
    code = EinCode((c60_edges..., [(i,) for i=1:60]...), ())
    size_dict = Dict([i=>2 for i in 1:60])
    log2_edge_sizes = Dict([i=>1 for i in 1:60])
    edge_sizes = Dict([i=>2 for i in 1:60])
    tc, sc = contraction_complexity(code, edge_sizes)
    @test tc == 60
    @test sc == 0
    optcode = optimize_code(code, size_dict, TreeSA(ntrials=1), MergeVectors())
    tc2, sc2 = contraction_complexity(optcode, edge_sizes)
    @test sc2 == 10
    xs = vcat([TropicalF64.([-1 1; 1 -1]) for i=1:90], [TropicalF64.([0, 0]) for i=1:60])
    @test OMEinsum.flatten(optcode) == code
    @test OMEinsum.flatten(code) == code
    @test optcode(xs...)[].n == 66
end

@testset "regression test" begin
    code = ein"i->"
    optcode = optimize_code(code, Dict('i'=>3), GreedyMethod())
    @test optcode isa NestedEinsum
    x = randn(3)
    @test optcode(x) ≈ code(x)

    code = ein"i,j->"
    optcode = optimize_code(code, Dict('i'=>3, 'j'=>3), GreedyMethod())
    @test optcode isa NestedEinsum
    x = randn(3)
    y = randn(3)
    @test optcode(x, y) ≈ code(x, y)

    code = ein"ij,jk,kl->ijl"
    optcode = optimize_code(code, Dict('i'=>3, 'j'=>3, 'k'=>3, 'l'=>3), GreedyMethod())
    @test optcode isa NestedEinsum
    a, b, c = [rand(3,3) for i=1:3]
    @test optcode(a, b, c) ≈ code(a, b, c)
end

@testset "simplifier and permute optimizer" begin
    code = EinCode([['a','b'], ['b','c'], ['c','d']], ['a','d'])
    code = optimize_code(code, uniformsize(code, 2), GreedyMethod())
    xs = [randn(3,3) for i=1:4]
    c2 = optimize_permute(code)
    @test code(xs...) ≈ c2(xs...)
end

@testset "save load" begin
    for code in [
        EinCode([[1,2], [2,3], [3,4]], [1,4]),
        EinCode([['a','b'], ['b','c'], ['c','d']], ['a','d'])
    ]
        for optcode in [optimize_code(code, uniformsize(code, 2), GreedyMethod()),
            optimize_code(code, uniformsize(code, 2), TreeSA(nslices=1))]
            filename = tempname()
            writejson(filename, optcode)
            code2 = readjson(filename)
            @test optcode == code2
        end
    end
end

using LuxorGraphPlot

@testset "visualization tool" begin
    eincode = ein"ab,acd,bcef,e,df->"
    nested_ein = optein"ab,acd,bcef,e,df->"

    graph_1 = viz_eins(eincode)
    @test graph_1 isa LuxorGraphPlot.Luxor.Drawing 

    graph_2 = viz_eins(nested_ein)
    @test graph_2 isa LuxorGraphPlot.Luxor.Drawing

    gif = viz_contraction(nested_ein, filename = tempname() * ".gif")
    @test gif isa String

    video = viz_contraction(nested_ein)
    @test video isa String
end

"""
    parse_nested(s::AbstractString (, iy = []))

return a contraction-tree consisting of `NestedEinsumConstructor`
objects as nodes and `IndexGroup` as leaves.
`s` should only contain the `ixs` part
"""

function parse_nested(s::AbstractString, iy = [])
    count(==('('),s) == count(==(')'),s) || throw(
        ArgumentError("Parentheses don't pair up in $s"))

    _, out = parse_parens(s, firstindex(s), 1)
    append!(out.iy, iy)
    filliys!(out)
    return construct(out)
end

"""
    parse_parens(s::AbstractString, i, narg)

parse one level of parens starting at index `i` where `narg` counts which tensor the
current group of indices, e.g. "ijk", belongs to.
Recursively calls itself for each new opening paren that's opened.
"""
function parse_parens(s::AbstractString, i, narg)
    out = NestedEinsumConstructor{Char}([], [], [])
    g = IndexGroup{Char}([],narg)

    while i <= lastindex(s)
        c = s[i]
        j = nextind(s,i)
        if c === '('
            # opening a parens means that next a new contraction is parsed
            j, out2, narg = parse_parens(s, j, narg)
            push!(out, out2)
            union!(out.inds, out2.inds)
        elseif c === ')' || c === ','
            # either closing a parens or a comma means that a tensors indices
            # are complete and can be added to the contraction-object
            if !isempty(g)
                push!(out, g)
                union!(out.inds, g.inds)
            end
            if  c === ','
                # comma implies that a new tensor is parsed for the current contraction
                narg += 1
                g = IndexGroup{Char}([], narg)
            else
                # parens implies that the current contraction is complete
                return j, out, narg
            end
        elseif isletter(c) # could allow isnumeric() too
            push!(g,c)
        else
            throw(ArgumentError("parsing $s failed, $c is not a valid entry"))
        end
        i = j
    end
    if !isempty(g)
        push!(out, g)
        union!(out.inds, g.inds)
    end
    return i, out
end

"""
    filliys!(neinsum::NestedEinsumConstructor)

goes through all `NestedEinsumConstructor` objects in the tree and saves the correct `iy` in them.
"""
function filliys!(neinsum)
    iy = neinsum.iy
    args = neinsum.args
    for i in 1:length(neinsum.args)
        arg = args[i]
        arg isa IndexGroup && continue
        union!(arg.iy, intersect(arg.inds, iy))
        for j in 1:length(neinsum.args)
            i === j && continue
            union!(arg.iy, intersect(arg.inds, args[j].inds))
        end
        filliys!(arg)
    end
    return neinsum
end

"""
    IndexGroup

Leaf in a contractiontree, contains the indices and the number of the tensor it
describes, e.g. in "ij,jk -> ik", indices "ik" belong to tensor `1`, so
would be described by IndexGroup(['i','k'], 1).
"""
struct IndexGroup{T}
    inds::Vector{T}
    n::Int
end

Base.push!(ig::IndexGroup, c) = (push!(ig.inds,c); ig)
Base.isempty(ig::IndexGroup) = isempty(ig.inds)

"""
    NestedEinsumConstructor

describes a (potentially) nested einsum. Important fields:
- `args`, vector of all inputs, either `IndexGroup` objects corresponding to tensors or `NestedEinsumConstructor`
- `iy`, indices of output
"""
struct NestedEinsumConstructor{T}
    args::Vector{Union{NestedEinsumConstructor{T}, IndexGroup{T}}}
    inds::Vector{T}
    iy::Vector{T}
end

Base.push!(neinsum::NestedEinsumConstructor, x) = (push!(neinsum.args,x); neinsum)

using MacroTools

function _nested_ein_macro(ex; einsum=:einsum)
    @capture(ex, (left_ := right_)) || throw(ArgumentError("expected A[] := B[]... "))
    @capture(left, Z_[leftind__] | [leftind__] ) || throw(
        ArgumentError("can't understand LHS, expected A[i,j] etc."))
    Z === nothing && @gensym Z
    primefix!(leftind)
    allinds = unique(leftind)

    MacroTools.postwalk(right) do x
        @capture(x, A_[inds__]) && union!(allinds, inds)
        x
    end
    primefix!(allinds)

    tensors = Symbol[]
    nein = parse_nested_expr(right, tensors, allinds)
    append!(nein.iy, indexin(leftind,allinds))
    filliys!(nein)
    snein = construct(nein)

    tensornames = map(esc, tensors)
    :($(esc(Z)) = $snein(($(tensornames...),)...))
end

function parse_nested_expr(expr, tensors, allinds)
    if @capture(expr, *(args__))
        einargs = map(x -> parse_nested_expr(x,tensors, allinds), args)
        intinds = union(mapreduce(x -> x.inds, vcat, einargs))
        return NestedEinsumConstructor{Int}(einargs, intinds, Int[])
    elseif @capture(expr, A_[inds__])
        push!(tensors,A)
        return IndexGroup{Int}(indexin(primefix!(inds), allinds), length(tensors))
    end
end

# the contraction tree
"""
    NestedEinsum{LT} <: AbstractEinsum

The abstract type for contraction trees. It has two subtypes, [`DynamicNestedEinsum`](@ref) and [`StaticNestedEinsum`](@ref).
"""
abstract type NestedEinsum{LT} <: AbstractEinsum end

"""
    DynamicNestedEinsum{LT} <: NestedEinsum{LT}
    DynamicNestedEinsum(args, eins)
    DynamicNestedEinsum{LT}(tensorindex::Int)

Einsum with contraction order, where the type parameter `LT` is the label type.
It has two constructors. One takes a `tensorindex` as input, which represents the leaf node in a contraction tree.
The other takes an iterable of type `DynamicNestedEinsum`, `args`, as the siblings, and `eins` to specify the contraction operation.
"""
struct DynamicNestedEinsum{LT} <: NestedEinsum{LT}
    args::Vector{DynamicNestedEinsum{LT}}
    tensorindex::Int  # -1 if not leaf
    eins::DynamicEinCode{LT}

    function DynamicNestedEinsum(args::Vector{DynamicNestedEinsum{LT}}, eins::DynamicEinCode{LT}) where LT
        @assert length(args) == length(getixsv(eins))
        new{LT}(args, -1, eins)
    end
    DynamicNestedEinsum{LT}(arg::Int) where LT = new{LT}(NestedEinsum{LT}[], arg)
end
function DynamicNestedEinsum(args, eins::DynamicEinCode{LT}) where LT
    DynamicNestedEinsum(collect(DynamicNestedEinsum{LT}, args), eins)
end
isleaf(ne::DynamicNestedEinsum) = ne.tensorindex != -1
siblings(ne::DynamicNestedEinsum) = ne.args
tensorindex(ne::DynamicNestedEinsum) = ne.tensorindex
rootcode(ne::DynamicNestedEinsum) = ne.eins

"""
    StaticNestedEinsum{LT,args,eins} <: NestedEinsum{LT}
    StaticNestedEinsum(args, eins)
    StaticNestedEinsum{LT}(tensorindex::Int)

Einsum with contraction order, where the type parameter `LT` is the label type,
`args` is a tuple of StaticNestedEinsum, `eins` is a `StaticEinCode` and leaf node is defined by setting `eins` to an integer.
It has two constructors. One takes a `tensorindex` as input, which represents the leaf node in a contraction tree.
The other takes an iterable of type `DynamicNestedEinsum`, `args`, as the siblings, and `eins` to specify the contraction operation.
"""
struct StaticNestedEinsum{LT,args,eins} <: NestedEinsum{LT}
    function StaticNestedEinsum(args::NTuple{N,StaticNestedEinsum{LT}}, eins::StaticEinCode{LT}) where {N,LT}
        @assert length(args) == length(getixs(eins))
        new{LT,args,eins}()
    end
    function StaticNestedEinsum{LT}(tensorindex::Int) where {LT}
        new{LT,(),tensorindex}()
    end
end
isleaf(::StaticNestedEinsum{LT,args,eins}) where {LT,args,eins} = eins isa Int
siblings(::StaticNestedEinsum{LT,args}) where {LT,args} = args
tensorindex(ne::StaticNestedEinsum{LT,args,eins}) where {LT,args,eins} = (@assert isleaf(ne); eins)
rootcode(::StaticNestedEinsum{LT,args,eins}) where {LT,args,eins} = eins

function Base.:(==)(a::NestedEinsum, b::NestedEinsum)
    siba, sibb = siblings(a), siblings(b)
    (isleaf(a) != isleaf(b) || length(siba) != length(sibb)) && return false
    ex = if isleaf(a)
        tensorindex(a) == tensorindex(b)
    else
        rootcode(a) == rootcode(b)
    end
    return ex && all(i->siba[i] == sibb[i], 1:length(siba))
end

# conversion
function StaticNestedEinsum(ne::DynamicNestedEinsum{LT}) where LT
    if isleaf(ne)
        StaticNestedEinsum{LT}(tensorindex(ne))
    else
        sib = siblings(ne)
        StaticNestedEinsum(ntuple(i->StaticNestedEinsum(sib[i]),length(sib)), StaticEinCode(rootcode(ne)))
    end
end
function DynamicNestedEinsum(ne::StaticNestedEinsum{LT}) where LT
    if isleaf(ne)
        DynamicNestedEinsum{LT}(tensorindex(ne))
    else
        DynamicNestedEinsum([DynamicNestedEinsum(s) for s in siblings(ne)], DynamicEinCode(rootcode(ne)))
    end
end
function NestedEinsum(args, eins::EinCode)
    eins isa DynamicEinCode ? DynamicNestedEinsum(args, eins) : StaticNestedEinsum(args, eins)
end

function construct(nein::NestedEinsumConstructor{T}) where T
    ixs = Tuple(map(extractixs, nein.args))
    iy = Tuple(nein.iy)
    eins = StaticEinCode{T,ixs,iy}()
    args = Tuple(map(x -> x isa NestedEinsumConstructor ? construct(x) : StaticNestedEinsum{T}(x.n), nein.args))
    return StaticNestedEinsum(args, eins)
end
extractixs(x::IndexGroup) = Tuple(x.inds)
extractixs(x::NestedEinsumConstructor) = Tuple(x.iy)

# For CuArrays, kwargs can be [`active_free`].
function (neinsum::NestedEinsum{LT})(@nospecialize(xs::AbstractArray...); size_info = nothing, kwargs...) where LT
    size_dict = size_info===nothing ? Dict{LT,Int}() : copy(size_info)
    get_size_dict!(neinsum, xs, size_dict)
    return einsum(neinsum, xs, size_dict; kwargs...)
end

function get_size_dict!(ne::NestedEinsum, @nospecialize(xs), size_info::Dict{LT}) where LT
    d = collect_ixs!(ne, Dict{Int,Vector{LT}}())
    ks = sort!(collect(keys(d)))
    ixs = [d[i] for i in ks]
    return get_size_dict_!(ixs, [collect(Int, size(xs[i])) for i in ks], size_info)
end

function einsum!(neinsum::NestedEinsum, @nospecialize(xs::NTuple{N,AbstractArray} where N), y, sx, sy, size_dict::Dict)
    # do not use map because the static overhead is too large
    # do not use `setindex!` because we need to make the AD work
    mxs = Vector{AbstractArray}(undef, length(siblings(neinsum)))
    for (i, arg) in enumerate(siblings(neinsum))
        mxs = _safe_set(mxs, i, isleaf(arg) ? xs[tensorindex(arg)] : einsum!(arg, xs, similar(y, ([size_dict[l] for l in getiy(rootcode(arg))]...,)), true, false, size_dict))
    end
    return einsum!(rootcode(neinsum), (mxs...,), y, sx, sy, size_dict)
end
function einsum(neinsum::NestedEinsum, @nospecialize(xs::NTuple{N,AbstractArray} where N), size_dict::Dict)
    # do not use map because the static overhead is too large
    # do not use `setindex!` because we need to make the AD work
    mxs = Vector{AbstractArray}(undef, length(siblings(neinsum)))
    for (i, arg) in enumerate(siblings(neinsum))
        mxs = _safe_set(mxs, i, isleaf(arg) ? xs[tensorindex(arg)] : einsum(arg, xs, size_dict))
    end
    return einsum(rootcode(neinsum), (mxs...,), size_dict)
end

_safe_set(lst, i, y) = (lst[i] = y; lst)

# Better printing
struct LeafString
    str::String
end
function AbstractTrees.children(ne::NestedEinsum)
    [isleaf(item) ? LeafString(_join(getixs(rootcode(ne))[k])) : item for (k,item) in enumerate(siblings(ne))]
end

AbstractTrees.printnode(io::IO, e::LeafString) = print(io, e.str)
function AbstractTrees.printnode(io::IO, x::NestedEinsum)
    isleaf(x) ? print(io, tensorindex(x)) : print(io, rootcode(x))
end

function Base.show(io::IO, e::EinCode)
    s = join([_join(ix) for ix in getixs(e)], ", ") * " -> " * _join(getiy(e))
    print(io, s)
end
function Base.show(io::IO, e::NestedEinsum)
    print_tree(io, e)
end
Base.show(io::IO, ::MIME"text/plain", e::NestedEinsum) = show(io, e)
Base.show(io::IO, ::MIME"text/plain", e::EinCode) = show(io, e)
_join(ix) = isempty(ix) ? "" : join(ix, connector(eltype(ix)))
connector(::Type{Char}) = ""
connector(::Type{Int}) = "∘"
connector(::Type) = "-"

# flatten nested einsum
function _flatten(code::NestedEinsum, iy=nothing)
    isleaf(code) && return [tensorindex(code)=>iy]
    sibs = siblings(code)
    ixs = []
    for i=1:length(sibs)
        append!(ixs, _flatten(sibs[i], getixs(rootcode(code))[i]))
    end
    return ixs
end

flatten(code::EinCode) = code
function flatten(code::DynamicNestedEinsum{LT}) where LT
    ixd = Dict(_flatten(code))
    DynamicEinCode([ixd[i] for i=1:length(ixd)], collect(getiy(code.eins)))
end
function flatten(code::StaticNestedEinsum{LT}) where LT
    ixd = Dict(_flatten(code))
    StaticEinCode{LT,ntuple(i->(ixd[i]...,), length(ixd)), getiy(rootcode(code))}()
end

labeltype(::NestedEinsum{LT}) where LT = LT
function getixsv(ne::NestedEinsum{LT}) where LT
    if isleaf(ne)
        error("Can not call `getiyv` on leaf nodes!")
    end
    d = collect_ixs!(ne, Dict{Int,Vector{LT}}())
    ks = sort!(collect(keys(d)))
    return @inbounds [d[i] for i in ks]
end
function collect_ixs!(ne::NestedEinsum, d::Dict{Int,Vector{LT}}) where LT
    args = siblings(ne)
    @inbounds for i=1:length(args)
        arg = args[i]
        if isleaf(arg)
            d[tensorindex(arg)] = _collect(LT, getixs(rootcode(ne))[i])
        else
            collect_ixs!(arg, d)
        end
    end
    return d
end
function getiyv(ne::NestedEinsum{LT}) where LT
    if isleaf(ne)
        error("Can not call `getiyv` on leaf nodes!")
    end
    getiyv(rootcode(ne))
end

function Base.replace(ne::NestedEinsum, pairs::Pair...)
    if isleaf(ne)
        settensorindex(ne, replace([tensorindex(ne)], pairs...)[])
    else
        NestedEinsum(map(arg->replace(arg, pairs...), siblings(ne)), replace(rootcode(ne), pairs...))
    end
end
settensorindex(::DynamicNestedEinsum{LT}, idx::Int) where LT = DynamicNestedEinsum{LT}(idx)
settensorindex(::StaticNestedEinsum{LT}, idx::Int) where LT = StaticNestedEinsum{LT}(idx)

using OMEinsum
using Test
using LinearAlgebra
using CUDA
import Documenter


@testset "Core" begin
    include("Core.jl")
end

@testset "match rule" begin
    include("matchrule.jl")
end

@testset "unary rules" begin
    include("unaryrules.jl")
end

@testset "binary rules" begin
    include("binaryrules.jl")
end

@testset "utils" begin
    include("utils.jl")
end

@testset "einsum" begin
    include("einsum.jl")
end

@testset "cuda" begin
    if CUDA.functional()
        include("cueinsum.jl")
    end
end

@testset "autodiff" begin
    include("autodiff.jl")
end

@testset "einsequence" begin
    include("einsequence.jl")
end

@testset "slicing" begin
    include("slicing.jl")
end

@testset "interfaces" begin
    include("interfaces.jl")
end

@testset "contraction order" begin
    include("contractionorder.jl")
end

@testset "back propagation" begin
    include("bp.jl")
end

@testset "docstring" begin
    Documenter.doctest(OMEinsum; manual=false)
end

using BenchmarkTools, OMEinsum, CUDA
CUDA.allowscalar(false)

a = randn(Float32, 50, 50)
@benchmark ein"ij,jk->ik"($a,$a) seconds = 1
@benchmark ein"ij,ik,il->jkl"($a,$a,$a) seconds = 1
@benchmark a*a seconds = 1

a = a |> CuArray
y = y |> CuArray
@benchmark ein"ij,jk->ik"($a,$a) seconds = 1
@benchmark ein"ij,ik,il->jkl"($a,$a,$a) seconds = 1
@benchmark a*a seconds = 1

using Test
using OMEinsum
using CUDA, cuTENSOR
using DoubleFloats
using Zygote

CUDA.allowscalar(false)

@static if pkgversion(cuTENSOR) >= v"6"
    const cutensor_available = cuTENSOR.functional()
else
    const cutensor_available = cuTENSOR.has_cutensor()
end

@testset "loop einsum" begin
    a = [randn(fill(3, i)...) for i=1:4]
    ca = a .|> CuArray
    ixs = ((1,2), (2,3))
    xs = (ca[2], ca[2])
    @test loop_einsum!(ixs, (1,3), xs, zeros(3,3) |> CuArray, true, false, OMEinsum.get_size_dict(ixs, xs)) |> Array ≈ a[2]*a[2]
    @test loop_einsum!(ixs, (1,3), xs, ones(3,3) |> CuArray, 4.0, 2.0, OMEinsum.get_size_dict(ixs, xs)) |> Array ≈ 4.0 * a[2]*a[2] + 2 * ones(3, 3)
    res = 4.0 * a[2]*a[2]
    out = 2 * ones(3, 3, 3)
    for k = 1:3
        out[:,k,k] .+= res[:,k]
    end
    @test loop_einsum!(ixs, (1,3,3), xs, ones(3,3,3) |> CuArray, 4.0, 2.0, OMEinsum.get_size_dict(ixs, xs)) |> Array ≈ out
end

@testset "cuda einsum" begin
    a = [randn(fill(3, i)...) for i=1:4]
    ca = a .|> CuArray
    ixs = ((1,2), (2,3))
    xs = (ca[2], ca[2])
    @test loop_einsum!(ixs, (1,3), xs, zeros(3,3) |> CuArray, true, false, OMEinsum.get_size_dict(ixs, xs)) ≈ ca[2]*ca[2]
    for f in [ein"ij,jk->ik", ein"ii->", ein"ijj ->i", ein"ij,ik,il->jkl", ein"ii->i", ein"ijl->i", ein"i->ii", ein"ij,jk,kl->il", ein"ij,ij,ij -> ij"]
        cins = map(ix->ca[length(ix)], OMEinsum.getixs(f))
        ins = map(ix->a[length(ix)], OMEinsum.getixs(f))
        @test f(cins...) isa DenseCuArray
        @test loop_einsum(f, cins, OMEinsum.get_size_dict(OMEinsum.getixs(f), cins)) |> Array ≈ f(ins...)
        @test f(ins...) ≈ Array(f(cins...))
    end
end

@testset "fallback - getindex IR error" begin
    a = rand(ComplexF64,2,2,2)
    ca = CuArray(a);
    @test Array(ein"npu,por,dom,lmn -> urdl"(ca,ca,ca,ca)) ≈ ein"npu,por,dom,lmn -> urdl"(a,a,a,a)
end

@testset "isbatchmul" begin
    for (ixs, iy) in [(((1,2), (2,3)), (1,3)), (((1,2,3), (2,3)), (1,3)),
                        (((7,1,2,3), (2,4,3,7)), (1,4,3)),
                        (((3,), (3,)), (3,)), (((3,1), (3,)), (3,1))
                        ]
        xs = ([randn(ComplexF64, fill(4,length(ix))...) |> CuArray for ix in ixs]...,)
        @test EinCode(ixs, iy)(xs...) |> Array ≈ loop_einsum(EinCode(ixs, iy), xs, OMEinsum.get_size_dict(ixs, xs)) |> Array
    end
end


@testset "doublefloats" begin
    D = 2
    T = CuArray(rand(Double64, D, D, D, D, D, D))
    U = CuArray(rand(Double64, D, D, D))

    code = ein"abewcd,bfixgh,ajeycd,jfizgh->wxyz"
    xs = (T,T,T,T)
    M = code(xs...)
    @test M |> Array ≈ loop_einsum(code, xs, OMEinsum.get_size_dict(OMEinsum.getixs(code), xs)) |> Array

    code = ein"(ubcdef,fjz),dhx,(bvghij,eiy),cgw->uvwxyz"
    _code = ein"ubcdef,fjz,dhx,bvghij,eiy,cgw->uvwxyz"
    xs = (T,U,U,T,U,U)
    M = code(xs...)
    # mapreducedim! calls to dynamic tuple splatting.
    @test M |> Array ≈ loop_einsum(_code, xs, OMEinsum.get_size_dict(OMEinsum.getixs(_code), xs)) |> Array
end

@testset "unary einsum rules" begin
    for code in [
            ein"ij->",  # sum
            ein"ij->j", # sum
            ein"ii->",  # tr
            ein"ii->i",  # diag
            ein"ijk->kij",   # permutedims
            ein"a->aaaa",   # ~diag
            ein"ac->acc",   # ~diag
            ein"->ii",   # ~tr
            ein"i->ik",   # ~sum
            ein"->ik",   # ~sum
            ein"illljkk->kijjcc",   # general
        ]
        @info code
        D = 2
        xs = [length(ix)==0 ? CUDA.fill(1.2) : CUDA.rand(Float64, fill(D, length(ix))...) for ix in OMEinsum.getixs(code)]
        size_dict = Dict(zip(('a', 'b', 'c', 'd', 'e', 'f','i','j','k','l'), ntuple(x->D, 10)))
        res = einsum(code, (xs...,), size_dict)
        @test Array(res) ≈ loop_einsum(code, (Array.(xs)...,), size_dict)
        @test Array(res) ≈ Array(loop_einsum(code, (xs...,), size_dict))
    end
end

@testset "binary einsum rules" begin
    codes = [
            # binary
            ein",->",
            ein"i,->i",
            ein"j,j->",
            ein",k->k",
            ein"j,jk->k",
            ein"j,kj->k",
            ein"ij,j->i",
            ein"ji,j->i",
            ein"i,k->ik",
            ein"i,k->ki",
    ]

    for (i1, X1) in enumerate([('i', 'j'), ('j', 'i')])
        for (i2, X2) in enumerate([('j', 'k'), ('k', 'j')])
            for (i3, X3) in enumerate([('i', 'k'), ('k', 'i')])
                push!(codes, OMEinsum.StaticEinCode{Char, (X1,X2),X3}())
            end
        end
    end
    for code in copy(codes)
        X1, X2 = OMEinsum.getixs(code)
        X3 = OMEinsum.getiy(code)
        push!(codes, OMEinsum.StaticEinCode{Char, ((X1...,'l'),(X2...,'l')),(X3...,'l')}())
    end

    for code in codes
        @info code
        D = 2
        xs = [length(ix)==0 ? CUDA.fill(1.2) : CUDA.rand(Float64, fill(D, length(ix))...) for ix in OMEinsum.getixs(code)]
        size_dict = Dict(zip(('a', 'b', 'c', 'd', 'e', 'f','i','j','k','l'), ntuple(x->D, 10)))
        res = einsum(code, (xs...,), size_dict)
        @test Array(res) ≈ loop_einsum(code, (Array.(xs)...,), size_dict)
        @test Array(res) ≈ Array(loop_einsum(code, (xs...,), size_dict))
    end
end

@testset "composite einsum" begin
    for code in [
            ein"abb,bc->ac",  # with diag in
            ein"ab,bc->acc",  # with diag out
            ein"ab,bce->ac",  # with sum in
            ein"ab,bc->ace",  # with sum out
            ein"bal,bcl->lcae",  # with perm in
            ein"bal,bcl->ca",  # with multi-edge in
            ein"bal,bc->lca",  # with multi-edge out
            ein"ddebal,bcf->lcac",  # with all
        ]
        @info code
        D = 2
        xs = [length(ix)==0 ? CUDA.fill(1.2) : CUDA.rand(Float64, fill(D, length(ix))...) for ix in OMEinsum.getixs(code)]
        size_dict = Dict(zip(('a', 'b', 'c', 'd', 'e', 'f','i','j','k','l'), ntuple(x->D, 10)))
        res = einsum(code, (xs...,), size_dict)
        @test Array(res) ≈ loop_einsum(code, (Array.(xs)...,), size_dict)
        @test Array(res) ≈ Array(loop_einsum(code, (xs...,), size_dict))
    end
end

@testset "permutedims for high dimensional tensors" begin
    c = CUDA.rand(4, [rand(1:3) for _ = 2:18]...);
    @test Array(permutedims(c, 18:-1:1)) ≈ permutedims(Array(c), 18:-1:1)
end

@testset "gradient type check - CUDA" begin
    array_match(x, y) = typeof(x) == typeof(y) && size(x) == size(y)
    a = CUDA.randn(3,3)
    b = CUDA.randn(3,3)
    @test array_match(gradient(a->Array(einsum(EinCode(((1,2), (2,1)), ()), (a, b)))[] |> abs, a)[1], a)
    b = CUDA.randn(ComplexF64,3,3)
    @test array_match(gradient(a->Array(einsum(EinCode(((1,2), (2,1)), ()), (a, b)))[] |> abs, a)[1], a)
    a = CUDA.randn(ComplexF64,3,3)
    @test array_match(gradient(a->Array(einsum(EinCode(((1,2), (2,3)), ()), (a, b)))[] |> abs, a)[1], a)
    b = CUDA.randn(3,3)
    @test array_match(gradient(a->Array(einsum(EinCode(((1,2), (2,3)), ()), (a, b)))[] |> abs, a)[1], a)
end

@testset "adjoint dispatch" begin
    u = CUDA.rand(2,2); A = CUDA.rand(2,2,2);
    @test Array(ein"(ip,pql),qj -> ijl"(u', A, u)) ≈ ein"(ip,pql),qj -> ijl"(Array(CuArray(u')), Array(A), Array(u))
    @test Array(DynamicEinCode(ein"mk, ijk -> ijm")(u', A)) ≈ DynamicEinCode(ein"mk, ijk -> ijm")(Array(u'), Array(A))
    @test Array(ein"mk, ijk -> ijm"(u', A)) ≈ DynamicEinCode(ein"mk, ijk -> ijm")(Array(u'), Array(A))
end

#####################################################################
# cuTENSOR Backend Tests
#####################################################################

@testset "cuTENSOR backend - availability check" begin
    # Test backend API
    @test get_einsum_backend() isa DefaultBackend
    set_einsum_backend!(CuTensorBackend())
    @test get_einsum_backend() isa CuTensorBackend
    set_einsum_backend!(DefaultBackend())
    @test get_einsum_backend() isa DefaultBackend
end

@testset "cuTENSOR backend - binary contractions" begin
    # Skip if cuTENSOR is not available
    if cutensor_available
        @info "Testing cuTENSOR backend (cuTENSOR available)"
        
        # Test with cuTENSOR backend
        set_einsum_backend!(CuTensorBackend())
        
        # Test different data types
        for T in [Float32, Float64, ComplexF32, ComplexF64]
            @testset "cuTENSOR $T" begin
                D = 10
                
                # Matrix multiplication: ij,jk->ik
                A = CUDA.rand(T, D, D+5)
                B = CUDA.rand(T, D+5, D+3)
                C_cutensor = ein"ij,jk->ik"(A, B)
                
                # Compare with CPU result
                A_cpu, B_cpu = Array(A), Array(B)
                C_cpu = ein"ij,jk->ik"(A_cpu, B_cpu)
                @test Array(C_cutensor) ≈ C_cpu
                
                # Batched matrix multiplication: ijl,jkl->ikl
                A = CUDA.rand(T, D, D+2, 3)
                B = CUDA.rand(T, D+2, D+1, 3)
                C_cutensor = ein"ijl,jkl->ikl"(A, B)
                C_cpu = ein"ijl,jkl->ikl"(Array(A), Array(B))
                @test Array(C_cutensor) ≈ C_cpu
                
                # Trace contraction: ij,ji->
                A = CUDA.rand(T, D, D)
                B = CUDA.rand(T, D, D)
                C_cutensor = ein"ij,ji->"(A, B)
                C_cpu = ein"ij,ji->"(Array(A), Array(B))
                @test Array(C_cutensor)[] ≈ C_cpu[]
                
                # Outer product: i,j->ij
                A = CUDA.rand(T, D)
                B = CUDA.rand(T, D+2)
                C_cutensor = ein"i,j->ij"(A, B)
                C_cpu = ein"i,j->ij"(Array(A), Array(B))
                @test Array(C_cutensor) ≈ C_cpu
                
                # General contraction: ijk,jkl->il
                A = CUDA.rand(T, 5, 6, 7)
                B = CUDA.rand(T, 6, 7, 8)
                C_cutensor = ein"ijk,jkl->il"(A, B)
                C_cpu = ein"ijk,jkl->il"(Array(A), Array(B))
                @test Array(C_cutensor) ≈ C_cpu
                
                # Transposed output: ij,jk->ki
                A = CUDA.rand(T, D, D+2)
                B = CUDA.rand(T, D+2, D+3)
                C_cutensor = ein"ij,jk->ki"(A, B)
                C_cpu = ein"ij,jk->ki"(Array(A), Array(B))
                @test Array(C_cutensor) ≈ C_cpu
            end
        end
        
        # Reset backend
        set_einsum_backend!(DefaultBackend())
    else
        @info "Skipping cuTENSOR tests (cuTENSOR not available)"
        @test_skip "cuTENSOR not available"
    end
end

@testset "cuTENSOR backend - comparison with DefaultBackend" begin
    if cutensor_available
        @info "Comparing cuTENSOR vs DefaultBackend results"
        
        for T in [Float32, Float64]
            @testset "Comparison $T" begin
                D = 32
                
                # Test various contraction patterns
                test_cases = [
                    (ein"ij,jk->ik", (D, D+5), (D+5, D+3)),           # matmul
                    (ein"ijk,jkl->il", (8, 10, 12), (10, 12, 14)),    # tensor contraction
                    (ein"ijl,jkl->ikl", (8, 10, 5), (10, 12, 5)),     # batched
                    (ein"ij,kj->ik", (D, D+2), (D+3, D+2)),           # transposed B
                    (ein"ji,jk->ik", (D+2, D), (D+2, D+3)),           # transposed A
                ]
                
                for (code, size1, size2) in test_cases
                    A = CUDA.rand(T, size1...)
                    B = CUDA.rand(T, size2...)
                    
                    # DefaultBackend result
                    set_einsum_backend!(DefaultBackend())
                    C_default = code(A, B)
                    
                    # CuTensorBackend result
                    set_einsum_backend!(CuTensorBackend())
                    C_cutensor = code(A, B)
                    
                    @test Array(C_cutensor) ≈ Array(C_default) rtol=1e-5
                end
            end
        end
        
        set_einsum_backend!(DefaultBackend())
    else
        @test_skip "cuTENSOR not available"
    end
end

@testset "cuTENSOR backend - scaling factors" begin
    if cutensor_available
        set_einsum_backend!(CuTensorBackend())
        
        D = 16
        A = CUDA.rand(Float64, D, D)
        B = CUDA.rand(Float64, D, D)
        C = CUDA.rand(Float64, D, D)
        
        code = EinCode((('i','j'),('j','k')),('i','k'))
        
        # Test with sx=2.0, sy=0.5
        C_result = copy(C)
        einsum!(code, (A, B), C_result, 2.0, 0.5)
        
        A_cpu, B_cpu, C_cpu = Array(A), Array(B), Array(C)
        C_expected = 2.0 * (A_cpu * B_cpu) + 0.5 * C_cpu
        
        @test Array(C_result) ≈ C_expected rtol=1e-10
        
        set_einsum_backend!(DefaultBackend())
    else
        @test_skip "cuTENSOR not available"
    end
end

@testset "cuTENSOR backend - nested einsum" begin
    if cutensor_available
        set_einsum_backend!(CuTensorBackend())
        
        # Test nested contraction
        D = 8
        A = CUDA.rand(Float32, D, D)
        B = CUDA.rand(Float32, D, D)
        C = CUDA.rand(Float32, D, D)
        
        code = ein"(ij,jk),kl->il"
        result_cutensor = code(A, B, C)
        
        # Compare with CPU
        result_cpu = code(Array(A), Array(B), Array(C))
        @test Array(result_cutensor) ≈ result_cpu rtol=1e-4
        
        set_einsum_backend!(DefaultBackend())
    else
        @test_skip "cuTENSOR not available"
    end
end

@testset "cuTENSOR backend - Float16" begin
    if cutensor_available
        set_einsum_backend!(CuTensorBackend())
        
        D = 32
        A = CUDA.rand(Float16, D, D)
        B = CUDA.rand(Float16, D, D)
        
        C_cutensor = ein"ij,jk->ik"(A, B)
        
        # Compare with Float32 computation for accuracy reference
        A32 = Float32.(Array(A))
        B32 = Float32.(Array(B))
        C_ref = ein"ij,jk->ik"(A32, B32)
        
        @test Float32.(Array(C_cutensor)) ≈ C_ref rtol=1e-2
        
        set_einsum_backend!(DefaultBackend())
    else
        @test_skip "cuTENSOR not available"
    end
end

using OMEinsum
using cuTENSOR, cuTENSOR.CUDA
using BenchmarkTools
using Printf

# Benchmark configuration
BenchmarkTools.DEFAULT_PARAMETERS.samples = 100
BenchmarkTools.DEFAULT_PARAMETERS.seconds = 5

"""
Run benchmark for a specific einsum code and tensor sizes.
"""
function benchmark_einsum(code, sizes, T::Type; warmup=true)
    # Create input tensors
    xs = Tuple(CUDA.rand(T, s...) for s in sizes)
    
    results = Dict{String, Any}()
    
    # Warmup
    if warmup
        code(xs...)
        CUDA.synchronize()
    end
    
    # DefaultBackend (CUBLAS)
    set_einsum_backend!(DefaultBackend())
    CUDA.synchronize()
    
    default_bench = @benchmark begin
        $code($xs...)
        CUDA.synchronize()
    end
    results["default"] = default_bench
    
    # CuTensorBackend
    set_einsum_backend!(CuTensorBackend())
    CUDA.synchronize()
    
    cutensor_bench = @benchmark begin
        $code($xs...)
        CUDA.synchronize()
    end
    results["cutensor"] = cutensor_bench

    # Reset to default
    set_einsum_backend!(DefaultBackend())

    return results
end

"""
Format benchmark results for display.
"""
function format_result(bench)
    med = median(bench)
    return @sprintf("%.3f ms (±%.3f)", med.time/1e6, std(bench.times)/1e6)
end

"""
Print benchmark comparison table.
"""
function print_comparison(name, results)
    default_med = median(results["default"]).time
    
    print(@sprintf("%-40s", name))
    print(@sprintf(" | %-20s", format_result(results["default"])))
    
    if haskey(results, "cutensor")
        cutensor_med = median(results["cutensor"]).time
        speedup = default_med / cutensor_med
        print(@sprintf(" | %-20s", format_result(results["cutensor"])))
        print(@sprintf(" | %.2fx", speedup))
    else
        print(" | N/A                  | N/A")
    end
    println()
end

# ============================================================================
# Benchmark Suite
# ============================================================================

function run_benchmarks()
    println("=" ^ 100)
    println("cuTENSOR vs CUBLAS Benchmark")
    println("=" ^ 100)
    println()
    
    # GPU Info
    println("GPU: ", CUDA.name(CUDA.device()))
    println("CUDA: ", CUDA.runtime_version())
    println("cuTENSOR: ", cuTENSOR.version())
    println()
    
    for T in [Float32, Float64]
        println("-" ^ 100)
        println("Data Type: $T")
        println("-" ^ 100)
        println(@sprintf("%-40s | %-20s | %-20s | %s", "Operation", "CUBLAS", "cuTENSOR", "Speedup"))
        println("-" ^ 100)
        
        # 1. Matrix multiplication (GEMM-like)
        for n in [128, 256, 512, 1024, 2048]
            name = "matmul ($n×$n)"
            results = benchmark_einsum(ein"ij,jk->ik", [(n, n), (n, n)], T)
            print_comparison(name, results)
        end
        println()
        
        # 2. Rectangular matrix multiplication
        results = benchmark_einsum(ein"ij,jk->ik", [(512, 1024), (1024, 768)], T)
        print_comparison("matmul (512×1024, 1024×768)", results)
        println()
        
        # 3. Batched matrix multiplication
        for (m, n, k, b) in [(64, 64, 64, 32), (128, 128, 128, 16), (256, 256, 256, 8)]
            name = "batched_matmul ($m×$n×$k, batch=$b)"
            results = benchmark_einsum(ein"ijl,jkl->ikl", [(m, n, b), (n, k, b)], T)
            print_comparison(name, results)
        end
        println()
        
        # 4. Tensor contraction (non-GEMM patterns)
        # These are where cuTENSOR should shine vs CUBLAS (which needs reshape/permute)
        
        # 4a. ijk,jkl->il (contract middle two indices)
        for d in [16, 32, 64]
            name = "contract ijk,jkl->il ($(d)³)"
            results = benchmark_einsum(ein"ijk,jkl->il", [(d, d, d), (d, d, d)], T)
            print_comparison(name, results)
        end
        println()
        
        # 4b. ijkl,klmn->ijmn (contract k,l)
        for d in [8, 16, 24]
            name = "4D contract ijkl,klmn->ijmn ($d⁴)"
            results = benchmark_einsum(ein"ijkl,klmn->ijmn", [(d, d, d, d), (d, d, d, d)], T)
            print_comparison(name, results)
        end
        println()
        
        # 4c. Trace-like contraction: ij,ji->
        for n in [256, 512, 1024, 2048]
            name = "trace ij,ji-> ($n×$n)"
            results = benchmark_einsum(ein"ij,ji->", [(n, n), (n, n)], T)
            print_comparison(name, results)
        end
        println()
        
        # 4d. Outer product: i,j->ij
        for n in [1024, 2048, 4096]
            name = "outer i,j->ij ($n)"
            results = benchmark_einsum(ein"i,j->ij", [(n,), (n,)], T)
            print_comparison(name, results)
        end
        println()
        
        # 5. More complex patterns (tensor network style)
        # 5a. Typical MPS-style contraction
        D, d = 64, 4  # bond dimension, physical dimension
        name = "MPS-style aib,bjc->aijc (D=$D, d=$d)"
        results = benchmark_einsum(ein"aib,bjc->aijc", [(D, d, D), (D, d, D)], T)
        print_comparison(name, results)
        
        # 5b. PEPS-style contraction
        D = 16
        name = "PEPS-style ijab,jkbc->ikac (D=$D)"
        results = benchmark_einsum(ein"ijab,jkbc->ikac", [(D, D, D, D), (D, D, D, D)], T)
        print_comparison(name, results)
        
        println()
    end
    
    println("=" ^ 100)
    println("Benchmark complete!")
end

# Run benchmarks
run_benchmarks()

using OMEinsum, Test
using OMEinsum: unary_einsum!, Duplicate, Sum, Tr, Permutedims, Repeat, Diag, Identity
using SymEngine: Basic

@testset "Duplicate" begin
    ix = (1,2,3)
    iy = (3,2,1,1,2)
    size_dict = Dict(1=>3,2=>3,3=>3)
    x = randn(3,3,3)
    y = randn(3,3,3,3,3)
    @test OMEinsum.duplicate!(y, x, ix, iy, true, false) ≈ OMEinsum.loop_einsum(EinCode((ix,),iy), (x,), size_dict)
    @test unary_einsum!(Duplicate(), ix, iy, x, y, true, false) ≈ OMEinsum.loop_einsum(EinCode((ix,),iy), (x,), size_dict)
end

@testset "Diag" begin
    ix = (3,2,1,1,2)
    iy = (1,2,3)
    size_dict = Dict(1=>3,2=>3,3=>3)
    x = randn(3,3,3,3,3)
    y = randn(3,3,3)
    @test unary_einsum!(Diag(), ix, iy, x, copy(y), true, false) ≈ OMEinsum.loop_einsum(EinCode((ix,),iy), (x,), size_dict)
    @test unary_einsum!(Diag(), ix, iy, x, copy(y), 2.0, 0.0) ≈ 2* OMEinsum.loop_einsum(EinCode((ix,),iy), (x,), size_dict)
    @test unary_einsum!(Diag(), ix, iy, x, copy(y), 1.0, 2.0) ≈ OMEinsum.loop_einsum(EinCode((ix,),iy), (x,), size_dict) + 2y
    @test unary_einsum!(Diag(), ix, iy, x, copy(y), 2.0, 3.0) ≈ 2 * OMEinsum.loop_einsum(EinCode((ix,),iy), (x,), size_dict) + 3y
end

@testset "Repeat" begin
    ix = (1,2,3)
    iy = (3,4,2,1)
    size_dict = Dict(1=>3,2=>3,3=>3,4=>5)
    x = randn(3,3,3)
    y = randn(3,5,3,3)
    @test unary_einsum!(Repeat(), ix, iy, x, y, true, false) ≈ OMEinsum.loop_einsum(EinCode((ix,),iy), (x,), size_dict)
end

@testset "Tr" begin
    a = rand(5,5)
    @test unary_einsum!(Tr(), (1,1),(), a, fill(1.0), true, false)[] ≈ sum(a[i,i] for i in 1:5)
    a = Basic.(rand(5,5))
    @test isapprox(unary_einsum!(Tr(), (1,1),(), a, fill(Basic(0)), 1, 0)[], sum(a[i,i] for i in 1:5), rtol=1e-8)
end

@testset "Permutedims" begin
    a = rand(5,5,3)
    @test unary_einsum!(Permutedims(), (1,2,3), (2,3,1), a, zeros(5, 3, 5), true, false) ≈ permutedims(a, (2,3,1))
end

@testset "Identity" begin
    a = rand(5,5,3)
    @test unary_einsum!(Identity(), (1,2,3), (1,2,3), a, ones(5, 5, 3), 2.0, 3.0) ≈ 3 .+ 2a
end

@testset "Sum" begin
    # index-sum
    a = rand(2,2,5)
    @test unary_einsum!(Sum(), (1, 2, 3), (1,2), a, zeros(2, 2), true, false) ≈ sum(a, dims=3)
    a = Basic.(rand(1:100, 2,2,5))
    @test unary_einsum!(Sum(), (1, 2, 3) ,(1,2), a, zeros(Basic, 2, 2), 1, 0) == dropdims(sum(a; dims=3); dims=3)
end

using OMEinsum, LightGraphs, BenchmarkTools
using OMEinsum: getixs, getiy

function uniformsize(code::EinCode, size::Int)
    Dict([c=>size for c in [OMEinsum.flatten(getixs(code))..., getiy(code)...]])
end
uniformsize(ne::OMEinsum.NestedEinsum, size::Int) = uniformsize(OMEinsum.flatten(ne), size)

function random_regular_eincode(n, k)
	g = LightGraphs.random_regular_graph(n, k)
	ixs = [minmax(e.src,e.dst) for e in LightGraphs.edges(g)]
	code = EinCode((ixs..., [(i,) for i in LightGraphs.vertices(g)]...), ())
end

number_of_nodes = 200
code = random_regular_eincode(number_of_nodes, 3)
optcode = @benchmark optimize_greedy($code, $(uniformsize(code, 2)); nrepeat=10, method=OMEinsum.MinSpaceOut())

using Test, OMEinsum
using OMEinsum: IndexGroup, NestedEinsum, parse_nested, DynamicEinCode, isleaf, getixsv, getiyv
@testset "einsequence" begin
    @test push!(IndexGroup([],1), 'c').inds == IndexGroup(['c'], 1).inds
    @test isempty(IndexGroup([],1))

    @test_throws ArgumentError parse_nested("((ij,jk),km")
    @test_throws ArgumentError parse_nested("((ij,jk),k1)")

    e1 = ein"((i,ij),i),j->i"
    e2 = DynamicNestedEinsum(e1)
    e3 = StaticNestedEinsum(e2)
    @test e1 == e3
    @test e1 == e2
    @test getiyv(e1) == ['i']
    @test OMEinsum.rootcode(e1) == ein"ij,j->i"
    lf = OMEinsum.siblings(e1)[2]
    @test isleaf(lf)
    @test OMEinsum.tensorindex(lf) == 4
    @test labeltype(e1) == Char

    @test_throws ErrorException getiyv(lf)
    @test_throws ErrorException getixsv(lf)

    xs = (randn(3), randn(3,3), randn(3), randn(3))
    @test e1(xs...) == e2(xs...)

    a, b, c = rand(2,2), rand(2,2), rand(2,2)
    abc1 = ein"(ij,jk),km -> im"(a,b,c)
    abc2 = ein"((ij,jk),km) -> im"(a,b,c)
    abc3 = ein"ij,jk,km -> im"(a,b,c)

    ne = ein"(ij,jk),km -> im"
    print(ne)
    dne = DynamicNestedEinsum(ne)
    print(dne)
    args = (dne, dne)
    eins = DynamicEinCode([['a', 'b'], ['b', 'c']], ['a', 'c'])
    @test DynamicNestedEinsum(args, eins) isa DynamicNestedEinsum

    @test abc1 ≈ abc2 ≈ abc3
    size_info = Dict('k'=>2)
    a, b, c, d = randn(2), randn(2,2), randn(2), randn(2)
    @test ein"((i,ij),i),j->ik"(a, b, c, d; size_info=size_info) ≈ ein"i,ij,i,j->ik"(a, b, c, d; size_info=size_info)
    size_dict = Dict([l=>2 for l in "ijkl"])
    @test einsum!(ein"((i,ij),i),j->ik", (a, b, c, d), randn(2, 2), true, false, size_dict) ≈ ein"i,ij,i,j->ik"(a, b, c, d; size_info=size_info)
    @test getixsv(ein"((i,ij),i),j->ik") == getixsv(ein"i,ij,i,j->ik") == getixsv(DynamicEinCode(ein"i,ij,i,j->ik")) == [['i'], ['i','j'], ['i'], ['j']]
    @test getiyv(ein"((i,ij),i),j->ik") == getiyv(ein"i,ij,i,j->ik") == getiyv(DynamicEinCode(ein"i,ij,i,j->ik")) == ['i','k']
end

@testset "macro" begin
    b, c, d = rand(2,2), rand(2,2,2), rand(2,2,2,2)
    @ein a[i,j] := b[i,k] * c[k,k,l] * d[l,m,m,j]
    @ein a2[i,j] := b[i,k] * (c[k,k,l] * d[l,m,m,j])
    @test a ≈ a2
end

@testset "flatten" begin
    ne = ein"(ij,j),k->"
    @test OMEinsum.flatten(ne) === ein"ij,j,k->"
    ne2 = DynamicNestedEinsum(ne)
    @test OMEinsum.flatten(ne2) isa DynamicEinCode && OMEinsum.flatten(ne2) == DynamicEinCode(ein"ij,j,k->")
end

@testset "time, space, rw complexity" begin
    ne = ein"(ij,jkc),klc->il"
    size_dict = Dict([l=>10 for l in "ijklc"])
    tc, sc, rw = timespacereadwrite_complexity(ne, size_dict)
    @test tc ≈ log2(10000+10000)
    @test sc ≈ log2(1000)
    @test rw ≈ log2(100+1000+1000+1000+1000+100)
    @test peak_memory(ne, size_dict) == 2100
end

@testset "replace" begin
    ne = ein"(ij, jk), kl->il"
    ne2 = replace(ne, 'i'=>'a', 'j'=>'b', 'k'=>'c', 'l'=>'d')
    @test labeltype(ne2) == Char
    @test ne2 == ein"(ab, bc), cd->ad"

    ne = OMEinsum.DynamicNestedEinsum(ein"(ij, jk), kl->il")
    ne2 = replace(ne, 'i'=>'a', 'j'=>'b', 'k'=>'c', 'l'=>'d')
    @test labeltype(ne2) == Char
    @test ne2 == ein"(ab, bc), cd->ad"
end

# include `EinCode`, `NestedEinsum` and `SlicedEinsum`
#
# Required interfaces are:
# * labeltype
# * getixsv
# * getiyv
#
# Optional interfaces are:
# * uniquelabels
abstract type AbstractEinsum end
uniquelabels(code::AbstractEinsum) = unique!(vcat(getixsv(code)..., getiyv(code)))

"""
    EinCode <: AbstractEinsum
    EinCode(ixs, iy)

Abstract type for sum-product contraction code.
The constructor returns a `DynamicEinCode` instance.
"""
abstract type EinCode <: AbstractEinsum end

"""
    StaticEinCode{LT, ixs, iy}

The static version of `DynamicEinCode` that matches the contraction rule at compile time.
It is the default return type of `@ein_str` macro. `LT` is the label type.
"""
struct StaticEinCode{LT,ixs, iy} <: EinCode end

getixs(::StaticEinCode{LT,ixs}) where {LT,ixs} = ixs
getiy(::StaticEinCode{LT,ixs, iy}) where {LT,ixs, iy} = iy
labeltype(::StaticEinCode{LT}) where {LT} = LT
"""
    getixsv(code)

Get labels of input tensors for `EinCode`, `NestedEinsum` and some other einsum like objects.
Returns a vector of vectors.

```jldoctest; setup = :(using OMEinsum)
julia> getixsv(ein"(ij,jk),k->i")
3-element Vector{Vector{Char}}:
 ['i', 'j']
 ['j', 'k']
 ['k']
```
"""
getixsv(code::StaticEinCode{LT}) where LT = [collect(LT, ix) for ix in getixs(code)]   # not stable!
"""
    getiy(code)

Get labels of the output tensor for `EinCode`, `NestedEinsum` and some other einsum like objects.
Returns a vector.

```jldoctest; setup = :(using OMEinsum)
julia> getiyv(ein"(ij,jk),k->i")
1-element Vector{Char}:
 'i': ASCII/Unicode U+0069 (category Ll: Letter, lowercase)
```
"""
getiyv(code::StaticEinCode{LT}) where LT = collect(LT, getiy(code))
function Base.replace(::StaticEinCode{LT, ixs, iy}, pairs::Pair...) where {ixs, iy, LT}
    StaticEinCode{LT, map(ix->replace(ix, pairs...), ixs), replace(iy, pairs...)}()
end

"""
    DynamicEinCode{LT}
    DynamicEinCode(ixs, iy)

Wrapper to `eincode`-specification that creates a callable object
to evaluate the `eincode` `ixs -> iy` where `ixs` are the index-labels
of the input-tensors and `iy` are the index-labels of the output.

# example

```jldoctest; setup = :(using OMEinsum)
julia> a, b = rand(2,2), rand(2,2);

julia> OMEinsum.DynamicEinCode((('i','j'),('j','k')),('i','k'))(a, b) ≈ a * b
true
```
"""
struct DynamicEinCode{LT} <: EinCode
    ixs::Vector{Vector{LT}}
    iy::Vector{LT}
end
# to avoid ambiguity error, support tuple inputs
function DynamicEinCode(ixs, iy)
    @debug "generating dynamic eincode ..."
    if isempty(ixs)
        error("number of input tensors must be greater than 0")
    end
    DynamicEinCode(_tovec(ixs, iy)...)
end
_tovec(ixs::NTuple{N,Tuple{}}, iy::Tuple{}) where {N} = [collect(Union{}, ix) for ix in ixs], collect(Union{}, iy)
_tovec(ixs::NTuple{N,NTuple{M,LT} where M}, iy::NTuple{K,LT}) where {N,K,LT} = [collect(LT, ix) for ix in ixs], collect(LT, iy)
_tovec(ixs::NTuple{N,Vector{LT}}, iy::Vector{LT}) where {N,LT} = collect(ixs), iy
_tovec(ixs::AbstractVector{Vector{LT}}, iy::AbstractVector{LT}) where {LT} = collect(ixs), collect(iy)

Base.:(==)(x::EinCode, y::EinCode) = getixsv(x) == getixsv(y) && getiyv(x) == getiyv(y)
function Base.replace(code::DynamicEinCode{LT}, pairs::Pair...) where LT
    DynamicEinCode{LT}(map(ix->replace(ix, pairs...), code.ixs), replace(code.iy, pairs...))
end
# forward from EinCode, for compatibility
EinCode(ixs, iy) = DynamicEinCode(ixs, iy)

getixs(code::DynamicEinCode) = code.ixs
getiy(code::DynamicEinCode) = code.iy
labeltype(::DynamicEinCode{LT}) where LT = LT
getixsv(code::DynamicEinCode) = code.ixs
getiyv(code::DynamicEinCode) = code.iy

# conversion
DynamicEinCode(::StaticEinCode{LT,ixs,iy}) where {LT,ixs, iy} = DynamicEinCode([collect(LT,ix) for ix in ixs], collect(LT,iy))
StaticEinCode(code::DynamicEinCode{LT}) where LT = StaticEinCode{LT,(Tuple.(code.ixs)...,), (code.iy...,)}()

"""
    EinIndexer{locs,N}

A structure for indexing `EinArray`s. `locs` is the index positions (among all indices).
In the constructor, `size` is the size of target tensor,
"""
struct EinIndexer{locs,N}
    cumsize::NTuple{N, Int}
end

"""
    EinIndexer{locs}(size::Tuple)

Constructor for `EinIndexer` for an object of size `size` where `locs` are the
locations of relevant indices in a larger tuple.
"""
function EinIndexer{locs}(size::NTuple{N,Int}) where {N,locs}
    N==0 && return EinIndexer{(),0}(())
    EinIndexer{locs,N}((1,TupleTools.cumprod(size[1:end-1])...))
end

getlocs(::EinIndexer{locs,N}) where {N,locs} = locs

# get a subset of index
@inline subindex(indexer::EinIndexer, ind::CartesianIndex) = subindex(indexer, ind.I)
@inline subindex(indexer::EinIndexer{(),0}, ind::NTuple{N0,Int}) where N0 = 1
@inline @generated function subindex(indexer::EinIndexer{locs,N}, ind::NTuple{N0,Int}) where {N,N0,locs}
    ex = Expr(:call, :+, map(i->i==1 ? :(ind[$(locs[i])]) : :((ind[$(locs[i])]-1) * indexer.cumsize[$i]), 1:N)...)
    :(@inbounds $ex)
end

"""
    EinArray{T, N, TT, LX, LY, ICT, OCT} <: AbstractArray{T, N}

A struct to hold the intermediate result of an `einsum` where all index-labels
of both input and output are expanded to a rank-`N`-array whose values
are lazily calculated.
Indices are arranged as _inner indices_ (or reduced dimensions) first and _then outer indices_.

Type parameters are

    * `T`: element type,
    * `N`: array dimension,
    * `TT`: type of "tuple of input arrays",
    * `LX`: type of "tuple of input indexers",
    * `LX`: type of output indexer,
    * `ICT`: typeof inner CartesianIndices,
    * `OCT`: typeof outer CartesianIndices,
"""
struct EinArray{T, N, TT, LX, LY, ICT, OCT} <: AbstractArray{T, N}
    xs::TT
    x_indexers::LX
    y_indexer::LY
    size::NTuple{N, Int}
    ICIS::ICT
    OCIS::OCT
    function EinArray{T}(xs::TT, x_indexers::LX, y_indexer::LY, size::NTuple{N, Int}, ICIS::ICT, OCIS::OCT) where {T,N,TT<:Tuple,LX<:Tuple,LY<:EinIndexer,ICT,OCT}
        new{T,N,TT,LX,LY,ICT,OCT}(xs,x_indexers,y_indexer,size,ICIS,OCIS)
    end
end

"""
    einarray(::Val{ixs}, Val{iy}, xs, size_dict) -> EinArray

Constructor of `EinArray` from an `EinCode`, a tuple of tensors `xs` and a `size_dict` that assigns each index-label a size.
The returned `EinArray` holds an intermediate result of the `einsum` specified by the
`EinCode` with indices corresponding to all unique labels in the einsum.
Reduction over the (lazily calculated) dimensions that correspond to labels not present
in the output lead to the result of the einsum.

# example

```jldoctest; setup = :(using OMEinsum)
julia> using OMEinsum: get_size_dict

julia> a, b = rand(2,2), rand(2,2);

julia> sd = get_size_dict((('i','j'),('j','k')), (a, b));

julia> ea = OMEinsum.einarray(Val((('i','j'),('j','k'))),Val(('i','k')), (a,b), sd);

julia> dropdims(sum(ea, dims=1), dims=1) ≈ a * b
true
```
"""
@generated function einarray(::Val{ixs}, ::Val{iy}, xs::TT, size_dict) where {ixs, iy, NI, TT<:NTuple{NI,AbstractArray}}
    inner_indices, outer_indices, locs_xs, locs_y = indices_and_locs(ixs, iy)
    inner_indices = (inner_indices...,)
    outer_indices = (outer_indices...,)
    T = promote_type(eltype.(xs.parameters)...)
    xind_expr = Expr(:call, :tuple, map(i->:(EinIndexer{$(locs_xs[i])}(size(xs[$i]))),1:NI)...)

    quote
        # find size for each leg
        outer_sizes = getindex.(Ref(size_dict), $outer_indices)
        inner_sizes = getindex.(Ref(size_dict), $inner_indices)

        # cartesian indices for outer and inner legs
        outer_ci = CartesianIndices(outer_sizes)
        inner_ci = CartesianIndices(inner_sizes)

        x_indexers = $(xind_expr)
        y_size = getindex.(Ref(size_dict), iy)
        y_indexer = EinIndexer{$locs_y}(y_size)

        #EinArray{$T, $N, $TT, $LX, $LY, $ICT, $OCT}(xs, x_indexers, y_indexer, (inner_sizes...,outer_sizes...), inner_ci, outer_ci)
        EinArray{$T}(xs, x_indexers, y_indexer, (inner_sizes...,outer_sizes...), inner_ci, outer_ci)
    end
end

Base.size(A::EinArray) = A.size
@doc raw"
    getindex(A::EinArray, inds...)
return the lazily calculated entry of `A` at index `inds`.
"
@inline Base.getindex(A::EinArray{T}, ind) where {T} = map_prod(A.xs, ind, A.x_indexers)
@inline Base.getindex(A::EinArray{T}, inds::Int...) where {T} = map_prod(A.xs, inds, A.x_indexers)

# get one element from each tensor, and multiply them
@doc raw"
    map_prod(xs, ind, indexers)

calculate the value of an `EinArray` with `EinIndexer`s `indexers` at location `ind`.
"
@inline @generated function map_prod(xs::Tuple, ind, indexers::NTuple{N,Any}) where {N}
    ex = Expr(:call, :*, map(i->:(xs[$i][subindex(indexers[$i], ind)]), 1:N)...)
    :(@inbounds $ex)
end

@doc raw"
    indices_and_locs(ixs,iy)
given the index-labels of input and output of an `einsum`, return
(in the same order):
- a tuple of the distinct index-labels of the output `iy`
- a tuple of the distinct index-labels in `ixs` of the input not appearing in the output `iy`
- a tuple of tuples of locations of an index-label in the `ixs` in a list of all index-labels
- a tuple of locations of index-labels in `iy` in a list of all index-labels

where the list of all index-labels is simply the first  and the second output catenated and the second output catenated.
"
function indices_and_locs(ixs, iy)
    # outer legs and inner legs
    outer_indices = unique!(collect(iy))
    inner_indices = setdiff!(collect(vcat(_collect.(ixs)...)), outer_indices)

    # for indexing tensors (leg binding)
    indices = (inner_indices...,outer_indices...)
    locs_xs = map(ixs) do ix
        map(i->findfirst(isequal(i), indices), ix)
    end
    locs_y = map(i->findfirst(isequal(i), outer_indices), iy)
    return inner_indices, outer_indices, locs_xs, locs_y
end

# dynamic EinIndexer
struct DynamicEinIndexer{N}
    locs::NTuple{N,Int}
    cumsize::NTuple{N, Int}
end

function dynamic_indexer(locs::NTuple{N,Int}, size::NTuple{N,Int}) where {N}
    N==0 && return DynamicEinIndexer{0}((),())
    DynamicEinIndexer{N}(locs, (1,TupleTools.cumprod(size[1:end-1])...))
end

getlocs(d::DynamicEinIndexer{N}) where {N} = d.locs

# get a subset of index
@inline subindex(indexer::DynamicEinIndexer, ind::CartesianIndex) = subindex(indexer, ind.I)
@inline subindex(indexer::DynamicEinIndexer{0}, ind::NTuple{N0,Int}) where N0 = 1
@inline @generated function subindex(indexer::DynamicEinIndexer{N}, ind::NTuple{N0,Int}) where {N,N0}
    ex = Expr(:call, :+, map(i->i==1 ? :(ind[indexer.locs[$i]]) : :((ind[indexer.locs[$i]]-1) * indexer.cumsize[$i]), 1:N)...)
    :(@inbounds $ex)
end

using BenchmarkTools
using Random
using OMEinsum


Random.seed!(0)

const SUITE = BenchmarkGroup()

SUITE["manyinds"] = BenchmarkGroup()
suite = SUITE["manyinds"]

for T in (Float32, Float64, ComplexF32, ComplexF64)
    suite[string(T)] = BenchmarkGroup()
    args = ["abcdefghijklmnop,flnqrcipstujvgamdwxyz->bcdeghkmnopqrstuvwxyz"]
    dims = [2]
    for str in args, dim in dims
        code = ein"abcdefghijklmnop,flnqrcipstujvgamdwxyz->bcdeghkmnopqrstuvwxyz"
        arr1 = rand(T, map(i->2, OMEinsum.getixs(code)[1])...)
        arr2 = rand(T, map(i->2, OMEinsum.getixs(code)[2])...)
        suite[string(T)]["tiny"] = @benchmarkable code($arr1,$arr2)
    end
end

# Matrix multiplication
SUITE["matmul"] = BenchmarkGroup()
suite = SUITE["matmul"]
for T in (Float32, Float64, ComplexF32, ComplexF64)
    suite[string(T)] = BenchmarkGroup()
    args = ["tiny"   => rand(T,2,2),
    "small"  => rand(T,10,10),
    "medium" => rand(T,10^2,10^2),
    "large"  => rand(T, 10^3,10^3)
    ]
    for (k,m) in args
        suite[string(T)][k] = @benchmarkable ein"ij,jk -> ik"($m,$m)
    end
end

# Matrix batch-multiplication
SUITE["batchmul"] = BenchmarkGroup()
suite = SUITE["batchmul"]


for T in (Float32, Float64, ComplexF32, ComplexF64)
    suite[string(T)] = BenchmarkGroup()
    args = ["tiny"   => rand(T,2,2,3),
    "small"  => rand(T,10,10,3),
    "medium" => rand(T,10^2,10^2,3),
    "large"  => rand(T, 10^3,10^3,3)
    ]
    for (k,m) in args
        suite[string(T)][k] = @benchmarkable ein"ijk,jlk -> ilk"($m,$m)
    end
end

#inner - reduction to scalar
SUITE["dot"] = BenchmarkGroup()
suite = SUITE["dot"]
for T in (Float32, Float64, ComplexF32, ComplexF64)
    suite[string(T)] = BenchmarkGroup()
    args = ["tiny"   => rand(T,fill(2,3)...)
    "small"  => rand(T,fill(10,3)...)
    "medium" => rand(T,fill(20,3)...)
    "large"  => rand(T,fill(50,3)...)
    "huge"   => rand(T,fill(10^2,3)...)]
    for (k,m) in args
        suite[string(T)][k] = @benchmarkable ein"ijk,ijk -> "($m, $m)
    end
end

#trace
SUITE["trace"] = BenchmarkGroup()
suite = SUITE["trace"]
for T in (Float32, Float64, ComplexF32, ComplexF64)
    suite[string(T)] = BenchmarkGroup()
    args = ["tiny"   => rand(T,fill(2,2)...)
    "small"  => rand(T,fill(10,2)...)
    "medium" => rand(T,fill(10^2,2)...)
    "large"  => rand(T,fill(10^3,2)...)]
    for (k,m) in args
        suite[string(T)][k] = @benchmarkable ein"ii -> "($m)
    end
end

#partial trace
SUITE["ptrace"] = BenchmarkGroup()
suite = SUITE["ptrace"]
for T in (Float32, Float64, ComplexF32, ComplexF64)
    suite[string(T)] = BenchmarkGroup()
    args = ["tiny"   => rand(T,fill(2,3)...)
    "small"  => rand(T,fill(10,3)...)
    "medium" => rand(T,fill(20,3)...)
    "large"  => rand(T,fill(50,3)...)
    "huge"   => rand(T,fill(10^2,3)...)]
    for (k,m) in args
        suite[string(T)][k] = @benchmarkable ein"iij -> j"($m)
    end
end

#diagonal
SUITE["diag"] = BenchmarkGroup()
suite = SUITE["diag"]

for T in (Float32, Float64, ComplexF32, ComplexF64)
    suite[string(T)] = BenchmarkGroup()
    args =  [
    "tiny"   => rand(T,fill(2,3)...)
    "small"  => rand(T,fill(10,3)...)
    "medium" => rand(T,fill(20,3)...)
    "large" => rand(T,fill(30,3)...)
    "huge" => rand(T,fill(100,3)...)
    ]
    for (k,m) in args
        suite[string(T)][k] = @benchmarkable ein"ijj -> ij"($m)
    end
end

#permutation
SUITE["perm"] = BenchmarkGroup()
suite = SUITE["perm"]
for T in (Float32, Float64, ComplexF32, ComplexF64)
    suite[string(T)] = BenchmarkGroup()
    args =  [
    "tiny"   => rand(T,fill(1,4)...)
    "small"  => rand(T,fill(2,4)...)
    "medium" => rand(T,fill(10,4)...)
    "large"  => rand(T,fill(30,4)...)
    ]
    for (k,m) in args
        suite[string(T)][k] = @benchmarkable ein"ijkl -> ljki"($m)
    end
end

# tensor contraction
SUITE["tcontract"] = BenchmarkGroup()
suite = SUITE["tcontract"]

for T in (Float32, Float64, ComplexF32, ComplexF64)
    suite[string(T)] = BenchmarkGroup()
    args =  [
    "tiny"   => rand(T,fill(1,3)...)
    "small"  => rand(T,fill(2,3)...)
    "medium" => rand(T,fill(10,3)...)
    "large"  => rand(T,fill(30,3)...)
    ]

    for (k,m) in args
        suite[string(T)][k] = @benchmarkable ein"ijk, jlk -> il"($m,$m)
    end
end

# star contraction
SUITE["star"] = BenchmarkGroup()
suite = SUITE["star"]

for T in (Float32, Float64, ComplexF32, ComplexF64)
    suite[string(T)] = BenchmarkGroup()
    args =  [
    "tiny"   => rand(T,fill(2,2)...)
    "small"  => rand(T,fill(10,2)...)
    "medium" => rand(T,fill(30,2)...)
    "large"  => rand(T,fill(100,2)...)
    ]
    for (k,m) in args
        suite[string(T)][k] = @benchmarkable ein"ij,ik,il -> jkl"($m,$m,$m)
    end
end

#star and contract
SUITE["starandcontract"] = BenchmarkGroup()
suite = SUITE["starandcontract"]

for T in (Float32, Float64, ComplexF32, ComplexF64)
    suite[string(T)] = BenchmarkGroup()
    args =  [
    "tiny"   => rand(T,fill(2,2)...)
    "small"  => rand(T,fill(10,2)...)
    "medium" => rand(T,fill(30,2)...)
    "large"  => rand(T,fill(100,2)...)
    ]
    for (k,m) in args
        suite[string(T)][k] = @benchmarkable ein"ij,ik,ik -> j"($m,$m,$m)
    end
end

# index-sum
SUITE["indexsum"] = BenchmarkGroup()
suite = SUITE["indexsum"]
for T in (Float32, Float64, ComplexF32, ComplexF64)
    suite[string(T)] = BenchmarkGroup()
    args =  [
    "tiny"   => rand(T,fill(2,3)...)
    "small"  => rand(T,fill(10,3)...)
    "medium" => rand(T,fill(30,3)...)
    "large"  => rand(T,fill(100,3)...)
    ]
    for (k,m) in args
        suite[string(T)][k] = @benchmarkable ein"ijk -> ik"($m)
    end
end
# Hadamard
SUITE["hadamard"] = BenchmarkGroup()
suite = SUITE["hadamard"]
for T in (Float32, Float64, ComplexF32, ComplexF64)
    suite[string(T)] = BenchmarkGroup()
    args =  [
    "tiny"   => rand(T,fill(2,3)...)
    "small"  => rand(T,fill(10,3)...)
    "medium" => rand(T,fill(30,3)...)
    "large"  => rand(T,fill(100,3)...)
    ]
    for (k,m) in args
        suite[string(T)][k] = @benchmarkable ein"ijk,ijk -> ijk"($m,$m)
    end
end

# Outer
SUITE["outer"] = BenchmarkGroup()
suite = SUITE["outer"]

for T in (Float32, Float64, ComplexF32, ComplexF64)
    suite[string(T)] = BenchmarkGroup()
    args =  [
    "tiny"   => rand(T,fill(2,2)...)
    "small"  => rand(T,fill(10,2)...)
    "medium" => rand(T,fill(50,2)...)
    "large"  => rand(T,fill(100,2)...)
    ]
    for (k,m) in args
        suite[string(T)][k] = @benchmarkable ein"ij,kl -> ijkl"($m,$m)
    end
end

## non-inplace einsum
@doc raw"
    einsum(code::EinCode, xs, size_dict)

Return the tensor that results from contracting the tensors `xs` according to the contraction code `code`.

### Arguments
- `code`: The einsum notation, which can be an instance of [`EinCode`](@ref), [`NestedEinsum`](@ref), or [`SlicedEinsum`](@ref).
- `xs` - the input tensors
- `size_dict` - a dictionary that maps index-labels to their sizes

### Examples

```jldoctest; setup = :(using OMEinsum)
julia> a, b = rand(2,2), rand(2,2);

julia> einsum(EinCode((('i','j'),('j','k')),('i','k')), (a, b)) ≈ a * b
true

julia> einsum(EinCode((('i','j'),('j','k')),('k','i')), (a, b)) ≈ permutedims(a * b, (2,1))
true
```
"
function einsum(code::AbstractEinsum, @nospecialize(xs::Tuple), size_dict::Dict=get_size_dict!(getixs(code), xs, Dict{labeltype(code),Int}()))
    y = get_output_array(xs, map(y -> size_dict[y], getiyv(code)), false)
    einsum!(code, xs, y, true, false, size_dict)
end

# inplace einsum, EinCode as the input
"""
    einsum!(code::EinCode, xs, y, sx, sy, size_dict)

Inplace version of `einsum`. The result is stored in `y`.

### Arguments
- `code`: The einsum notation, which can be an instance of [`EinCode`](@ref), [`NestedEinsum`](@ref), or [`SlicedEinsum`](@ref).
- `xs`: The input tensors.
- `y`: The output tensor.
- `sx`: Scale `x` by `sx`.
- `sy`: Scale `y` by `sy`.
- `size_dict`: A dictionary that maps index-labels to their sizes.
"""
function einsum!(code::EinCode, @nospecialize(xs::Tuple), @nospecialize(y), sx, sy, size_dict::Dict=get_size_dict(getixs(code), xs))
    einsum!(getixs(code), getiy(code), xs, y, sx, sy, size_dict)
end
# inplace einsum, the fallback
function einsum!(ixs, iy, @nospecialize(xs::Tuple), @nospecialize(y), sx, sy, size_dict::Dict)
    @debug "fallback to loop_einsum" ixs => iy size.(xs)
    loop_einsum!(ixs, iy, (xs...,), y, sx, sy, size_dict)
end

struct UnaryOperation{LT}
    type
    ix::Vector{LT}
    iy::Vector{LT}
end
# for unary operations
# overhead ~ 2.3us
# @benchmark OMEinsum.einsum(DefaultRule(), $((('a', 'a', 'b'),)), $(('c', 'b','a')), (x,), $(Dict('a'=>1, 'b'=>1, 'c'=>1))) setup=(x=randn(1,1,1))
function unary_pipeline(ix::Vector{LT}, iy::Vector{LT}) where {LT}
    ix_unique = _unique(LT, ix)
    iy_unique = _unique(LT, iy)
    iy_a = filter(i -> i ∈ ix, iy_unique)

    operations = UnaryOperation[]
    if length(ix_unique) != length(ix)  # diag
        push!(operations, UnaryOperation(Diag(), ix, ix_unique))
    end
    if length(ix_unique) != length(iy_a)  # sum
        push!(operations, UnaryOperation(Sum(), ix_unique, iy_a))
    elseif ix_unique != iy_a   # permute, high freq
        push!(operations, UnaryOperation(Permutedims(), ix_unique, iy_a))
    end

    if length(iy_a) != length(iy_unique)  # repeat
        push!(operations, UnaryOperation(Repeat(), iy_a, iy_unique))
    end
    if length(iy_unique) != length(iy)  # duplicate
        push!(operations, UnaryOperation(Duplicate(), iy_unique, iy))
    end
    return operations
end

function einsum!(ixs, iy, @nospecialize(xs::NTuple{1,Any}), @nospecialize(y), sx, sy, size_dict::Dict{LT}) where {LT}
    @debug "compiling unary" ixs[1] => iy size(xs[1])
    pipeline = unary_pipeline(collect(LT, ixs[1]), collect(LT, iy))
    lasttensor = xs[1]
    for (k, op) in enumerate(pipeline)
        if k == length(pipeline)  # last operation
            unary_einsum!(op.type, op.ix, op.iy, lasttensor, y, sx, sy)
        else
            cache = similar(y, ([size_dict[l] for l in op.iy]...,))
            unary_einsum!(op.type, op.ix, op.iy, lasttensor, cache, true, false)
            lasttensor = cache
        end
    end
    if length(pipeline) == 0
        @flatten_addmul! sy * y + sx * lasttensor
    end
    return y
end

# there are too many combination in the binary case, so nospecialize
function einsum!(ixs, iy, @nospecialize(xs::NTuple{2,Any}), @nospecialize(y), sx, sy, size_dict::Dict{LT}) where {LT}
    iyv = _collect(LT, iy)
    ix1v, ix2v = _collect.(Ref(LT), ixs)
    @debug "compiling binary" ixs => iyv size.(xs)
    x1, x2 = xs
    c1, c2, cy, s1, s2, s3, i1, i2, iyb = analyze_binary(ix1v, ix2v, iyv, size_dict)
    rule = SimpleBinaryRule{(i1...,),(i2...,),(iyb...,)}()
    xs1 = simplifyto(ix1v, c1, x1, size_dict)
    xs2 = simplifyto(ix2v, c2, x2, size_dict)
    x1_ = safe_reshape(xs1, s1)
    x2_ = safe_reshape(xs2, s2)
    @debug rule size.((x1_, x2_))
    if cy != iyv
        y_ = similar(y, (s3...,))
        y_ = reshape(binary_einsum!(rule, x1_, x2_, y_, true, false), [size_dict[x] for x in cy]...)
        return einsum!((cy,), iyv, (y_,), y, sx, sy, size_dict)
    else
        binary_einsum!(rule, x1_, x2_, safe_reshape(y, s3), sx, sy)
        return y
    end
end
safe_reshape(x, sz) = reshape(x, (sz...,))

function simplifyto(ix1, c1, x1, size_dict::Dict{LT}) where {LT}
    if c1 != ix1
        xs1 = similar(x1, ([size_dict[l] for l in c1]...,))
        return einsum!((_collect(LT, ix1),), c1, (x1,), xs1, true, false, size_dict)
    else
        return x1
    end
end

"""
Get the expected labels.
"""
function analyze_binary(ix1::Vector{T}, ix2::Vector{T}, iy::Vector{T}, size_dict::Dict{T,Int}) where {T}
    ix_inner, ix1_outer, ix2_outer, batch = _analyze_binary_input(ix1, ix2, iy)
    c1 = vcat(ix1_outer, ix_inner, batch)
    c2 = vcat(ix_inner, ix2_outer, batch)
    cy = vcat(ix1_outer, ix2_outer, batch)
    si = prod(map(x -> size_dict[x], ix1_outer))
    sj = prod(map(x -> size_dict[x], ix_inner))
    sk = prod(map(x -> size_dict[x], ix2_outer))
    sl = prod(map(x -> size_dict[x], batch))
    has_i = !isempty(ix1_outer)
    has_j = !isempty(ix_inner)
    has_k = !isempty(ix2_outer)
    has_l = !isempty(batch)
    i1 = Char[]
    i2 = Char[]
    iyb = Char[]
    s1 = Int[]
    s2 = Int[]
    s3 = Int[]
    if has_i
        push!(i1, 'i')
        push!(iyb, 'i')
        push!(s1, si)
        push!(s3, si)
    end
    if has_j
        push!(i1, 'j')
        push!(i2, 'j')
        push!(s1, sj)
        push!(s2, sj)
    end
    if has_k
        push!(i2, 'k')
        push!(iyb, 'k')
        push!(s2, sk)
        push!(s3, sk)
    end
    if has_l
        push!(i1, 'l')
        push!(i2, 'l')
        push!(iyb, 'l')
        push!(s1, sl)
        push!(s2, sl)
        push!(s3, sl)
    end
    return c1, c2, cy, s1, s2, s3, i1, i2, iyb
end

function _analyze_binary_input(ix1::Vector{T}, ix2::Vector{T}, iy::Vector{T}) where {T}
    ix1_batch = T[]
    ix1_inner = T[]
    ix1_outer = T[]
    for l1 in ix1
        if l1 ∈ ix2
            if l1 ∈ iy  # batch
                l1 ∉ ix1_batch && push!(ix1_batch, l1)
            else        # inner
                l1 ∉ ix1_inner && push!(ix1_inner, l1)
            end
        elseif l1 ∈ iy  # outer
            l1 ∉ ix1_outer && push!(ix1_outer, l1)
        else
            # dangling
        end
    end
    ix2_outer = T[]     # outer dimension of x2
    for l2 in ix2
        if l2 ∉ ix1 && l2 ∈ iy && l2 ∉ ix2_outer
            push!(ix2_outer, l2)
        end
    end
    ix1_inner, ix1_outer, ix2_outer, ix1_batch
end

# `CacheTree` stores intermediate `NestedEinsum` contraction results.
# It is a tree structure that isomorphic to the contraction tree,
# `content` is the cached intermediate contraction result.
# `siblings` are the siblings of current node.
mutable struct CacheTree{T}
    content::AbstractArray{T}
    const siblings::Vector{CacheTree{T}}
end
CacheTree(content::AbstractArray{T}, siblings) where T = CacheTree(content, CacheTree{T}[siblings...])

"""
    cached_einsum(code, xs, size_dict)

Compute the einsum contraction and cache the intermediate contraction results.

### Arguments
- `code`: The contraction code, which can be a `NestedEinsum` or a `SlicedEinsum`.
- `xs`: The input tensors.
- `size_dict`: The size dictionary, which maps the label to the size of the corresponding dimension.

### Returns
- `CacheTree`: The cached tree storing the intermediate results.
"""
function cached_einsum(se::SlicedEinsum, @nospecialize(xs), size_dict)
    # slicing is not supported yet.
    if length(se.slicing) != 0
        @warn "Slicing is not supported for caching, got nslices = $(length(se.slicing))! Fallback to `NestedEinsum`."
    end
    return cached_einsum(se.eins, xs, size_dict)
end

# recursively contract and cache a tensor network
function cached_einsum(code::NestedEinsum, @nospecialize(xs), size_dict)
    if isleaf(code)
        # For a leaf node, cache the input tensor
        y = xs[tensorindex(code)]
        return CacheTree(y, CacheTree{eltype(y)}[])
    else
        # For a non-leaf node, compute the einsum and cache the contraction result
        caches = [cached_einsum(arg, xs, size_dict) for arg in siblings(code)]
        # `einsum` evaluates the einsum contraction,
        # Its 1st argument is the contraction pattern,
        # Its 2nd one is a tuple of input tensors,
        # Its 3rd argument is the size dictionary (label as the key, size as the value).
        y = einsum(rootcode(code), ntuple(i -> caches[i].content, length(caches)), size_dict)
        return CacheTree(y, caches)
    end
end

"""
    back_propagate(f, code, cache, ȳ, size_dict)

Back propagate the message `ȳ` through the cached tree `cache` and return a tree storing the intermediate messages.
The message can be gradients et al.

### Arguments
- `f`: The back-propagation rule. The signature is `f(eins, xs, y, size_dict, dy) -> dxs`, where
    - `eins`: The contraction code at the current node.
    - `xs`: The input tensors at the current node.
    - `y`: The output tensor at the current node.
    - `size_dict`: The size dictionary, which maps the label to the size of the corresponding dimension.
    - `dy`: The message on the output tensor (`y`) to back-propagate through the current node.
    - `dxs`: The message on the input tensors (`xs`) as the result of back-propagation.
- `code`: The contraction code, which can be a `NestedEinsum` or a `SlicedEinsum`.
- `cache`: The cached intermediate results, which can be generated by [`cached_einsum`](@ref).
- `ȳ`: The message to back-propagate.
- `size_dict`: The size dictionary, which maps the label to the size of the corresponding dimension.

### Returns
- `CacheTree`: The tree storing the intermediate messages.
"""
function back_propagate(f, se::SlicedEinsum, cache::CacheTree{T}, dy::AbstractArray{T}, size_dict::Dict) where {T}
    if length(se.slicing) != 0
        @warn "Slicing is not supported for generating masked tree! Fallback to `NestedEinsum`."
    end
    return back_propagate(f, se.eins, cache, dy, size_dict)
end

function back_propagate(f, code::NestedEinsum, cache::CacheTree{T}, dy::AbstractArray{T}, size_dict::Dict) where {T}
    if isleaf(code)
        return CacheTree(dy, CacheTree{T}[])
    else
        xs = ntuple(i -> cache.siblings[i].content, length(cache.siblings))
        # `einsum_grad` is the back-propagation rule for einsum function.
        # If the forward pass is `y = einsum(EinCode(inputs_labels, output_labels), (A, B, ...), size_dict)`
        # Then the back-propagation pass is
        # ```
        # A̅ = einsum_grad(inputs_labels, (A, B, ...), output_labels, size_dict, y̅, 1)
        # B̅ = einsum_grad(inputs_labels, (A, B, ...), output_labels, size_dict, y̅, 2)
        # ...
        # ```
        # Let `L` be the loss, we will have `y̅ := ∂L/∂y`, `A̅ := ∂L/∂A`...
        dxs = f(rootcode(code), xs, cache.content, size_dict, dy)
        return CacheTree(dy, back_propagate.(Ref(f), siblings(code), cache.siblings, dxs, Ref(size_dict)))
    end
end

# the main function for generating the gradient tree.
function gradient_tree(code::AbstractEinsum, xs, ȳ)
    # infer size from the contraction code and the input tensors `xs`, returns a label-size dictionary.
    size_dict = get_size_dict!(getixsv(code), xs, Dict{labeltype(code), Int}())
    # forward compute and cache intermediate results.
    cache = cached_einsum(code, xs, size_dict)
    # back-propagate
    return copy(cache.content), back_propagate(einsum_backward_rule, code, cache, ȳ, size_dict)
end

"""
    cost_and_gradient(code, xs, ȳ)

Compute the cost and the gradients w.r.t the input tensors `xs`.

### Arguments
- `code`: The contraction code, which can be a `NestedEinsum` or a `SlicedEinsum`.
- `xs`: The input tensors.
- `ȳ`: The message to back-propagate. Default is `1`.

### Returns
- `cost`: The cost of the contraction.
- `grads`: The gradients w.r.t the input tensors.
"""
function cost_and_gradient(code, xs::Tuple, ȳ = nothing)
    if ȳ === nothing
        ȳ = init_gradient(code, xs)
        @assert ndims(ȳ) == 0 "The output must be a scalar! Or you need to feed the gradient manually. Got: $(ndims(ȳ))!"
    end
    cost, tree = gradient_tree(code, xs, ȳ)
    # extract the gradients on leaves (i.e. the input tensors).
    return cost, extract_leaves(code, tree)
end

# initialize `y̅` as `1`. Note we always start from `L̅ := 1`.
function init_gradient(code, xs)
    size_dict = get_size_dict!(getixsv(code), xs, Dict{labeltype(code), Int}())
    output_size = getindex.(Ref(size_dict), getiyv(code))
    ȳ = get_output_array(xs, output_size, false)
    return fill!(ȳ, one(eltype(ȳ)))
end

# since slicing is not supported, we forward it to NestedEinsum.
extract_leaves(code::SlicedEinsum, cache::CacheTree) = extract_leaves(code.eins, cache)

# extract gradients on leaf nodes.
function extract_leaves(code::NestedEinsum, cache::CacheTree)
    res = Vector{Any}(undef, length(getixsv(code)))
    return extract_leaves!(code, cache, res)
end

function extract_leaves!(code, cache, res)
    if isleaf(code)
        # extract
        res[tensorindex(code)] = cache.content
    else
        # resurse deeper
        for (subcode, sib) in zip(siblings(code), cache.siblings)
            extract_leaves!(subcode, sib, res)
        end
    end
    return res
end

using OMEinsum: _unique
using OMEinsum
using Test

@testset "utils" begin
    @test _unique(Int,(1,2,3,3,)) == [1,2,3]
    @test asarray(3) isa Array
    @test asarray(3, randn(3,3)) isa Array
    @test asarray(randn(3,3)) isa Array
    @test asscalar(fill(3,())) === 3
    @test asscalar(3) === 3
end

@testset "allunique" begin
    @test allunique(())
    @test allunique(('i',))
    @test allunique((1,2))
    @test !allunique((1,2,1))
end

@testset "tensorpermute" begin
    a = randn(100, 100)
    @test OMEinsum.tensorpermute!(zero(a), a, [1,2], true, false) == a
    @test OMEinsum.tensorpermute!(zero(a), a, (2,1), true, false) == transpose(a)
end

@testset "align_types" begin
    a = randn(100, 100)
    b = randn(ComplexF64, 100, 100)
    res = OMEinsum.align_eltypes(a, b)
    @test res[2] === b
    @test res == (ComplexF64.(a), b)
end

@testset "batched gemm" begin
    A = randn(10, 10, 10)
    B = randn(10, 10, 10)
    for C1 in ['N', 'T']
        for C2 in ['N', 'T']
            A_ = Array{Any}(A)
            B_ = Array{Any}(B)
            @test OMEinsum._batched_gemm!(C1, C2, true, A, B, false, zeros(10, 10, 10)) ≈ OMEinsum._batched_gemm!(C1, C2, true, A_, B_, false, zeros(10, 10, 10))
        end
    end
end

@testset "addmul!" begin
    x = randn(10, 10)
    y = randn(10, 10)
    z = randn(10, 10)
    for a in [0.0, 1.0, 4.0], b in [0.0, 1.0, 4.0]
        @test (o = copy(x); OMEinsum.@addmul! a * o + b * y * z) ≈ a .* x .+ b .* y .* z
        @test (o = copy(x); OMEinsum.@flatten_addmul! a * o + b * y * z) ≈ a .* x .+ b .* y .* z
    end
end

"""
    ein"ij,jk -> ik"(A,B)

String macro interface which understands `numpy.einsum`'s notation.
Translates strings into `StaticEinCode`-structs that can be called to evaluate
an `einsum`.
To control evaluation order, use parentheses - instead of an `EinCode`,
a `NestedEinsum` is returned which evaluates the expression
according to parens.
The valid character ranges for index-labels are `a-z` and `α-ω`.

# example

```jldoctest; setup = :(using OMEinsum)
julia> a, b, c = rand(10,10), rand(10,10), rand(10,1);

julia> ein"ij,jk,kl -> il"(a,b,c) ≈ ein"(ij,jk),kl -> il"(a,b,c) ≈ a * b * c
true
```
"""
macro ein_str(s::AbstractString)
    ein(s)
end

"""
    optein"ij,jk,kl -> ik"(A, B, C)

String macro interface that similar to [`@ein_str`](@ref), with optimized contraction order (dimensions are assumed to be uniform).
"""
macro optein_str(s::AbstractString)
    code = ein(s)
    optimize_code(code, uniformsize(code, 2), TreeSA(; ntrials=1, niters=10)).eins
end

function ein(s::AbstractString)
    s = replace(replace(s, "\n" => ""), " "=>"")
    m = match(r"([\(\)a-z,α-ω]*)->([a-zα-ω]*)", s)
    m === nothing && throw(ArgumentError("invalid einsum specification $s"))
    sixs, siy = m.captures
    if '(' in sixs
        return parse_nested(sixs, collect(siy))
    else
        iy  = Tuple(siy)
        ixs = Tuple(Tuple(ix) for ix in split(sixs,','))
        return StaticEinCode{Char, ixs, iy}()
    end
end

function (code::DynamicEinCode{LT})(@nospecialize(xs...); size_info=nothing) where LT
    size_dict = get_size_dict!(getixs(code), xs, size_info===nothing ? Dict{LT,Int}() : copy(size_info))
    einsum(code, xs, size_dict)
end

function (code::StaticEinCode{LT})(xs...; size_info=nothing) where LT
    size_dict = get_size_dict!(getixs(code), xs, size_info===nothing ? Dict{LT,Int}() : copy(size_info))
    einsum(code, xs, size_dict)
end

# 2us overheads if @nospecialize
@doc raw"
    get_size_dict!(ixs, xs, size_info)

return a dictionary that is used to get the size of an index-label
in the einsum-specification with input-indices `ixs` and tensors `xs` after
consistency within `ixs` and between `ixs` and `xs` has been verified.
"
@inline function get_size_dict!(ixs, xs, size_info::Dict{LT}) where LT
    if length(ixs) == 1
        get_size_dict_unary!(ixs[1], size(xs[1]), size_info)
    else
        get_size_dict_!(ixs, [collect(Int, size(x)) for x in xs], size_info)
    end
end

function get_size_dict_!(ixs, sizes::AbstractVector, size_info::Dict{LT}) where LT
    # check size of input tuples
    length(sizes)<1 && error("empty input tensors")
    length(ixs) != length(sizes) && throw(ArgumentError("$(length(sizes)) tensors labelled by $(length(ixs)) indices"))
    # check tensor orders
    @inbounds for i=1:length(sizes)
        ix, s = ixs[i], sizes[i]
        length(ix) == length(s) || throw(
            ArgumentError("indices $ix invalid for tensor with ndims = $(length(s))"))
        for j = 1:length(ix)
            k = ix[j]
            if haskey(size_info, k)
                s[j] == size_info[k] || throw(DimensionMismatch("$k = $(size_info[k]) or $(s[j]))?"))
            else
                size_info[k] = s[j]
            end
        end
    end
    return size_info
end
# to speed up unary operations
function get_size_dict_unary!(ix, s, size_info::Dict{LT}) where LT
    @inbounds for j = 1:length(ix)
        k = ix[j]
        if haskey(size_info, k)
            s[j] == size_info[k] || throw(DimensionMismatch("$k = $(size_info[k]) or $(s[j]))?"))
        else
            size_info[k] = s[j]
        end
    end
    return size_info
end

@inline function get_size_dict(ixs, xs, size_info=nothing)
    LT = foldl((a, b) -> promote_type(a, eltype(b)), ixs; init=Union{})
    return get_size_dict!(ixs, xs, size_info===nothing ? Dict{LT,Int}() : size_info)
end
@inline function get_size_dict(ixs::AbstractVector{<:AbstractVector{LT}}, xs, size_info=nothing) where LT
    return get_size_dict!(ixs, xs, size_info===nothing ? Dict{LT,Int}() : size_info)
end

using MacroTools
"""
    @ein A[i,k] := B[i,j] * C[j,k]     # A = B * C

Macro interface similar to that of other packages.

You may use numbers in place of letters for dummy indices, as in `@tensor`,
and need not name the output array. Thus `A = @ein [1,2] := B[1,ξ] * C[ξ,2]`
is equivalent to the above. This can also be written `A = ein"ij,jk -> ik"(B,C)`
using the numpy-style string macro.

# example

```jldoctest; setup = :(using OMEinsum)
julia> a, b = rand(2,2), rand(2,2);

julia> @ein c[i,k] := a[i,j] * b[j,k];

julia> c ≈ a * b
true

julia> c ≈ ein"ij,jk -> ik"(a,b)
true
```
"""
macro ein(exs...)
    _ein_macro(exs...)
end

primefix!(ind) = map!(i -> @capture(i, (j_)') ? Symbol(j, '′') : i, ind, ind)

function _ein_macro(ex; einsum = :einsum)
    @capture(ex, (left_ := right_)) || throw(ArgumentError("expected @ein A[] := B[]..."))

    @capture(left, Z_[leftind__] | [leftind__] ) || throw(
        ArgumentError("can't understand LHS, expected A[i,j] etc."))
    if Z===nothing
        @gensym Z
    end
    primefix!(leftind)

    rightind, rightpairs = [], []
    @capture(right, *(factors__)) || (factors = Any[right])
    for fact in factors
        @capture(fact, A_[Aind__]) || return _nested_ein_macro(ex)
        primefix!(Aind)
        append!(rightind, Aind)
        push!(rightpairs, (A, Aind) )
    end
    unique!(rightind)
    isempty(setdiff(leftind, rightind)) || throw(
        ArgumentError("some indices appear only on the left"))

    lefttuple = Tuple(indexin(leftind, rightind))
    righttuples = [ Tuple(indexin(ind, rightind)) for (A, ind) in rightpairs ]
    rightnames = [ esc(A) for (A, ind) in rightpairs ]

    return :( $(esc(Z)) = $einsum( EinCode(($(righttuples...),), $lefttuple), ($(rightnames...),)) )
end

"""
    @ein! A[i,k] := B[i,j] * C[j,k]     # A = B * C
    @ein! A[i,k] += B[i,j] * C[j,k]     # A += B * C

Macro interface similar to that of other packages.

Inplace version of `@ein`. 

# example

```jldoctest; setup = :(using OMEinsum)
julia> a, b, c, d = rand(2,2), rand(2,2), rand(2,2), zeros(2,2);

julia> cc = copy(c);

julia> @ein! d[i,k] := a[i,j] * b[j,k];

julia> d ≈ a * b
true

julia> d ≈ ein"ij,jk -> ik"(a,b)
true

julia> @ein! c[i,k] += a[i,j] * b[j,k];

julia> c ≈ cc + a * b
true
```
"""
macro ein!(exs...)
    _ein_macro!(exs...)
end

function _ein_macro!(ex; einsum = :einsum!)
    if @capture(ex, (left_ := right_))
        flag = false
    elseif @capture(ex, (left_ += right_))
        flag = true
    else
        throw(ArgumentError("expected @ein! A[] := B[]... or @ein! A[] += B[]..."))
    end

    @capture(left, Z_[leftind__] | [leftind__] ) || throw(
        ArgumentError("can't understand LHS, expected A[i,j] etc."))
    if Z===nothing
        throw(ArgumentError("LHS is needed for inplace einsum, expected A[i,j] etc."))
    end
    primefix!(leftind)

    rightind, rightpairs = [], []
    @capture(right, *(factors__)) || (factors = Any[right])
    for fact in factors
        @capture(fact, A_[Aind__]) || return _nested_ein_macro(ex)
        primefix!(Aind)
        append!(rightind, Aind)
        push!(rightpairs, (A, Aind) )
    end
    unique!(rightind)
    isempty(setdiff(leftind, rightind)) || throw(
        ArgumentError("some indices appear only on the left"))

    lefttuple = Tuple(indexin(leftind, rightind))
    righttuples = [ Tuple(indexin(ind, rightind)) for (A, ind) in rightpairs ]
    rightnames = [ esc(A) for (A, ind) in rightpairs ]

    return :( $(esc(Z)) = $einsum( EinCode(($(righttuples...),), $lefttuple), ($(rightnames...),), $(esc(Z)), true, $flag) )
end

using Test
using OMEinsum
using AMDGPU
using DoubleFloats
using Zygote

AMDGPU.allowscalar(false)

@testset "loop einsum" begin
    a = [randn(fill(3, i)...) for i = 1:4]
    ca = a .|> ROCArray
    ixs = ((1, 2), (2, 3))
    xs = (ca[2], ca[2])
    @test loop_einsum!(ixs, (1, 3), xs, zeros(3, 3) |> ROCArray, true, false, OMEinsum.get_size_dict(ixs, xs)) |> Array ≈ a[2] * a[2]
    @test loop_einsum!(ixs, (1, 3), xs, ones(3, 3) |> ROCArray, 4.0, 2.0, OMEinsum.get_size_dict(ixs, xs)) |> Array ≈ 4.0 * a[2] * a[2] + 2 * ones(3, 3)
    res = 4.0 * a[2] * a[2]
    out = 2 * ones(3, 3, 3)
    for k = 1:3
        out[:, k, k] .+= res[:, k]
    end
    @test loop_einsum!(ixs, (1, 3, 3), xs, ones(3, 3, 3) |> ROCArray, 4.0, 2.0, OMEinsum.get_size_dict(ixs, xs)) |> Array ≈ out
end

@testset "roc einsum" begin
    a = [randn(fill(3, i)...) for i = 1:4]
    ca = a .|> ROCArray
    ixs = ((1, 2), (2, 3))
    xs = (ca[2], ca[2])
    @test loop_einsum!(ixs, (1, 3), xs, zeros(3, 3) |> ROCArray, true, false, OMEinsum.get_size_dict(ixs, xs)) ≈ ca[2] * ca[2]
    for f in [ein"ij,jk->ik", ein"ii->", ein"ijj ->i", ein"ij,ik,il->jkl", ein"ii->i", ein"ijl->i", ein"i->ii", ein"ij,jk,kl->il", ein"ij,ij,ij -> ij"]
        cins = map(ix -> ca[length(ix)], OMEinsum.getixs(f))
        ins = map(ix -> a[length(ix)], OMEinsum.getixs(f))
        @test f(cins...) isa DenseROCArray
        @test loop_einsum(f, cins, OMEinsum.get_size_dict(OMEinsum.getixs(f), cins)) |> Array ≈ f(ins...)
        @test f(ins...) ≈ Array(f(cins...))
    end
end

@testset "fallback - getindex IR error" begin
    a = rand(ComplexF64, 2, 2, 2)
    ca = ROCArray(a)
    @test Array(ein"npu,por,dom,lmn -> urdl"(ca, ca, ca, ca)) ≈ ein"npu,por,dom,lmn -> urdl"(a, a, a, a)
end

@testset "isbatchmul" begin
    for (ixs, iy) in [(((1, 2), (2, 3)), (1, 3)), (((1, 2, 3), (2, 3)), (1, 3)),
        (((7, 1, 2, 3), (2, 4, 3, 7)), (1, 4, 3)),
        (((3,), (3,)), (3,)), (((3, 1), (3,)), (3, 1))
    ]
        xs = ([randn(ComplexF64, fill(4, length(ix))...) |> ROCArray for ix in ixs]...,)
        @test EinCode(ixs, iy)(xs...) |> Array ≈ loop_einsum(EinCode(ixs, iy), xs, OMEinsum.get_size_dict(ixs, xs)) |> Array
    end
end


@testset "doublefloats" begin
    D = 2
    T = ROCArray(rand(Double64, D, D, D, D, D, D))
    U = ROCArray(rand(Double64, D, D, D))

    code = ein"abewcd,bfixgh,ajeycd,jfizgh->wxyz"
    xs = (T, T, T, T)
    M = code(xs...)
    @test M |> Array ≈ loop_einsum(code, xs, OMEinsum.get_size_dict(OMEinsum.getixs(code), xs)) |> Array

    code = ein"(ubcdef,fjz),dhx,(bvghij,eiy),cgw->uvwxyz"
    _code = ein"ubcdef,fjz,dhx,bvghij,eiy,cgw->uvwxyz"
    xs = (T, U, U, T, U, U)
    M = code(xs...)
    # mapreducedim! calls to dynamic tuple splatting.
    @test M |> Array ≈ loop_einsum(_code, xs, OMEinsum.get_size_dict(OMEinsum.getixs(_code), xs)) |> Array
end

@testset "unary einsum rules" begin
    for code in [
        ein"ij->",  # sum
        ein"ij->j", # sum
        ein"ii->",  # tr
        ein"ii->i",  # diag
        ein"ijk->kij",   # permutedims
        ein"a->aaaa",   # ~diag
        ein"ac->acc",   # ~diag
        ein"->ii",   # ~tr
        ein"i->ik",   # ~sum
        ein"->ik",   # ~sum
        ein"illljkk->kijjcc",   # general
    ]
        @info code
        D = 2
        xs = [length(ix) == 0 ? AMDGPU.fill(1.2) : AMDGPU.rand(Float64, fill(D, length(ix))...) for ix in OMEinsum.getixs(code)]
        size_dict = Dict(zip(('a', 'b', 'c', 'd', 'e', 'f', 'i', 'j', 'k', 'l'), ntuple(x -> D, 10)))
        res = einsum(code, (xs...,), size_dict)
        @test Array(res) ≈ loop_einsum(code, (Array.(xs)...,), size_dict)
        @test Array(res) ≈ Array(loop_einsum(code, (xs...,), size_dict))
    end
end

@testset "binary einsum rules" begin
    codes = [
        # binary
        ein",->",
        ein"i,->i",
        ein"j,j->",
        ein",k->k",
        ein"j,jk->k",
        ein"j,kj->k",
        ein"ij,j->i",
        ein"ji,j->i",
        ein"i,k->ik",
        ein"i,k->ki",
    ]

    for (i1, X1) in enumerate([('i', 'j'), ('j', 'i')])
        for (i2, X2) in enumerate([('j', 'k'), ('k', 'j')])
            for (i3, X3) in enumerate([('i', 'k'), ('k', 'i')])
                push!(codes, OMEinsum.StaticEinCode{Char,(X1, X2),X3}())
            end
        end
    end
    for code in copy(codes)
        X1, X2 = OMEinsum.getixs(code)
        X3 = OMEinsum.getiy(code)
        push!(codes, OMEinsum.StaticEinCode{Char,((X1..., 'l'), (X2..., 'l')),(X3..., 'l')}())
    end

    for code in codes
        @info code
        D = 2
        xs = [length(ix) == 0 ? AMDGPU.fill(1.2) : AMDGPU.rand(Float64, fill(D, length(ix))...) for ix in OMEinsum.getixs(code)]
        size_dict = Dict(zip(('a', 'b', 'c', 'd', 'e', 'f', 'i', 'j', 'k', 'l'), ntuple(x -> D, 10)))
        res = einsum(code, (xs...,), size_dict)
        @test Array(res) ≈ loop_einsum(code, (Array.(xs)...,), size_dict)
        @test Array(res) ≈ Array(loop_einsum(code, (xs...,), size_dict))
    end
end

@testset "composite einsum" begin
    for code in [
        ein"abb,bc->ac",  # with diag in
        ein"ab,bc->acc",  # with diag out
        ein"ab,bce->ac",  # with sum in
        ein"ab,bc->ace",  # with sum out
        ein"bal,bcl->lcae",  # with perm in
        ein"bal,bcl->ca",  # with multi-edge in
        ein"bal,bc->lca",  # with multi-edge out
        ein"ddebal,bcf->lcac",  # with all
    ]
        @info code
        D = 2
        xs = [length(ix) == 0 ? AMDGPU.fill(1.2) : AMDGPU.rand(Float64, fill(D, length(ix))...) for ix in OMEinsum.getixs(code)]
        size_dict = Dict(zip(('a', 'b', 'c', 'd', 'e', 'f', 'i', 'j', 'k', 'l'), ntuple(x -> D, 10)))
        res = einsum(code, (xs...,), size_dict)
        @test Array(res) ≈ loop_einsum(code, (Array.(xs)...,), size_dict)
        @test Array(res) ≈ Array(loop_einsum(code, (xs...,), size_dict))
    end
end

@testset "permutedims for high dimensional tensors" begin
    c = AMDGPU.rand(4, [rand(1:3) for _ = 2:18]...)
    @test Array(permutedims(c, 18:-1:1)) ≈ permutedims(Array(c), 18:-1:1)
end

@testset "gradient type check - AMDGPU" begin
    array_match(x, y) = typeof(x) == typeof(y) && size(x) == size(y)
    a = AMDGPU.randn(3, 3)
    b = AMDGPU.randn(3, 3)
    @test array_match(gradient(a -> Array(einsum(EinCode(((1, 2), (2, 1)), ()), (a, b)))[] |> abs, a)[1], a)
    b = randn(ComplexF64, 3, 3) |> ROCArray
    @test array_match(gradient(a -> Array(einsum(EinCode(((1, 2), (2, 1)), ()), (a, b)))[] |> abs, a)[1], a)
    a = randn(ComplexF64, 3, 3) |> ROCArray
    @test array_match(gradient(a -> Array(einsum(EinCode(((1, 2), (2, 3)), ()), (a, b)))[] |> abs, a)[1], a)
    b = AMDGPU.randn(3, 3)
    @test array_match(gradient(a -> Array(einsum(EinCode(((1, 2), (2, 3)), ()), (a, b)))[] |> abs, a)[1], a)
end

@testset "adjoint dispatch" begin
    u = AMDGPU.rand(2, 2)
    A = AMDGPU.rand(2, 2, 2)
    @test Array(ein"(ip,pql),qj -> ijl"(u', A, u)) ≈ ein"(ip,pql),qj -> ijl"(Array(ROCArray(u')), Array(A), Array(u))
    @test Array(DynamicEinCode(ein"mk, ijk -> ijm")(u', A)) ≈ DynamicEinCode(ein"mk, ijk -> ijm")(Array(u'), Array(A))
    @test Array(ein"mk, ijk -> ijm"(u', A)) ≈ DynamicEinCode(ein"mk, ijk -> ijm")(Array(u'), Array(A))
end

"""
    loop_einsum(::EinCode, xs, size_dict)

evaluates the eincode specified by `EinCode` and the tensors `xs` by looping
over all possible indices and calculating the contributions ot the result.
Scales exponentially in the number of distinct index-labels.
"""
function loop_einsum(code::EinCode, xs::NTuple{N, AbstractArray{<:Any,M} where M},
                size_dict) where {N}
    iy = getiy(code)
    size = getindex.(Ref(size_dict), iy)
    loop_einsum!(getixs(code), getiy(code), xs, get_output_array(xs, size, false), true, false, size_dict)
end

"""
    loop_einsum!(ixs, iy, xs, y, sx, sy, size_dict)

inplace-version of `loop_einsum`, saving the result in a preallocated tensor
of correct size `y`.
"""
function loop_einsum!(ixs, iy,
                xs::NTuple{N, AbstractArray{<:Any,M} where M},
                y::AbstractArray{T,L}, sx, sy, size_dict) where {N,L,T}
    ALLOW_LOOPS[] || error("using `loop_einsum` is forbidden: code: $ixs -> $iy")
    A = einarray(Val((Tuple.(ixs)...,)), Val((iy...,)), xs, size_dict)
    if iszero(sy)
        fill!(y, zero(T))
    elseif !isone(sy)
        lmul!(sy, y)
    end
    reduce_einarray!(A, y, sx)
end

function reduce_einarray!(A::EinArray{T}, y, sx) where T
    @inbounds for ind_y in A.OCIS
        iy = subindex(A.y_indexer,ind_y)
        yi = zero(T)
        for ind_x in A.ICIS
            ind = TupleTools.vcat(ind_x.I,ind_y.I)
            yi += map_prod(A.xs, ind, A.x_indexers)
        end
        y[iy] += sx * yi
    end
    y
end

# speed up the get output array for the case when the inputs have the same type.
function get_output_array(xs::NTuple{N, AbstractArray{T,M} where M}, size, fillzero::Bool) where {T,N}
    if fillzero
        zeros(T, size...)
    else
        Array{T}(undef, size...)
    end
end
function get_output_array(xs::NTuple{N, AbstractArray{<:Any,M} where M}, size, fillzero::Bool) where N
    if fillzero
        zeros(promote_type(map(eltype,xs)...), size...)
    else
        Array{promote_type(map(eltype,xs)...)}(undef, size...)
    end
end

const ALLOW_LOOPS = Ref(true)

"""
    allow_loops(flag::Bool)

Setting this to `false` will cause OMEinsum to log an error if it falls back to
`loop_einsum` evaluation, instead of calling specialised kernels. The default is `true`.
"""
function allow_loops(flag::Bool)
    ALLOW_LOOPS[] = flag
end

using Distributed
using OMEinsum.OMEinsumContractionOrders, OMEinsum, CUDA

@info "find $(length(devices())) GPU devices"
const procs = addprocs(length(devices())-nprocs()+1)
const gpus = collect(devices())
const process_device_map = Dict(zip(procs, gpus))
@info "mapping processes to GPUs: $process_device_map"

@everywhere begin  # these packages/functions should be accessible on all processes
    using OMEinsum.OMEinsumContractionOrders, OMEinsum, CUDA
    CUDA.allowscalar(false)

    function do_work(f, jobs, results) # define work function everywhere
        while true
            job = take!(jobs)
            @info "running $job on device $(Distributed.myid())"
            res = f(job)
            put!(results, res)
        end
    end
end

"""
    multiprocess_run(func, inputs::AbstractVector)

Run `func` in parallel for a vector f `inputs`.
Returns a vector of results.
"""
function multiprocess_run(func, inputs::AbstractVector{T}) where T
    n = length(inputs)
    jobs = RemoteChannel(()->Channel{T}(n));
    results = RemoteChannel(()->Channel{Any}(n));
    for i in 1:n
        put!(jobs, inputs[i])
    end
    for p in workers() # start tasks on the workers to process requests in parallel
        remote_do(do_work, p, func, jobs, results)
    end
    return Any[take!(results) for i=1:n]
end

"""
    multigpu_einsum(code::SlicedEinsum, xs::AbstractArray...; size_info = nothing, process_device_map::Dict)

Multi-GPU contraction of a sliced einsum specified by `code`.
Each time, the program take the slice and upload them to a specific GPU device and do the contraction.
Other arguments are

* `xs` are input tensors allocated in **main memory**,
* `size_info` specifies extra size information,
* `process_device_map` is a map between processes and GPU devices.
"""
function multigpu_einsum(se::SlicedEinsum{LT,ET}, @nospecialize(xs::AbstractArray...); size_info = nothing, process_device_map::Dict) where {LT, ET}
    length(se.slicing) == 0 && return se.eins(xs...; size_info=size_info)
    size_dict = size_info===nothing ? Dict{OMEinsum.labeltype(se),Int}() : copy(size_info)
    OMEinsum.get_size_dict!(se, xs, size_dict)

    it = OMEinsum.SliceIterator(se, size_dict)
    res = OMEinsum.get_output_array(xs, getindex.(Ref(size_dict), it.iyv), true)
    eins_sliced = OMEinsum.drop_slicedim(se.eins, se.slicing)
    inputs = collect(enumerate([copy(x) for x in it]))
    @info "start multiple process contraction!"
    results = multiprocess_run(inputs) do (k, slicemap)
        @info "computing slice $k/$(length(it))"
        device!(process_device_map[Distributed.myid()])
        xsi = ntuple(i->CuArray(OMEinsum.take_slice(xs[i], it.ixsv[i], slicemap)), length(xs))
        Array(einsum(eins_sliced, xsi, it.size_dict_sliced))
    end
    # accumulate results to `res`
    for (resi, (k, slicemap)) in zip(results, inputs)
        OMEinsum.fill_slice!(res, it.iyv, resi, slicemap)
    end
    return res
end

# A using case
# ---------------------------------------
using Yao, Yao.YaoToEinsum, Yao.EasyBuild

# I. create a quantum circuit
nbit = 20
c = Yao.dispatch!(variational_circuit(nbit, 10), :random)

# II. convert a tensor network
# 1. specify input and output states as product states,
prod_state = Dict(zip(1:nbit, zeros(Int, nbit)))
# 2. convert the circuit to einsum code,
code, xs = YaoToEinsum.yao2einsum(c; initial_state=prod_state, final_state=prod_state, optimizer=nothing)
# 3. optimize the contraction order
size_dict = OMEinsum.get_size_dict(getixsv(code), xs)
slicedcode = optimize_code(code, size_dict, TreeSA(); simplifier=MergeGreedy(), slicer=TreeSASlicer(score=ScoreFunction(sc_target=15)))

# III. do the contraction on multiple GPUs in parallel
@info "time/space complexity is $(timespace_complexity(slicedcode, size_dict)), number of slices: $(length(slicedcode.slicing))"
multigpu_einsum(slicedcode, xs...; process_device_map=process_device_map)

macro addmul!(ex)
    esc(addmul_impl(ex, false))
end
macro flatten_addmul!(ex)
    esc(addmul_impl(ex, true))
end

function addmul_impl(ex::Expr, flatten::Bool)
    @assert ex.head === :call && length(ex.args) == 3
    dotadd, ay, bxs = ex.args
    @assert dotadd == :+
    @assert ay.head === :call && length(ay.args) == 3
    dotmul, a, y = ay.args
    @assert dotmul == :*
    @assert bxs.head === :call
    dotmul2, b, xs... = bxs.args
    @assert dotmul2 == :*
    @assert length(xs) > 0

    added = :(Ref($b))
    for x in xs
        added = :($added .* $(flatten ? :(vec($x)) : x))
    end
    vy = flatten ? :(vec($y)) : y
    quote
        if iszero($b)   # no need to multiply
            $lmul!($a, $vy)
        elseif iszero($a)  # empty y
            $vy .= $added
        elseif isone($a)
            $vy .+= $added
        else  # a != 1, a != 0, b != 0
            $vy .= Ref($a) .* $vy .+ $added
        end
        $y
    end
end

"""
    asarray(x[, parent::AbstractArray]) -> AbstactArray

Return a 0-dimensional array with item `x`, otherwise, do nothing.
If a `parent` is supplied, it will try to match the parent array type.
"""
asarray(x) = fill(x, ())
asarray(x::AbstractArray) = x
asarray(x, arr::AbstractArray) = fill(x, ())
asarray(x::AbstractArray, y::Array) = x
asscalar(x) = x
asscalar(x::AbstractArray) = x[]
_collect(x) = collect(x)
_collect(x::Vector) = x
_collect(::Type{T}, x::Vector{T}) where {T} = x
_collect(::Type{T}, x) where {T} = collect(T, x)
_insertat(lst::Tuple, i, item) = TupleTools.insertat(lst, i, (item,))
_insertat(lst::AbstractVector, i, item) = (lst = copy(lst); lst[i] = item; lst)

"""
    nopermute(ix,iy)

check that all values in `iy` that are also in `ix` have the same relative order,

# example

```jldoctest; setup = :(using OMEinsum)
julia> using OMEinsum: nopermute

julia> nopermute((1,2,3),(1,2))
true

julia> nopermute((1,2,3),(2,1))
false
```
e.g. `nopermute((1,2,3),(1,2))` is true while `nopermute((1,2,3),(2,1))` is false
"""
function nopermute(ix::NTuple, iy::NTuple)
    i, j, jold = 1, 1, 0
    # find each element of iy in ix and check that the order is the same
    for i in 1:length(iy)
        j = findfirst(==(iy[i]), ix)
        (j === nothing || j <= jold) && return false
        jold = j
    end
    return true
end

"""
    allunique(ix::Tuple)

return true if all elements of `ix` appear only once in `ix`.

# example

```jldoctest; setup = :(using OMEinsum)
julia> using OMEinsum: allunique

julia> allunique((1,2,3,4))
true

julia> allunique((1,2,3,1))
false
```
"""
allunique(ix) = all(i -> count(==(i), ix) == 1, ix)
_unique(::Type{T}, x::NTuple{N,T}) where {N,T} = unique!(collect(T, x))
_unique(::Type{T}, x::Vector{T}) where {T} = unique(x)

function align_eltypes(xs::AbstractArray...)
    T = promote_type(eltype.(xs)...)
    return map(x -> eltype(x) == T ? x : T.(x), xs)
end

function align_eltypes(xs::AbstractArray{T}...) where {T}
    xs
end

"""
    tensorpermute(A, perm)

`permutedims(A, perm)` with grouped dimensions.
"""
function tensorpermute!(C::AbstractArray{T,N}, A::AbstractArray{T,N}, perm, sx, sy) where {T,N}
    @assert N == length(perm) && all(p -> 1 <= p <= N, perm)
    N == 0 && return copy(A)
    # group `perm`s
    newshape_slots = fill(-1, N)
    dk = 1  # the size of dimension-batch
    @inbounds begin
        permk = perm[1]
        newperm = [permk]
        newshape_slots[permk] = size(A, permk)
    end
    @inbounds for i = 2:N
        permi = perm[i]
        if permi == permk + dk  # same group
            newshape_slots[permk] *= size(A, permi)
            dk += 1
        else
            permk = permi
            newshape_slots[permk] = size(A, permi)
            push!(newperm, permk)
            dk = 1
        end
    end
    newshape = filter(!=(-1), newshape_slots)
    newperm = sortperm(sortperm(newperm))
    A_ = reshape(A, newshape...)
    permed_shape = ntuple(i -> size(A_, @inbounds newperm[i]), ndims(A_))
    if iszero(sy)
        permutedims!(reshape(C, permed_shape), A_, newperm)
        !isone(sx) && lmul!(sx, C)
        return C
    else
        return @flatten_addmul! sy * C + sx * permutedims(A_, newperm)
    end
end

# new interface for GPU support!
# function _batched_gemm!(C1::Char, C2::Char, alpha, A::StridedArray{T,3}, B::StridedArray{T2,3}, beta, C::StridedArray{T3,3}) where {T<:BlasFloat, T2<:BlasFloat, T3<:BlasFloat}
#     batched_gemm!(C1, C2, alpha, A, B, beta, C)
# end
function _batched_gemm!(C1::Char, C2::Char, alpha, A::AbstractArray{T,3}, B::AbstractArray{T2,3}, beta, C::AbstractArray{T3,3}) where {T<:BlasFloat,T2<:BlasFloat,T3<:BlasFloat}
    # NOTE: convert alpha and beta to T3, since booleans are not supported by BatchedRoutines
    #batched_gemm!(C1, C2, T3(alpha), Array(A), Array(B), T3(beta), C)
    batched_gemm!(C1, C2, T3(alpha), A, B, T3(beta), C)
end
function _batched_gemm!(C1::Char, C2::Char, alpha, A::AbstractArray{T,3}, B::AbstractArray{T2,3}, beta, C::AbstractArray{T3,3}) where {T,T2,T3}
    @assert size(A, 3) == size(B, 3) == size(C, 3) "batch dimension mismatch, got $(size(A,3)), $(size(B,3)) and $(size(C,3))"
    @assert C1 === 'N' || C1 === 'T'
    @assert C2 === 'N' || C2 === 'T'
    for l = 1:size(A, 3)
        a = C1 === 'T' ? transpose(view(A, :, :, l)) : view(A, :, :, l)
        b = C2 === 'T' ? transpose(view(B, :, :, l)) : view(B, :, :, l)
        mul!(view(C, :, :, l), a, b, alpha, beta)
    end
    return C
end

# macro addmul!(a, y, b, xs...)
#     added = :(Ref(b))
#     for x in xs
#         added = :($added .* $x)
#     end
#     yeval = gensym("y")
#     quote
#         $yeval = $y
#         if iszero($b)   # no need to multiply
#             $lmul!($a, $yeval)
#         elseif iszero($a)  # empty y
#             $yeval .= $added
#         elseif isone($a)
#             $yeval .+= $added
#         else  # a != 1, a != 0, b != 0
#             $yeval .= Ref($a) .* $yeval .+ $added
#         end
#         $yeval
#     end |> esc
# end

function decorate(code::OMEinsumContractionOrders.EinCode)
    DynamicEinCode(code.ixs, code.iy)
end
function decorate(code::OMEinsumContractionOrders.NestedEinsum{LT}) where LT
    if OMEinsumContractionOrders.isleaf(code)
        DynamicNestedEinsum{LT}(code.tensorindex)
    else
        DynamicNestedEinsum(decorate.(code.args), decorate(code.eins))
    end
end
function decorate(code::OMEinsumContractionOrders.SlicedEinsum)
    SlicedEinsum(code.slicing, decorate(code.eins))
end

function rawcode(code::EinCode)
    OMEinsumContractionOrders.EinCode(getixsv(code), getiyv(code))
end
function rawcode(code::NestedEinsum{LT}) where LT
    if isleaf(code)
        OMEinsumContractionOrders.NestedEinsum{LT}(tensorindex(code))
    else
        OMEinsumContractionOrders.NestedEinsum([rawcode(s) for s in siblings(code)], rawcode(rootcode(code)))
    end
end
function rawcode(code::SlicedEinsum)
    OMEinsumContractionOrders.SlicedEinsum(code.slicing, rawcode(code.eins))
end
rawcode(code::AbstractEinsum) = rawcode(code)

function OMEinsumContractionOrders.optimize_code(code::AbstractEinsum, size_dict::Dict, optimizer::CodeOptimizer, simplifier=nothing, permute::Bool=true)
    decorate(optimize_code(rawcode(code), size_dict, optimizer, simplifier, permute))
end
OMEinsumContractionOrders.optimize_permute(code::AbstractEinsum) = decorate(optimize_permute(rawcode(code)))
OMEinsumContractionOrders.peak_memory(code::AbstractEinsum, size_dict::Dict) = peak_memory(rawcode(code), size_dict)
OMEinsumContractionOrders.flop(code::AbstractEinsum, size_dict::Dict) = flop(rawcode(code), size_dict)
OMEinsumContractionOrders.contraction_complexity(code::AbstractEinsum, size_dict) = contraction_complexity(rawcode(code), size_dict)

OMEinsumContractionOrders.uniformsize(code::AbstractEinsum, size) = Dict([l=>size for l in uniquelabels(code)])
OMEinsumContractionOrders.label_elimination_order(code::AbstractEinsum) = label_elimination_order(rawcode(code))

OMEinsumContractionOrders.viz_eins(code::AbstractEinsum, args...; kwargs...) = viz_eins(rawcode(code), args...; kwargs...)
OMEinsumContractionOrders.viz_contraction(code::AbstractEinsum, args...; kwargs...) = viz_contraction(rawcode(code), args...; kwargs...)

# save load
function writejson(filename::AbstractString, ne::Union{NestedEinsum, SlicedEinsum})
    OMEinsumContractionOrders.writejson(filename, rawcode(ne))
end
readjson(filename::AbstractString) = decorate(OMEinsumContractionOrders.readjson(filename))

# binary operations that can not be simplified by a unitary operations
struct SimpleBinaryRule{ix1,ix2,iy} <: EinRule{2} end
function SimpleBinaryRule(code::EinCode)
    ixs, iy = getixs(code), getiy(code)
    @assert length(ixs) == 2 "fail to construct simple binary rule from $code"
    SimpleBinaryRule{ixs[1],ixs[2],iy}()
end
SimpleBinaryRule(ix1, ix2, iy) = SimpleBinaryRule{ix1,ix2,iy}()

# Code is a binary representation of `(O1,I,O2,B)`.
# Because the time complexity of `GEMM` and `BatchedGEMM` are higher than space complexity, we allow `permutedims`.
# We reduce the contraction to these basic forms through `permutedims` and reshape,
# because we assume most using cases have both inner and outer degrees on freedom.

# ,-> : 000
# S = 1
# T = 1
function binary_einsum!(::SimpleBinaryRule{(),(),()}, x1, x2, y, sx, sy)
    @addmul! sy * y + sx * x1 * x2
end

# i,->i : 100
# S = N
# T = N
function binary_einsum!(::SimpleBinaryRule{('i',),(),('i',)}, x1, x2, y, sx, sy)
    @addmul! sy * y + sx * x1 * Ref(asscalar(x2))
end

# j,j-> : 010
# S = N
# T = N
function binary_einsum!(::SimpleBinaryRule{('j',),('j',),()}, x1, x2, y, sx, sy)
    @addmul! sy * y + sx * (reshape(x1, 1, length(x1)) * x2)
end

# ,k->k : 001
# S = N
# T = N
@inline function binary_einsum!(::SimpleBinaryRule{(),('k',),('k',)}, x1, x2, y, sx, sy)
    @addmul! sy * y + sx * Ref(asscalar(x1)) * x2
end

# j,jk->k : 011
# S = N^2
# T = N^2
function binary_einsum!(::SimpleBinaryRule{('j',),('j', 'k'),('k',)}, x1, x2, y, sx, sy)
    mul!(y, transpose(x2), x1, sx, sy)
end
function binary_einsum!(::SimpleBinaryRule{('j',),('k', 'j'),('k',)}, x1, x2, y, sx, sy)
    mul!(y, x2, x1, sx, sy)
end

# ij,j->i : 110
# S = N^2
# T = N^2
@inline function binary_einsum!(::SimpleBinaryRule{('i', 'j'),('j',),('i',)}, x1, x2, y, sx, sy)
    mul!(y, x1, x2, sx, sy)
end
@inline function binary_einsum!(::SimpleBinaryRule{('j', 'i'),('j',),('i',)}, x1, x2, y, sx, sy)
    mul!(y, transpose(x1), x2, sx, sy)
end

# i,k->ik : 101
# S = N^2
# T = N^2
function binary_einsum!(::SimpleBinaryRule{('i',),('k',),('i', 'k')}, x1, x2, y, sx, sy)
    @addmul! sy * y + sx * x1 * reshape(x2, 1, length(x2))
end
@inline function binary_einsum!(::SimpleBinaryRule{('i',),('k',),('k', 'i')}, x1, x2, y, sx, sy)
    @addmul! sy * y + sx * reshape(x1, 1, length(x1)) * x2
end

# 000
function binary_einsum!(::SimpleBinaryRule{('l',),('l',),('l',)}, x1, x2, y, sx, sy)
    @addmul! sy * y + sx * x1 * x2
end

# 100
function binary_einsum!(::SimpleBinaryRule{('i', 'l'),('l',),('i', 'l')}, x1, x2, y, sx, sy)
    @addmul! sy * y + sx * x1 * reshape(x2, 1, length(x2))
end

# 001
@inline function binary_einsum!(::SimpleBinaryRule{('l',),('k', 'l'),('k', 'l')}, x1, x2, y, sx, sy)
    @addmul! sy * y + sx * reshape(x1, 1, length(x1)) * x2
end

# 010
function binary_einsum!(::SimpleBinaryRule{('j', 'l'),('j', 'l'),('l',)}, x1, x2, y, sx, sy)
    @addmul! sy * y + sx * dropdims(mapreduce(*, +, x1, x2; dims=1); dims=1)
end

# 101
function binary_einsum!(::SimpleBinaryRule{('i', 'l'),('k', 'l'),('i', 'k', 'l')}, x1, x2, y::AbstractArray, sx, sy)
    _batched_gemm!('N', 'N', sx, reshape(x1, size(x1, 1), 1, size(x1, 2)), reshape(x2, 1, size(x2, 1), size(x2, 2)), sy, y)
end
@inline function binary_einsum!(::SimpleBinaryRule{('i', 'l'),('k', 'l'),('k', 'i', 'l')}, x1, x2, y::AbstractArray, sx, sy)
    _batched_gemm!('N', 'N', sx, reshape(x2, size(x2, 1), 1, size(x2, 2)), reshape(x1, 1, size(x1, 1), size(x1, 2)), sy, y)
end

# 011
function binary_einsum!(::SimpleBinaryRule{('j', 'l'),('j', 'k', 'l'),('k', 'l')}, x1, x2, y::AbstractArray, sx, sy)
    _batched_gemm!('N', 'N', sx, reshape(x1, 1, size(x1, 1), size(x1, 2)), x2, sy, reshape(y, 1, size(y, 1), size(y, 2)))
    y
end
function binary_einsum!(::SimpleBinaryRule{('j', 'l'),('k', 'j', 'l'),('k', 'l')}, x1, x2, y::AbstractArray, sx, sy)
    _batched_gemm!('N', 'T', sx, reshape(x1, 1, size(x1, 1), size(x1, 2)), x2, sy, reshape(y, 1, size(y, 1), size(y, 2)))
    y
end

# 110
function binary_einsum!(::SimpleBinaryRule{('i', 'j', 'l'),('j', 'l'),('i', 'l')}, x1, x2, y::AbstractArray, sx, sy)
    _batched_gemm!('N', 'N', sx, x1, reshape(x2, size(x2, 1), 1, size(x2, 2)), sy, reshape(y, size(y, 1), 1, size(y, 2)))
    y
end
function binary_einsum!(::SimpleBinaryRule{('j', 'i', 'l'),('j', 'l'),('i', 'l')}, x1, x2, y::AbstractArray, sx, sy)
    _batched_gemm!('T', 'N', sx, x1, reshape(x2, size(x2, 1), 1, size(x2, 2)), sy, reshape(y, size(y, 1), 1, size(y, 2)))
    y
end

# ij,jk->ik : 111
# S = N^2
# T = N^3
for (i1, X1) in enumerate([('i', 'j'), ('j', 'i')])
    for (i2, X2) in enumerate([('j', 'k'), ('k', 'j')])
        for (i3, X3) in enumerate([('i', 'k'), ('k', 'i')])
            A1 = i1 == i3 ? :(x1) : :(transpose(x1))
            A2 = i2 == i3 ? :(x2) : :(transpose(x2))
            @eval function binary_einsum!(::SimpleBinaryRule{$X1,$X2,$X3}, x1, x2, y::AbstractArray{T}, sx, sy) where {T}
                $(i3 == 1 ? :(mul!(y, $A1, $A2, sx, sy)) : :(mul!(y, $A2, $A1, sx, sy)))
            end
            X1B = (X1..., 'l')
            X2B = (X2..., 'l')
            X3B = (X3..., 'l')
            C1 = i1 == i3 ? 'N' : 'T'
            C2 = i2 == i3 ? 'N' : 'T'
            @eval function binary_einsum!(::SimpleBinaryRule{$X1B,$X2B,$X3B}, x1, x2, y::AbstractArray{T}, sx, sy) where {T}
                $(i3 == 1 ? :(_batched_gemm!($C1, $C2, sx, x1, x2, sy, y)) : :(_batched_gemm!($C2, $C1, sx, x2, x1, sy, y)))
            end
        end
    end
end

using OMEinsum, StatsBase
using DelimitedFiles
using OMEinsum: DynamicEinCode, StaticEinCode

function random_contract(D, dynamic, uniqueindex, nodangling)
    Ds = [rand(1:D) for _=1:3]
    T = Ds[1] + Ds[2]
    ixs = Tuple.((sample(1:T, Ds[1]; replace=!uniqueindex), sample(1:T, Ds[2]; replace=!uniqueindex)))
    allinds = ixs[1] ∪ ixs[2]
    iy = sample(allinds, min(Ds[3], length(allinds)); replace=!uniqueindex)
    if nodangling
        iy = Tuple(iy ∪ setdiff(allinds, iy))  # no dangling legs
    else
        iy = Tuple(iy)
    end
    xs = (randn(fill(2, Ds[1])...), randn(fill(2, Ds[2])...))
    if dynamic
        DynamicEinCode(ixs, iy)(xs...)
    else
        StaticEinCode{ixs,iy}()(xs...)
    end
end

function benchmark_compiletime(; D, nrepeat, dynamic, uniqueindex, nodangling, write=false)
    times = zeros(nrepeat)
    for i=1:nrepeat
        @show i
        times[i] = @elapsed random_contract(D, dynamic, uniqueindex, nodangling)
    end
    if write
        output_file=joinpath(@__DIR__, "compiletime_$(D)_$(dynamic)_$(uniqueindex).dat")
        writedlm(output_file, times)
    end
    return times
end

times = benchmark_compiletime(D=8, nrepeat=1000, dynamic=true, uniqueindex=true, nodangling=true, write=true)

#using Profile
#@profile for i=1:10 random_contract(8, true, true, true) end

"""
    EinsumBackend

Abstract type for einsum computation backends.

OMEinsum supports multiple backends for tensor contractions, allowing users
to choose the most appropriate implementation for their hardware and use case.

## Available Backends
- [`DefaultBackend`](@ref): Uses BLAS/CUBLAS with reshape/permute operations
- [`CuTensorBackend`](@ref): Uses NVIDIA cuTENSOR for native tensor contractions

## Usage
```julia
# Check current backend
get_einsum_backend()

# Change backend globally
set_einsum_backend!(CuTensorBackend())
```

See also: [`set_einsum_backend!`](@ref), [`get_einsum_backend`](@ref)
"""
abstract type EinsumBackend end

"""
    DefaultBackend <: EinsumBackend

Default backend using BLAS/CUBLAS for tensor contractions.

This backend reduces tensor contractions to matrix multiplications (GEMM) by:
1. Analyzing the contraction pattern to identify inner/outer/batch indices
2. Permuting tensors to canonical GEMM form if needed
3. Reshaping tensors to 2D/3D matrices
4. Calling optimized BLAS routines (`gemm!`, `gemm_strided_batched!`)
5. Reshaping and permuting the result back

## Pros
- Highly optimized for matrix-like contractions
- Works with any array type that supports `mul!`
- No additional library dependencies

## Cons
- Overhead from permute/reshape for non-GEMM patterns
- May allocate intermediate arrays

## Example
```julia
set_einsum_backend!(DefaultBackend())
ein"ij,jk->ik"(A, B)  # Uses BLAS gemm
```
"""
struct DefaultBackend <: EinsumBackend end

"""
    CuTensorBackend <: EinsumBackend

Backend using NVIDIA cuTENSOR library for native tensor contractions on GPU.

This backend calls cuTENSOR's `contract!` function directly, which:
- Handles arbitrary tensor contraction patterns natively
- Eliminates reshape/permute overhead
- Optimizes memory access patterns internally

## Requirements
- NVIDIA GPU with compute capability ≥ 6.0
- CUDA.jl v5.0 or later with cuTENSOR support

## Supported Types
- `Float16`, `Float32`, `Float64`
- `ComplexF16`, `ComplexF32`, `ComplexF64`

For unsupported types, automatically falls back to `DefaultBackend`.

## Pros
- No intermediate allocations for non-GEMM patterns
- Better performance for tensor network contractions
- Native support for arbitrary index patterns

## Cons
- Only available on NVIDIA GPUs with cuTENSOR
- Slightly higher overhead for simple GEMM patterns
- Limited to BLAS-compatible numeric types

## Example
```julia
using CUDA, cuTENSOR, OMEinsum

# Enable cuTENSOR backend
set_einsum_backend!(CuTensorBackend())

# Tensor contraction (benefits most from cuTENSOR)
A = CUDA.rand(Float32, 64, 64, 64)
B = CUDA.rand(Float32, 64, 64, 64)
C = ein"ijk,jkl->il"(A, B)  # Direct cuTENSOR call, no reshape needed
```

## When to Use
- Tensor network contractions (MPS, PEPS, etc.)
- High-dimensional tensor operations
- Contractions with complex index patterns like `ein"ijkl,klmn->ijmn"`

See also: [`DefaultBackend`](@ref), [`set_einsum_backend!`](@ref)
"""
struct CuTensorBackend <: EinsumBackend end

# Global backend configuration
const EINSUM_BACKEND = Ref{EinsumBackend}(DefaultBackend())

"""
    set_einsum_backend!(backend::EinsumBackend) -> EinsumBackend

Set the global backend for einsum operations.

!!! note
    This sets a global state. For thread-safe usage in concurrent code,
    consider using the same backend throughout or synchronizing access.

## Arguments
- `backend::EinsumBackend`: The backend to use.
  - `DefaultBackend()`: Use BLAS/CUBLAS (default)
  - `CuTensorBackend()`: Use cuTENSOR for GPU contractions

## Returns
The backend that was set.

## Example
```julia
using OMEinsum, CUDA

# Check current backend
get_einsum_backend()  # DefaultBackend()

# Switch to cuTENSOR
set_einsum_backend!(CuTensorBackend())

# Perform contractions with cuTENSOR
A = CUDA.rand(Float32, 100, 200)
B = CUDA.rand(Float32, 200, 300)
C = ein"ij,jk->ik"(A, B)

# Reset to default
set_einsum_backend!(DefaultBackend())
```

## Performance Comparison
```julia
using BenchmarkTools

A = CUDA.rand(Float32, 64, 64, 64)
B = CUDA.rand(Float32, 64, 64, 64)

# DefaultBackend: requires permute + reshape + GEMM + reshape
set_einsum_backend!(DefaultBackend())
@btime CUDA.@sync ein"ijk,jkl->il"(\$A, \$B)

# CuTensorBackend: direct tensor contraction
set_einsum_backend!(CuTensorBackend())
@btime CUDA.@sync ein"ijk,jkl->il"(\$A, \$B)
```

See also: [`get_einsum_backend`](@ref), [`EinsumBackend`](@ref)
"""
function set_einsum_backend!(backend::EinsumBackend)
    EINSUM_BACKEND[] = backend
    return backend
end

# Hook for extensions to check backend availability - returns (available::Bool, message::String)
check_backend_availability(::EinsumBackend) = (true, "")

# Registry for backend availability (used to avoid method overwriting during precompilation)
const _CUTENSOR_AVAILABLE = Ref{Bool}(false)

# Function reference for cuTENSOR einsum - set by CuTENSORExt when loaded
const _CUTENSOR_EINSUM_IMPL = Ref{Any}(nothing)

function _cutensor_einsum!(ixs, iy, xs, y, sx, sy, size_dict)
    impl = _CUTENSOR_EINSUM_IMPL[]
    if impl === nothing
        error("cuTENSOR extension not loaded. Please run `using cuTENSOR`.")
    end
    return impl(ixs, iy, xs, y, sx, sy, size_dict)
end

function check_backend_availability(::CuTensorBackend)
    if _CUTENSOR_AVAILABLE[]
        return (true, "")
    end
    return (false, "cuTENSOR.jl not loaded - run `using cuTENSOR` first")
end

function set_einsum_backend!(backend::CuTensorBackend)
    available, msg = check_backend_availability(backend)
    available || @warn "CuTensorBackend: $msg. Will fall back to CUBLAS."
    EINSUM_BACKEND[] = backend
end

"""
    get_einsum_backend() -> EinsumBackend

Get the current global einsum backend.

## Returns
The currently active `EinsumBackend` instance.

## Example
```julia
backend = get_einsum_backend()
if backend isa CuTensorBackend
    println("Using cuTENSOR")
else
    println("Using default BLAS/CUBLAS")
end
```

See also: [`set_einsum_backend!`](@ref), [`EinsumBackend`](@ref)
"""
get_einsum_backend() = EINSUM_BACKEND[]

"""
    CuTensorSupportedTypes

Union of numeric types supported by the cuTENSOR backend.

```julia
CuTensorSupportedTypes = Union{Float16, Float32, Float64, ComplexF16, ComplexF32, ComplexF64}
```

Arrays with element types not in this union will automatically fall back to
the default backend when `CuTensorBackend` is active.
"""
const CuTensorSupportedTypes = Union{Float16, Float32, Float64, ComplexF16, ComplexF32, ComplexF64}

using OMEinsum
using OMEinsum: cost_and_gradient
A, B, C = randn(2, 3), randn(3, 4), randn(4, 2)
y, g = cost_and_gradient(ein"(ij, jk), ki->", (A, B, C))

# evaluate the cost and the gradient of leaves
function gf(code, xs, res, ȳ = OMEinsum.init_gradient(code, xs))
    cost, tree = OMEinsum.gradient_tree(code, xs, ȳ)
    # extract the gradients on leaves (i.e. the input tensors).
    return cost, OMEinsum.extract_leaves!(code, tree, res)
end

using Zygote
xA, xB, xC = randn(2, 3), randn(3, 4), randn(4, 2)
function gfunc(A, B, C)
    ȳ = fill(one(eltype(A)))
    res = Zygote.Buffer(Any[nothing, nothing, nothing])
    cost, (gA, gB, gC) = gf(ein"(ij, jk), ki->", (A, B, C), res, ȳ)
    @info "summing"
    return sum(gA .* xA) + sum(gB .* xB) + sum(gC .* xC)
end
Zygote.gradient(gfunc, A, B, C)


zg = Zygote.gradient((a, b, c)->ein"(ij, jk), ki->"(a, b, c)[], A, B, C)
mg = gf(ein"(ij, jk), ki->", (A, B, C), Any[nothing, nothing, nothing])

using FiniteDiff
h = FiniteDiff.finite_difference_hessian(v->ein"(ij, jk), ki->"(reshape(v[1:6], 2, 3), reshape(v[7:18], 3, 4), reshape(v[19:end], 4, 2))[], [vec(A); vec(B); vec(C)])

using OMEinsum
using Test, Random

@testset "slice iterator" begin
    se = SlicedEinsum(['i', 'l'], ein"(ij,jk),(kl,lm)->im")
    it = OMEinsum.SliceIterator(se, uniformsize(se, 2))
    @test length(it) == 4
    for (i, v) in enumerate(it)
        @test v == it[i]
    end
end

@testset "SlicedEinsum" begin
    se = SlicedEinsum(['i', 'l'], ein"(ij,jk),(kl,lm)->im")
    @test OMEinsum.flatten(se) == OMEinsum.flatten(se.eins)
    @test labeltype(se) == Char
    xs = (randn(2,3), randn(3,4), randn(4,5), randn(5,6))
    size_info = Dict{Char,Int}()
    @test OMEinsum.get_size_dict!(se, xs, size_info) == Dict('i'=>2, 'j'=>3, 'k'=>4, 'l'=>5, 'm'=>6)
    @test getixsv(se) == [['i','j'],['j','k'],['k','l'],['l','m']]
    @test getiyv(se) == ['i','m']
    @test label_elimination_order(se) == ['j','l', 'k']
    for i=1:50
        expected = se.eins(xs...)
        @test se(xs...) ≈ expected
        y = similar(se(xs...))
        @test einsum!(se, xs, y, true, false, size_info) ≈ expected
        @test y ≈ expected
    end
    @test uniquelabels(se) == ['i', 'j', 'k', 'l', 'm']
    @test uniformsize(se, 2) == Dict(zip(['i', 'j', 'k', 'l', 'm'], ones(Int, 5).*2))
end

@testset "replace" begin
    code = ein"(ij, jk), kl->il"
    se = optimize_code(code, uniformsize(code, 2), TreeSA(;niters=0))
    se2 = replace(se, 'i'=>'a', 'j'=>'b', 'k'=>'c', 'l'=>'d')
    @test labeltype(se2) == Char
    @test se2 == SlicedEinsum(Char[], ein"(ab, bc), cd->ad")
end

using CUDA: device!
device!(0)
using BenchmarkTools, OMEinsum, CUDA
CUDA.allowscalar(false)

function bfunc_star(N::Int)
    ca = CUDA.curandn(Float32, N, N)
    res = CUDA.@sync ein"ji,kl,li->jkl"(ca,ca,ca)
    #res ≈ ein"ji,kl,li->jkl"(Matrix(ca),Matrix(ca), Matrix(ca))
end

function bfunc_t3(N::Int)
    ca = CUDA.curandn(Float32, N, N)
    ct = CUDA.curandn(Float32, N, N, N)
    CUDA.@sync ein"ji,kli,li->jkl"(ca,ct,ca)
end

function bfunc_psum(N::Int)
    cq = CUDA.curandn(Float32, N, N, N, N)
    CUDA.@sync ein"iikl->"(cq)
end

display(@benchmark bfunc_star(300) seconds = 1)
display(@benchmark bfunc_t3(300) seconds = 1)
display(@benchmark bfunc_psum(100) seconds = 1)

using BenchmarkTools, Plots

function plot_benchmark()
    res0 = BenchmarkTools.load(joinpath(@__DIR__, "OMEinsum_master.json"))[]
    res1 = BenchmarkTools.load(joinpath(@__DIR__, "OMEinsum_refactor.json"))[]
    t0 = Float64[]
    t1 = Float64[]
    xl = String[]
    for k in keys(res0)
        push!(t0, minimum(res0[k]["Float64"]["large"].times))
        push!(t1, minimum(res1[k]["Float64"]["large"].times))
        push!(xl, k)
    end
    xs = 1:length(res0)
    plot(xs, t0, marker = (:hexagon, 10, 0.6, :green, stroke(3, 0.2, :black, :dot)), yscale=:log10, lw=0, label="master")
    for i in xs
        annotate!(i+0.3, t1[i], text(xl[i], :black, :left, 12))
    end
    plot!(xs, t1, marker = (:circle, 10, 0.6, :red, stroke(3, 0.2, :black, :dot)), lw=0, label="refactor")
    #Plots.xticks!(xs, xl)
end

function plot_compile()
    pl = []
    for dynamic in [true, false]
        for uniqueindex in [true]
            times = readdlm(joinpath(@__DIR__, "compiletime_8_$(dynamic)_$(uniqueindex).dat"))
            push!(pl, plot(1:1000, times, label=(dynamic ? "dynamic" : "static") * " ($(round(sum(times); sigdigits=2)))", ylim=(0,2)))
        end
    end
    times = readdlm(joinpath(@__DIR__, "compiletime_8_false_true_master.dat"))
    push!(pl, plot(1:1000, times, label="master ($(round(sum(times); sigdigits=2)))", ylim=(0,2)))
    plt = plot(pl..., xlabel="iteration", ylabel="time", layout=(3,1))
end
#plot_benchmark()
plot_compile()

module OMEinsum

using TupleTools, Base.Cartesian, LinearAlgebra
using BatchedRoutines
using OMEinsumContractionOrders
using AbstractTrees
import LinearAlgebra: BlasFloat

export @ein_str, @ein, @ein!, ein, @optein_str
export einsum!, einsum, dynamic_einsum
export EinCode, EinIndexer, EinArray, DynamicEinCode, StaticEinCode, AbstractEinsum, NestedEinsum, SlicedEinsum, DynamicNestedEinsum, StaticNestedEinsum
export getiyv, getixsv, uniquelabels, labeltype
export flop
export loop_einsum, loop_einsum!, allow_loops
export asarray, asscalar
export cost_and_gradient

# re-export the functions in OMEinsumContractionOrders
export CodeOptimizer, CodeSimplifier,
    KaHyParBipartite, GreedyMethod, TreeSA, SABipartite, ExactTreewidth,
    MinSpaceDiff, MinSpaceOut,
    MergeGreedy, MergeVectors,
    uniformsize,
    optimize_code, optimize_permute,
    # time space complexity
    peak_memory, timespace_complexity, timespacereadwrite_complexity, flop, contraction_complexity,
    # file io
    writejson, readjson,
    label_elimination_order,
    # visualization
    viz_eins, viz_contraction

include("Core.jl")
include("loop_einsum.jl")
include("utils.jl")

include("unaryrules.jl")
include("binaryrules.jl")
include("matchrule.jl")
include("einsum.jl")

include("interfaces.jl")
include("einsequence.jl")
include("slicing.jl")
include("autodiff.jl")
include("bp.jl")

include("contractionorder.jl")

include("deprecation.jl")
end # module

using Documenter, OMEinsum

makedocs(;
    modules=[OMEinsum],
    format=Documenter.HTML(),
    pages=[
        "Home" => "index.md",
        "Background: Tensor Networks" => "background.md",
        "Basic usage" => "basic.md",
        "Contraction order optimization" => "contractionorder.md",
        "Automatic differentiation" => "autodiff.md",
        "CUDA" => "cuda.md",
        "Applications" => "applications.md",
        "Manual" => "docstrings.md"
    ],
    repo="https://github.com/under-Peter/OMEinsum.jl/blob/{commit}{path}#L{line}",
    sitename="OMEinsum.jl",
    authors="Andreas Peter",
)

deploydocs(;
    repo="github.com/under-Peter/OMEinsum.jl",
)

using Test
using OMEinsum
using OMEinsum: subindex, dynamic_indexer, DynamicEinCode, StaticEinCode, getixs, getiy, labeltype, einarray

@testset "EinCode" begin
    code = EinCode(((1,2), (2,3)), (1,3))
    @test code isa EinCode
    @test OMEinsum.getixs(code) == [[1,2], [2,3]]
    @test OMEinsum.getiy(code) == [1,3]

    @test DynamicEinCode(([1,2], [2,3]), [1,3]) == code
    @test DynamicEinCode([[1,2], [2,3]], [1,3]) == code

    code1 = ein"ab,bc->ac"
    code2 = EinCode((('a', 'b'), ('b', 'c')), ('a', 'c'))
    @test code2 isa DynamicEinCode
    @test code1 isa StaticEinCode
    @test DynamicEinCode(code1) == code2
    @test StaticEinCode(code2) === code1
    @test collect(collect.(getixs(code1))) == getixs(code2)
    @test collect(getiy(code1)) == getiy(code2)
    @test labeltype(code1) == labeltype(code2)

    code1 = ein",->"
    code2 = EinCode(((), ()), ())
    @test collect(collect.(getixs(code1))) == getixs(code2)
    @test collect(getiy(code1)) == getiy(code2)
    @test labeltype(code1) == Char
    @test labeltype(code2) == Union{}

    code1 = ein"->"
    code2 = EinCode(((),), ())
    @test collect(collect.(getixs(code1))) == getixs(code2)
    @test collect(getiy(code1)) == getiy(code2)
    @test labeltype(code1) == Char
    @test labeltype(code2) == Union{}

    @test_throws ErrorException EinCode((), ())
end

@testset "indexer" begin
    si = EinIndexer{()}(())
    @test subindex(si, (1,2,3)) == 1
    si = EinIndexer{(3,2)}((7,6))
    @test OMEinsum.getlocs(si) == (3,2)
    a = randn(7,6)
    @test a[subindex(si, (4,5,2))] == a[2,5]
end

@testset "dynamic indexer" begin
    si = dynamic_indexer((), ())
    @test subindex(si, (1,2,3)) == 1
    si = dynamic_indexer((3,2), (7,6))
    @test OMEinsum.getlocs(si) == (3,2)
    a = randn(7,6)
    @test a[subindex(si, (4,5,2))] == a[2,5]
end

@testset "EinArray" begin
    locs_xs = (EinIndexer{(1,2)}((8,8)), EinIndexer{(2,3)}((8,8)))
    ixs = ((1,2), (2,3))
    iy = (1,3)
    x1 = randn(8, 8)
    x2 = randn(8, 8)
    arr = einarray(Val(ixs), Val(iy), (x1, x2), OMEinsum.get_size_dict!(ixs, (x1, x2), Dict{Int,Int}()))
    @test size(arr) == (8,8,8)
    # inner first, then outer
    @test arr[CartesianIndex((3,4,2))] == x1[4,3]*x2[3,2]
    @test arr[3,4,2] == x1[4,3]*x2[3,2]
end

@testset "replace" begin
    a = DynamicEinCode([[1,2,3,4], [1,3]], [1,2,3,4])
    b = replace(a, 1=>5, 2=>6)
    @test labeltype(b) == Int
    @test b.ixs == [[5,6,3,4], [5,3]]
    @test b.iy == [5,6,3,4]

    a = StaticEinCode{Int, ((1,2,3,4), (1,3)), (1,2,3,4)}()
    b = replace(a, 1=>5, 2=>6)
    @test labeltype(b) == Int
    @test OMEinsum.getixs(b) == ((5,6,3,4), (5,3))
    @test OMEinsum.getiy(b) == (5,6,3,4)
end

using OMEinsum, Test
using OMEinsum: match_rule, DefaultRule, Diag, Sum, Tr, Permutedims, Duplicate, SimpleBinaryRule, Identity, nopermute

@testset "fix rule cc,cb->bc" begin
    @test OMEinsum.match_rule_binary([3], [1], [1,3]) isa OMEinsum.SimpleBinaryRule
    @test OMEinsum.match_rule_binary([1,3], [2,3], [1,2,3]) isa OMEinsum.SimpleBinaryRule
    @test OMEinsum.match_rule_binary([3], [3], [3,3]) isa OMEinsum.DefaultRule
    @test OMEinsum.match_rule_binary([3], [3, 3], [3]) isa OMEinsum.DefaultRule
    @test OMEinsum.match_rule_binary([3, 3], [3], [3]) isa OMEinsum.DefaultRule
    @test OMEinsum.match_rule_binary([3,3], [3, 3], [3,3]) isa OMEinsum.DefaultRule
    @test OMEinsum.match_rule_binary([3, 3], [3,2], [2,3]) isa OMEinsum.DefaultRule
    @test OMEinsum.match_rule_binary([3,1], [1, 3], [3,3]) isa OMEinsum.DefaultRule
    @test OMEinsum.match_rule_binary([1,3], [3, 3], [1,3]) isa OMEinsum.DefaultRule
    @test OMEinsum.match_rule_binary([3,3], [3], [3,3]) isa OMEinsum.DefaultRule
end

@testset "match rule" begin
    ixs = ((1,2), (2,3))
    iy = (1,3)
    @test match_rule(ixs, iy) == SimpleBinaryRule(ein"ij,jk->ik")
    @test match_rule(EinCode(ixs, iy)) == SimpleBinaryRule(ein"ij,jk->ik")

    ixs = ((1,2), (2,3), (3,4))
    iy = (1,4)
    @test match_rule(ixs, iy) == DefaultRule()

    ixs = ((1,1),)
    iy = ()
    @test match_rule(ixs, iy) == Tr()

    ixs = ((1,1,2),)
    iy = (2,)
    @test match_rule(ixs, iy) == DefaultRule()

    ixs = ((1,2),)
    iy = (1,)
    @test match_rule(ixs, iy) == Sum()

    ixs = ((1,2,3),)
    iy = (2,1,3)
    @test match_rule(ixs, iy) != Sum()

    ixs = ((1,2),(1,2),(1,2))
    iy = (1,2)
    @test match_rule(ixs, iy) == DefaultRule()

    ixs = ((1,2,3),)
    iy = (1,3,2)
    @test match_rule(ixs, iy) == Permutedims()

    ixs = ((1,2),)
    iy = (1,1)
    @test match_rule(ixs, iy) == DefaultRule()

    ix = (1,2,3)
    iy = (1,2)
    @test nopermute(ix,iy)

    ix = (1,2,3)
    iy = (2,1)
    @test !nopermute(ix,iy)

    # 3-argument match_rule
    @test match_rule(((1,1),), ()) == Tr()
    @test match_rule(((1,2),), ()) == Sum()
    @test match_rule(((1,1),), (1,)) == Diag()

    @test match_rule(((1,2),(2,3),(3,4),(4,5)), (1,5)) == DefaultRule()
    @test match_rule(((1,2),(2,3),(5,4),(3,4)), (1,5)) == DefaultRule()
    @test match_rule(((1,2),(2,3),(3,4),(3,5)), (1,5)) == DefaultRule()

    @test match_rule(((1,2,3,4),), (1,2)) == Sum()
    @test match_rule(((1,2,3,4),), (1,2)) == Sum()
    @test match_rule(((1,2,3,4),), (1,2,3,4)) == Identity()
    @test match_rule(((1,2,3,4),), (2,1)) == Sum()
    @test match_rule(((1,2,3,4),), (2,1,1)) == DefaultRule()

    @test match_rule(((1,2),), (2,1)) == Permutedims()
    @test match_rule(((1,2,3),), (2,1)) == Sum()
    @test match_rule(((3,3),), (1,3)) == DefaultRule()

    @test match_rule(((1,2),(1,2)), (1,2)) == DefaultRule()
    @test match_rule(((1,2),(2,1)), (1,2)) == DefaultRule()
    @test match_rule(((1,2),(1,2)), (1,2,1)) == DefaultRule()

    @test match_rule(((1,1,2),), (2,)) == DefaultRule()
    @test match_rule(((1,1,2,3),), (2,3)) == DefaultRule()
    @test match_rule(((1,1,2,3),), (3,2)) == DefaultRule()
    @test match_rule(((1,1,2),), (1,2,)) == Diag()

    @test match_rule(((1,2),(2,3)), (1,3)) == SimpleBinaryRule(ein"ij,jk->ik")
    @test match_rule(((1,2),(2,3)), (3,1)) == SimpleBinaryRule(ein"ij,jk->ki")
    @test match_rule(((2,1),(2,3)), (3,1)) == SimpleBinaryRule(ein"ji,jk->ki")
    @test match_rule(((2,1),(3,2)), (3,1)) == SimpleBinaryRule(ein"ji,kj->ki")
    @test match_rule(((1,2,3),(2,3,4)), (1,4)) == DefaultRule()

    @test match_rule(((1,2,3),), (1,2,3)) == Identity()
    @test match_rule(((1,2,3),), (1,3,2)) == Permutedims()

    @test match_rule(((1,2,1),), (1,2)) == Diag()
    @test match_rule(((1,2),), (1,2,1)) == Duplicate()
end

@testset "isbatchmul" begin
    @test match_rule(((1,2), (2,3)), (1,3)) == SimpleBinaryRule(ein"ij,jk->ik") # matmul
    @test match_rule(((1,2,3), (2,3)), (1,3)) == SimpleBinaryRule(ein"ijl,jl->il") # matvec-batched
    @test match_rule(((7,1,2,3), (2,4,3,7)), (1,4,3)) == DefaultRule() # matmat-batched
    @test match_rule(((3,), (3,)), (3,)) == SimpleBinaryRule(ein"l,l->l")  # pure batch
    @test match_rule(((3,1), (3,)), (3,1)) == DefaultRule()  # batched vector-vector
    @test match_rule(((2,2), (2,3)), (1,3)) == DefaultRule()
    @test match_rule(((2,1), (2,3)), (1,1)) == DefaultRule()
    @test match_rule(((1,2,3), (2,4,3)), (1,3)) == DefaultRule()
end

@testset "match_rule eye candies" begin
    @test match_rule(ein"ij,jk,kl->il") == DefaultRule()
end

using Test
using OMEinsum
using OMEinsum: StaticEinCode, DynamicEinCode
using Zygote, ForwardDiff

@doc raw"
    bpcheck(f, args...; η = 1e-5, verbose=false)
returns a `Bool` indicating whether Zygote calculates the gradient of `f(args...) -> scalar`
correctly using the relation `f(x - ηg) ≈ f(x) - η|g|²` with a relative tolerance
of 1e-2 and an absolute tolerance of 1e-8.
If `verbose=true`, print `f(x) - f(x - ηg)`and `η|g|²`.

# example

```jldoctest; setup = :(using OMEinsum)
julia> using OMEinsum: bpcheck

julia> a, b = rand(2,2), rand(2,2);

julia> bpcheck(sum ∘ ein\"ij,jk -> ik\", a, b)
true
```
"
function bpcheck(f, args...; η = 1e-5, verbose = false)
    g = gradient(f, args...)
    all(==(nothing), g) && error()
    dy_ref = 0
    for x in g
        x === nothing && continue
        x isa Tuple && (dy_ref += η * mapreduce(y -> y == nothing ? 0 : sum(abs2,y), +, x))
        x isa AbstractArray && (dy_ref += η * sum(abs2,x))
    end
    dy = f(args...) - f([gi === nothing ? arg : arg .- η .* gi for (arg, gi) in zip(args,g)]...)

    verbose && @show dy
    verbose && @show dy_ref

    isapprox(dy, dy_ref, rtol=1e-2, atol=1e-8)
end


@testset "einsum bp" begin
    for T in (Float64, ComplexF64)
        @testset "$T" begin
            # matrix and vector multiplication
            a,b,c = rand(T,2,2), rand(T,2,2), rand(T,2,2)
            v = rand(T,2)
            t = randn(2,2,2,2)
            @test bpcheck( (a,b,c) -> einsum(EinCode(((1,2),(2,3),(3,4)), (1,4)), (a,b,c)) |> abs ∘ sum ,a,b,c)
            @test bpcheck( (a,b,c) -> einsum(EinCode(((1,2),(2,3),(3,4)), (4,1)), (a,b,c)) |> abs ∘ sum ,a,b,c)
            @test bpcheck((a,v) -> einsum(EinCode(((1,2),(2,)), (1,)), (a,v)) |> abs ∘ sum , a, v)
            @test bpcheck((a,v) -> einsum(StaticEinCode{Int, ((1,2),(2,)), (1,)}(), (a,v)) |> abs ∘ sum , a, v)
            @test bpcheck((a,t,v) -> ein"(ab,abcd),c->ad"(a,t,v) |> abs ∘ sum ,a,T.(t),v)

            # contract to 0-dim array
            @test bpcheck((a,b) -> einsum(EinCode(((1,2),(1,2)), ()), (a,b)) |> abs ∘ sum , a,b)

            # trace
            @test bpcheck(a -> einsum(EinCode(((1,1),), ()), (a,)) |> abs ∘ sum, a)
            aa = rand(T,2,4,4,2)
            @test bpcheck(aa -> einsum(EinCode(((1,2,2,1),), ()), (aa,)) |> abs ∘ sum, aa)

            # partial trace
            @test bpcheck(aa -> einsum(EinCode(((1,2,2,3),), (1,3)), (aa,)) |> abs ∘ sum, aa)

            # diag
            @test bpcheck(aa -> einsum(EinCode(((1,2,2,3),), (1,2,3)), (aa,)) |> abs ∘ sum, aa)

            # permutation
            @test bpcheck(a -> einsum(EinCode(((1,2),), (2,1)), (a,)) |> abs ∘ sum, a)
            @test bpcheck(t -> einsum(EinCode(((1,2,3,4),),(2,3,1,4)), (t,)) |> abs ∘ sum, t)

            # tensor contraction
            @test bpcheck((t,a) -> einsum(EinCode(((1,2,3,4), (2,3)), (1,4)), (t,a)) |> abs ∘ sum, t,a)
            @test bpcheck((t,a) -> einsum(EinCode(((4,3,2,1), (2,3)), (1,4)), (t,a)) |> abs ∘ sum, t,a)

            # star-contraction
            @test bpcheck((a,b,c) -> einsum(EinCode(((1,2),(1,3),(1,4)), (2,3,4)), (a,b,c)) |> abs ∘ sum, a,b,c)

            # star and contract
            @test bpcheck((a,b,c) -> einsum(EinCode(((1,2),(1,2),(1,3)), (3,)), (a,b,c)) |> abs ∘ sum, a,b,c)

            # index-sum
            a3 = rand(T,2,2,2)
            @test bpcheck(a -> einsum(EinCode(((1,2,3),),(1,2)),(a,)) |> abs ∘ sum, a3)

            # Hadamard product
            @test bpcheck((a,b) -> einsum(EinCode(((1,2),(1,2)), (1,2)), (a,b)) |> abs ∘ sum, a, b)

            # Outer
            @test bpcheck((a,b) -> einsum(EinCode(((1,2),(3,4)),(1,2,3,4)),(a,b)) |> abs ∘ sum, a, b)
        end
    end
end

@testset "gradient type check" begin
    array_match(x, y) = typeof(x) == typeof(y) && size(x) == size(y)
    a = randn(3,3)
    b = randn(3,3)
    @test array_match(gradient(a->einsum(EinCode(((1,2), (2,1)), ()), (a, b))[] |> abs, a)[1], a)
    b = randn(ComplexF64,3,3)
    @test array_match(gradient(a->einsum(EinCode(((1,2), (2,1)), ()), (a, b))[] |> abs, a)[1], a)
    a = randn(ComplexF64,3,3)
    @test array_match(gradient(a->einsum(EinCode(((1,2), (2,3)), ()), (a, b))[] |> abs, a)[1], a)
    b = randn(3,3)
    @test array_match(gradient(a->einsum(EinCode(((1,2), (2,3)), ()), (a, b))[] |> abs, a)[1], a)
end

@testset "string-specification" begin
    a,b,c = rand(2,2), rand(2,2), rand(2,2)
    v = rand(2)
    @test bpcheck((a,b,c) -> einsum(ein"ij,jk,kl -> il", (a,b,c)) |> abs ∘ sum ,a,b,c)
    @test bpcheck((a,b,c) -> einsum(ein"ij,jk,kl -> li", (a,b,c)) |> abs ∘ sum ,a,b,c)
    @test bpcheck((a,v) -> einsum(ein"ij,j -> i", (a,v)) |> abs ∘ sum , a, v)
end

@testset "sequence specification" begin
    a, b, c = rand(2,2), rand(2,2), rand(2,2)
    @test all(gradient(sum ∘ ein"ij,jk,kl -> il", a, b, c) .≈
          gradient(sum ∘ ein"(ij,(jk,kl)) -> il", a, b, c))
end

@testset "hessian" begin
    loss(x) = sin(ein"ij->"(x)[])
    x = randn(2, 2)
    @test Zygote.hessian(loss, x) == ForwardDiff.hessian(loss, x)
end

using OMEinsum, Test
using OMEinsum: SimpleBinaryRule, match_rule, binary_einsum!
using Polynomials: Polynomial

@testset "analyse binary" begin
    size_dict = Dict(1=>1, 2=>2, 3=>3, 4=>4, 6=>6, 7=>7, 8=>8)
    c1, c2, cy, s1, s2, s3, is, js, ys = OMEinsum.analyze_binary([1,2,3,4,8], [2,6,6,8,4,2], [7,2,1,2,2,6], size_dict)
    @test c1 == [1,4,8,2]
    @test c2 == [4,8,6,2]
    @test cy == [1,6,2]
    @test s1 == [1,32,2]
    @test s2 == [32,6,2]
    @test is == ['i', 'j', 'l']
    @test js == ['j', 'k', 'l']
    @test ys == ['i', 'k', 'l']
end

@testset "binary rules" begin
    size_dict = Dict(zip(('i', 'j', 'k', 'l'), ntuple(x->5, 4)))
    nmatch = 0
    for has_batch in [true, false]
        for i1 in [(), ('i',), ('j',), ('i','j'), ('j', 'i')]
            for i2 in [(), ('k',), ('j',), ('k','j'), ('j', 'k')]
                for i3 in [(), ('i',), ('k',), ('i','k'), ('k', 'i')]
                    @info i1, i2, i3, has_batch
                    i1_ = has_batch ? (i1..., 'l') : i1
                    i2_ = has_batch ? (i2..., 'l') : i2
                    i3_ = has_batch ? (i3..., 'l') : i3
                    a = randn(fill(5, length(i1_))...) |> OMEinsum.asarray
                    b = randn(fill(5, length(i2_))...) |> OMEinsum.asarray
                    code = EinCode((i1_,i2_),i3_)
                    rule = match_rule(code)
                    if rule isa SimpleBinaryRule
                        nmatch += 1
                        out = OMEinsum.get_output_array((a, b), [size_dict[l] for l in getiyv(code)], false)
                        @test binary_einsum!(rule, a, b, out, true, false) ≈ loop_einsum(code, (a, b), size_dict)
                    else
                        @test einsum(code, (a, b), size_dict) ≈ loop_einsum(code, (a, b), size_dict)
                    end
                end
            end
        end
    end
    @test nmatch == 36
end

@testset "match binary rules" begin
    for code in [ein",->", ein",k->k", ein"i,->i", ein"j,j->", ein"i,k->ik", ein"i,k->ki",
                ein"j,jk->k", ein"j,kj->k", ein"ji,j->i", ein"ij,j->i", ein"ji,jk->ik",
                ein"ji,kj->ik", ein"ji,jk->ki", ein"ji,kj->ki", ein"ij,jk->ik", ein"ij,kj->ik", ein"ij,jk->ki", ein"ij,kj->ki"]
        @test OMEinsum.match_rule(code) == SimpleBinaryRule(code)
    end
    OMEinsum.match_rule(ein"ab,bc->ac") == SimpleBinaryRule(('i', 'j'), ('j', 'k'), ('i', 'k'))
    OMEinsum.match_rule(ein"ab,bce->ac") == OMEinsum.DefaultRule()
end 

@testset "binary einsum" begin
    for code in [
        ein",->",
        ein"ijl,jl->il",
        ein"ab,bc->ac",
        ein"abb,bc->ac",  # with diag in
        ein"ab,bc->acc",  # with diag out
        ein"ab,bce->ac",  # with sum in
        ein"ab,bc->ace",  # with sum out
        ein"bal,bcl->lcae",  # with perm in
        ein"bal,bcl->ca",  # with multi-edge in
        ein"bal,bc->lca",  # with multi-edge out
        ein"ddebal,bcf->lcac",  # with all
    ]
        xs = [OMEinsum.asarray(randn(ComplexF64, fill(5, length(ix))...)) for ix in OMEinsum.getixs(code)]
        size_dict = Dict(zip(('a', 'b', 'c', 'd', 'e', 'f','i','j','k','l'), ntuple(x->5, 10)))
        @test einsum(code, (xs...,), size_dict) ≈ loop_einsum(code, (xs...,), size_dict)
    end
end

@testset "regression test" begin
    x, y = randn(fill(2, 8)...), randn(fill(2, 5)...)
    code = EinCode(((10, 5, 4, 2, 6, 6, 7, 9), (1, 9, 8, 2, 10)), (4, 10, 9, 7, 10))
    @test code(x, y) ≈ loop_einsum(code, (x, y), OMEinsum.get_size_dict(OMEinsum.getixs(code), (x, y)))
end

@testset "polynomial scalar mul" begin
    @test ein",->"(OMEinsum.asarray(Polynomial([1.0])), OMEinsum.asarray(Polynomial([1.0]))) isa AbstractArray
end

"""
    SlicedEinsum{LT, Ein} <: AbstractEinsum

A tensor network with slicing. `LT` is the label type and `Ein` is the tensor network.

### Fields
- `slicing::Vector{LT}`: A vector of labels to slice.
- `eins::Ein`: The tensor network.
"""
struct SlicedEinsum{LT, Ein} <: AbstractEinsum
    slicing::Vector{LT}
    eins::Ein
end
Base.:(==)(se::SlicedEinsum, se2::SlicedEinsum) = se.slicing == se2.slicing && se.eins == se2.eins
function Base.replace(se::SlicedEinsum, pairs::Pair...)
    SlicedEinsum(replace(se.slicing, pairs...), replace(se.eins, pairs...))
end

# Iterate over tensor network slices, its iterator interface returns `slicemap` as a Dict
# slice and fill tensors with
# * take_slice(x, label_of_x, slicemap)
# * fill_slice!(x, label_of_x, x_slice, slicemap)
struct SliceIterator{LT,IT<:CartesianIndices}
    ixsv::Vector{Vector{LT}}
    iyv::Vector{LT}
    sliced_labels::Vector{LT}
    indices::IT
    size_dict_sliced::Dict{LT,Int}
end

function SliceIterator(se::SlicedEinsum, size_dict::Dict{LT}) where LT
    iyv = getiyv(se)
    ixsv = getixsv(se)
    return SliceIterator(ixsv, iyv, se.slicing, size_dict)
end

function SliceIterator(ixsv, iyv, legs, size_dict::Dict{LT}) where LT
    n = length(legs)
    size_dict_sliced = copy(size_dict)
    sliced_sizes = Vector{Int}(undef, n)
    sliced_labels = Vector{LT}(undef, n)
    for i = 1:n
        l = legs[i]
        sliced_sizes[i] = size_dict[l]
        sliced_labels[i] = l
        size_dict_sliced[l] = 1
    end
    indices = CartesianIndices((sliced_sizes...,))
    SliceIterator(ixsv, iyv, sliced_labels, indices, size_dict_sliced)
end
Base.length(si::SliceIterator) = length(si.indices)
Base.eltype(::Type{SliceIterator{LT,IT}}) where {LT,IT} = Dict{LT,Int}

# returns `slicemap` as a Dict
function Base.iterate(si::SliceIterator)
    ci, cistate = iterate(si.indices)
    slicemap = Dict(zip(si.sliced_labels, ones(Int,length(si.sliced_labels))))
    slicemap, (1,(ci,cistate),slicemap)
end
function Base.iterate(si::SliceIterator, state)
    i, (ci,cistate), slicemap = state
    if i >= length(si.indices)
        return nothing  # NOTE: ci is same as cistate
    else
        ci, cistate = iterate(si.indices, cistate)
        for (l, v) in zip(si.sliced_labels, ci.I)
            slicemap[l] = v
        end
        return slicemap, (i+1, (ci,cistate), slicemap)
    end
end
function Base.getindex(si::SliceIterator, indices...)
    ci = si.indices[indices...]
    slicemap = Dict(zip(si.sliced_labels, ci.I))
    return slicemap
end

function take_slice(x, ix, slicemap::Dict)
    slices = map(l->haskey(slicemap, l) ? slicemap[l] : Colon(), ix)
    if all(x->x isa Integer, slices)
        return copy(view(x,slices...))
    else
        return x[slices...]
    end
end
function fill_slice!(x, ix, chunk, slicemap::Dict)
    if ndims(x) == 0
        x .+= chunk  # to avoid CUDA `getindex!`.
    else
        slices = map(l->haskey(slicemap, l) ? slicemap[l] : Colon(), ix)
        view(x, slices...) .+= chunk
    end
    return x
end
function view_slice(x, ix, slicemap::Dict)
    if ndims(x) == 0
        return x
    else
        slices = map(l->haskey(slicemap, l) ? slicemap[l] : Colon(), ix)
        return view(x, slices...)
    end
end

function (se::SlicedEinsum{LT,ET})(@nospecialize(xs::AbstractArray...); size_info = nothing, kwargs...) where {LT, ET}
    # get size
    size_dict = size_info===nothing ? Dict{labeltype(se),Int}() : copy(size_info)
    get_size_dict!(se, xs, size_dict)
    # compute
    return einsum(se, xs, size_dict; kwargs...)
end

function einsum!(se::SlicedEinsum, @nospecialize(xs::NTuple{N,AbstractArray} where N), y, sx, sy, size_dict::Dict)
    length(se.slicing) == 0 && return einsum!(se.eins, xs, y, sx, sy, size_dict)
    iszero(sy) ? fill!(y, zero(eltype(y))) : rmul!(y, sy)
    it = SliceIterator(se, size_dict)
    eins_sliced = drop_slicedim(se.eins, se.slicing)
    for slicemap in it
        xsi = ntuple(i->take_slice(xs[i], it.ixsv[i], slicemap), length(xs))
        einsum!(eins_sliced, xsi, view_slice(y, it.iyv, slicemap), sx, true, it.size_dict_sliced)
    end
    return y
end
function einsum(se::SlicedEinsum, @nospecialize(xs::NTuple{N,AbstractArray} where N), size_dict::Dict)
    length(se.slicing) == 0 && return einsum(se.eins, xs, size_dict)
    it = SliceIterator(se, size_dict)
    # Note: the output array must be initialized to 0!
    res = get_output_array(xs, getindex.(Ref(size_dict), it.iyv), true)
    eins_sliced = drop_slicedim(se.eins, se.slicing)
    for slicemap in it  # `slicemap` is a Dict storing a mapping from sliced_labels to the current slice index
        # NOTE: @debug will break Zygote
        # @debug "computing slice $k/$(length(it))"
        xsi = ntuple(i->take_slice(xs[i], it.ixsv[i], slicemap), length(xs))
        resi = einsum(eins_sliced, xsi, it.size_dict_sliced)
        res = fill_slice!(res, it.iyv, resi, slicemap)
    end
    return res
end

function drop_slicedim(ne::NestedEinsum, slices::Vector)
    isleaf(ne) && return ne
    eins = rootcode(ne)
    ixs = map(ix->filter(∉(slices), ix), getixsv(eins))
    iy = filter(∉(slices), getiyv(eins))
    NestedEinsum(map(arg->drop_slicedim(arg, slices), siblings(ne)), similar_eincode(eins, ixs, iy))
end
similar_eincode(::DynamicEinCode, ixs, iy) = DynamicEinCode(ixs, iy)
similar_eincode(::StaticEinCode{LT}, ixs, iy) where LT = StaticEinCode{LT,(Tuple.(ixs)...,), (iy...,)}()

flatten(se::SlicedEinsum) = flatten(se.eins)
labeltype(::SlicedEinsum{LT}) where LT = LT
get_size_dict!(se::SlicedEinsum, xs, size_info::Dict) = get_size_dict!(se.eins, xs, size_info)
getixsv(se::SlicedEinsum) = getixsv(se.eins)
getiyv(se::SlicedEinsum) = getiyv(se.eins)

using OMEinsum, Test, Zygote

@testset "bp check" begin
    A, B, C = randn(2, 3), randn(3, 4), randn(4, 2)
    cost0 = ein"(ij, jk), ki->"(A, B, C)[]
    zg = Zygote.gradient((a, b, c)->ein"(ij, jk), ki->"(a, b, c)[], A, B, C)
    cost, mg = OMEinsum.cost_and_gradient(ein"(ij, jk), ki->", (A, B, C))
    @test cost[] ≈ cost0
    @test all(zg .≈ mg)

    code = optimize_code(ein"ij, jk, ki->", uniformsize(ein"ij, jk, ki->", 2), TreeSA())
    cost0 = code(A, B, C)[]
    zg = Zygote.gradient((a, b, c)->code(a, b, c)[], A, B, C)
    cost, mg = OMEinsum.cost_and_gradient(code, (A, B, C))
    @test cost[] ≈ cost0
    @test all(zg .≈ mg)
end

module CuTENSORExt

using OMEinsum: EinsumBackend, DefaultBackend, CuTensorBackend, get_einsum_backend, CuTensorSupportedTypes, _CUTENSOR_AVAILABLE, _CUTENSOR_EINSUM_IMPL
import OMEinsum
using cuTENSOR
@static if pkgversion(cuTENSOR) >= v"6"
    using cuTENSOR.CUDACore: CuArray
else
    using cuTENSOR.CUDA: CuArray
end

# Set flags at module initialization (runtime), not precompilation time
function __init__()
    _CUTENSOR_AVAILABLE[] = true
    _CUTENSOR_EINSUM_IMPL[] = cutensor_einsum!
end

"""
    cutensor_einsum!(ixs, iy, xs::NTuple{2,CuArray{T}}, y::CuArray{T}, sx, sy, size_dict) where T

Perform binary tensor contraction using cuTENSOR.jl.
This provides native tensor contraction without reshape/permute overhead.
"""
function cutensor_einsum!(
    ixs, iy,
    xs::NTuple{2,CuArray{T}}, y::CuArray{T},
    sx, sy, size_dict
) where {T<:CuTensorSupportedTypes}
    if length(ixs) != 2
        error("cuTENSOR backend only supports binary contractions")
    end
    
    A, B = xs
    ix1, ix2 = ixs[1], ixs[2]
    
    # Convert labels to vectors (cuTENSOR accepts Char or Integer indices)
    modes_A = collect(ix1)
    modes_B = collect(ix2)
    modes_C = collect(iy)
    
    # cuTENSOR.contract!(α, A, Ainds, opA, B, Binds, opB, β, C, Cinds, opC, opOut)
    cuTENSOR.contract!(
        T(sx), A, modes_A, cuTENSOR.OP_IDENTITY,
        B, modes_B, cuTENSOR.OP_IDENTITY,
        T(sy), y, modes_C, cuTENSOR.OP_IDENTITY,
        cuTENSOR.OP_IDENTITY
    )
    
    return y
end

@debug "OMEinsum: cuTENSOR extension loaded"

end

using ChainRulesCore

@doc raw"
    einsum_grad(ixs, xs, iy, size_dict, cdy, i)

return the gradient of the result of evaluating the `EinCode` w.r.t
the `i`th tensor in `xs`. `cdy` is the result of applying the `EinCode`
to the `xs`.

# example
```jldoctest; setup = :(using OMEinsum)
julia> using OMEinsum: einsum_grad, get_size_dict

julia> a, b = rand(2,2), rand(2,2);

julia> c = einsum(EinCode((('i','j'),('j','k')), ('i','k')), (a,b));

julia> sd = get_size_dict((('i','j'),('j','k')), (a,b));

julia> einsum_grad((('i','j'),('j','k')), (a,b), ('i','k'), sd, c, 1) ≈ c * transpose(b)
true
```
"
function einsum_grad(ixs, @nospecialize(xs), iy, size_dict, dy, i)
    nixs = _insertat(ixs, i, iy)
    nxs  = _insertat( xs, i, conj(dy))
    niy = ixs[i]
    y = einsum(DynamicEinCode(nixs, niy), nxs, size_dict)
    return ChainRulesCore.ProjectTo(xs[i])(conj(y))  # do not use `conj!` because we want to support Hessians.
end
function einsum_backward_rule(eins, @nospecialize(xs), @nospecialize(y), size_dict, @nospecialize(dy))
    return ntuple(i -> einsum_grad(getixs(eins), xs, getiy(eins), size_dict, dy, i), length(xs))
end

function ChainRulesCore.rrule(::typeof(einsum), code::EinCode, @nospecialize(xs), size_dict)
    y = einsum(code, xs, size_dict)
    function einsum_pullback(dy)
        dy = convert(typeof(y), unthunk(dy))  # for filled array/cuarray et al.
        dxs = ntuple(i -> (ChainRulesCore.@thunk einsum_grad(getixs(code), xs, getiy(code), size_dict, dy, i)), length(xs))
        return (NoTangent(), NoTangent(), dxs, NoTangent())
    end
    einsum_pullback(::NoTangent) = (NoTangent(), NoTangent(), NoTangent(), NoTangent())
    return y, einsum_pullback
end

function ChainRulesCore.rrule(::typeof(_safe_set), lst, i, x)
    y = _safe_set(lst, i, x)
    function set_pullback(dy)
        return (NoTangent(), dy, NoTangent(), dy[i])
    end
    set_pullback(::NoTangent) = (NoTangent(), NoTangent(), NoTangent(), NoTangent())
    return y, set_pullback
end

@non_differentiable get_size_dict!(::Any, ::Any, ::Any)
@non_differentiable DynamicEinCode(::Any, ::Any)
@non_differentiable DynamicEinCode(::Any)
@non_differentiable getixsv(::Any)

echo(x; tag="echo") = x
function ChainRulesCore.rrule(::typeof(echo), x; tag="echo")
    @info "$tag: $x"
    x, function (dy)
        @info "$tag (back): x̄ = $dy"
        return (NoTangent(), dy)
    end
end

macro echo(var)
    name = QuoteNode(var)
    esc(:($var = $echo($var; tag="$($name)")))
end

# A general unary operation uses the following pipeline
# 0. special rules `Identity` and `Tr`,
# 1. rules reducing dimensions `Diag` and `Sum`
# 2. `Permutedims`,
# 3. `Repeat` and `Duplicate`,

# `NT` for number of tensors
abstract type EinRule{NT} end

struct Tr <: EinRule{1} end
struct Sum <: EinRule{1} end
struct Repeat <: EinRule{1} end
struct Permutedims <: EinRule{1} end
struct Identity <: EinRule{1} end
struct Duplicate <: EinRule{1} end
struct Diag <: EinRule{1} end
struct DefaultRule <: EinRule{Any} end

# trace
# overhead ~ 0.07us
# @benchmark OMEinsum.einsum(Tr(), $(('a', 'a')), $(()), x, $(Dict('a'=>1, 'b'=>1))) setup=(x=randn(1,1))
function unary_einsum!(::Tr, ix, iy, x, y::AbstractArray, sx, sy)
    @debug "Tr" size(x)
    y .= sy .* y .+ sx * tr(x)
    return y
end

# overhead ~ 0.55us
# @benchmark OMEinsum.einsum(Sum(), $(('a', 'b')), $(('b',)), x, $(Dict('a'=>1, 'b'=>1))) setup=(x=randn(1,1))
function unary_einsum!(::Sum, ix, iy, x::AbstractArray, y::AbstractArray, sx, sy)
    @debug "Sum" ix => iy size(x)
    dims = (findall(i -> i ∉ iy, ix)...,)::NTuple{length(ix)-length(iy),Int}
    res = dropdims(sum(x, dims=dims), dims=dims)
    ix1f = filter(i -> i ∈ iy, ix)::typeof(iy)
    if ix1f != iy
        return unary_einsum!(Permutedims(), (ix1f...,), iy, res, y, sx, sy)
    else
        return @flatten_addmul! sy * y + sx * res
    end
end

# overhead ~ 0.53us
# @benchmark OMEinsum.einsum(OMEinsum.Repeat(), $(('a',)), $(('a', 'b',)), x, $(Dict('a'=>1, 'b'=>1))) setup=(x=randn(1))
function unary_einsum!(::Repeat, ix, iy, x::AbstractArray, y::AbstractArray, sx, sy)
    @debug "Repeat" ix => iy size(x)
    ix1f = filter(i -> i ∈ ix, iy)
    shape1 = [s for (l, s) in zip(iy, size(y)) if l ∈ ix]
    shape2 = [l ∈ ix ? s : 1 for (l, s) in zip(iy, size(y))]
    repeat_dims = [l ∈ ix ? 1 : s for (l, s) in zip(iy, size(y))]
    # TODO: avoid copy
    if ix1f != ix
        y1 = similar(x, (shape1...,))
        unary_einsum!(Permutedims(), ix, ix1f, x, y1, true, false)
    else
        y1 = x
    end
    @flatten_addmul! sy * y + sx * repeat(reshape(y1, shape2...), repeat_dims...)
end

# overhead ~ 0.28us
# @benchmark OMEinsum.einsum(Diag(), $(('a', 'a')), $(('a',)), x, $(Dict('a'=>1, 'b'=>1))) setup=(x=randn(1,1))
function unary_einsum!(::Diag, ix, iy, x::AbstractArray, y::AbstractArray, sx, sy)
    @debug "Diag" ix => iy size.(x)
    compactify!(y, x, ix, iy, sx, sy)
end

function compactify!(y, x, ix, iy, sx, sy)
    x_in_y_locs = (Int[findfirst(==(x), iy) for x in ix]...,)
    @assert size(x) == map(loc->size(y, loc), x_in_y_locs)
    indexer = dynamic_indexer(x_in_y_locs, size(x))
    _compactify!(y, x, indexer, sx, sy)
end

function _compactify!(y, x, indexer, sx, sy)
    if iszero(sy)
        if isone(sx)
            @inbounds for ci in CartesianIndices(y)
                y[ci] = x[subindex(indexer, ci.I)]
            end
        else
            @inbounds for ci in CartesianIndices(y)
                y[ci] = sx * x[subindex(indexer, ci.I)]
            end
        end
    else
        @inbounds for ci in CartesianIndices(y)
            y[ci] = sy * y[ci] + sx * x[subindex(indexer, ci.I)]
        end
    end
    return y
end

function duplicate!(y, x, ix, iy, sx, sy)
    # compute same locs
    x_in_y_locs = (Int[findfirst(==(l), ix) for l in iy]...,)
    indexer = dynamic_indexer(x_in_y_locs, size(y))
    _duplicate!(y, x, indexer, sx, sy)
end

@noinline function _duplicate!(y, x, indexer, sx, sy)
    if iszero(sy)
        fill!(y, zero(eltype(y)))
        map(CartesianIndices(x)) do ci
            @inbounds y[subindex(indexer, ci.I)] = sx * x[ci]
        end
    else
        lmul!(sy, y)
        map(CartesianIndices(x)) do ci
            @inbounds y[subindex(indexer, ci.I)] = fma(sx, x[ci], y[subindex(indexer, ci.I)])
        end
    end
    return y
end

# e.g. 'ij'->'iij', left indices are unique, right are not
# overhead ~ 0.29us
# @benchmark OMEinsum.einsum(Duplicate(), $((('a', ),)), $(('a','a')), (x,), $(Dict('a'=>1, 'b'=>1))) setup=(x=randn(1))
function unary_einsum!(::Duplicate, ix, iy, x::AbstractArray, y::AbstractArray, sx, sy)
    @debug "Duplicate" ix => iy size(x)
    duplicate!(y, x, ix, iy, sx, sy)
end

# overhead ~ 0.15us
# @benchmark OMEinsum.einsum(Permutedims(), $((('a', 'b'),)), $(('b','a')), (x,), $(Dict('a'=>1, 'b'=>1))) setup=(x=randn(1,1))
function unary_einsum!(::Permutedims, ix, iy, x::AbstractArray, y::AbstractArray, sx, sy)
    perm = ntuple(i -> findfirst(==(iy[i]), ix)::Int, length(iy))
    @debug "Permutedims" ix => iy size(x) perm
    return tensorpermute!(y, x, perm, sx, sy)
end

# overhead ~0.04us
# @benchmark OMEinsum.einsum(Identity(), $((('a', 'b'),)), $(('a','b')), (x,), $(Dict('a'=>1, 'b'=>1))) setup=(x=randn(1,1))
function unary_einsum!(::Identity, ix, iy, x::AbstractArray, y::AbstractArray, sx, sy)
    @debug "Identity" ix => iy size(x)
    @flatten_addmul! sy * y + sx * x  # NOTE: copy can not be avoided, otherwise AD may fail!
end

using Test
using OMEinsum
using OMEinsum: get_size_dict
using SymEngine
using LinearAlgebra: I, tr

SymEngine.free_symbols(syms::Union{Real, Complex}) = Basic[]
SymEngine.free_symbols(syms::AbstractArray{T}) where {T<:Union{Real, Complex}} = Basic[]
function rand_assign(syms...)
    fs = union(free_symbols.(syms)...)
    Dict(zip(fs, randn(length(fs))))
end

function _basic_approx(x, y; atol=1e-8)
    diff = x-y
    assign = rand_assign(x, y)
    length(assign) > 0 && (diff = subs.(diff, Ref.((assign...,))...))
    nres = ComplexF64.(diff)
    all(isapprox.(nres, 0; atol=atol))
end

Base.:≈(x::AbstractArray{<:Basic}, y::AbstractArray; atol=1e-8) = _basic_approx(x, y, atol=atol)
Base.:≈(x::AbstractArray, y::AbstractArray{<:Basic}; atol=1e-8) = _basic_approx(x, y, atol=atol)
Base.:≈(x::AbstractArray{<:Basic}, y::AbstractArray{<:Basic}; atol=1e-8) = _basic_approx(x, y, atol=atol)
Base.Complex{T}(a::Basic) where T = T(real(a)) + im*T(imag(a))

@testset "unary einsum" begin
    size_dict = Dict(1=>3,2=>3,3=>3,4=>4,5=>5)
    ix = (1,2,3,3,4)
    x = randn(3,3,3,3,4)
    iy = (3,5,1,1,2,5)
    y = randn(3,5,3,3,3,5)
    # Diag, Sum, Repeat, Duplicate
    @test einsum!((ix,), iy, (x,), y, true, false, size_dict) ≈ loop_einsum(EinCode((ix,), iy), (x,), size_dict)
    ix = (1,2,3,4)
    x = randn(3,3,3,4)
    iy = (4,3,1,2)
    y = randn(4,3,3,3)
    # Permutedims
    @test einsum!((ix,), iy, (x,), y, true, false, size_dict) ≈ loop_einsum(EinCode((ix,), iy), (x,), size_dict)
    # None
    ix = (1,2,3,4)
    x = randn(3,3,3,4)
    iy = (1,2,3,4)
    y = randn(3,3,3,4)
    @test einsum!((ix,), iy, (x,), y, true, false, size_dict) ≈ loop_einsum(EinCode((ix,), iy), (x,), size_dict)
    # tr
    ix = (1,1)
    x = randn(3,3)
    iy = ()
    y = fill(1.0)
    @test einsum!((ix,), iy, (x,), y, true, false, size_dict)[] ≈ tr(x)
end

@testset "binary einsum" begin
    size_dict = Dict(1=>3,2=>3,3=>3,4=>4,5=>5)
    ix = (1,2,3,3,4)
    x = randn(3,3,3,3,4)
    iy = (3,5,1,1,2,5)
    y = randn(3,5,3,3,3,5)
    iz = (1,2,3,4,5,5)
    z = randn(3,3,3,4,5,5)
    @test einsum!((ix, iy), iz, (x, y), z, true, false, size_dict) ≈ loop_einsum(EinCode((ix, iy), iz), (x, y), size_dict)
    @test einsum!((ix, iy), iz, (x, y), copy(z), 5.0, 3.0, size_dict) ≈ loop_einsum!((ix, iy), iz, (x, y), copy(z), 5.0, 3.0, size_dict)
    @test einsum!((ix, iy), iz, (x, y), copy(z), 5.0, 1.0, size_dict) ≈ loop_einsum!((ix, iy), iz, (x, y), copy(z), 5.0, 1.0, size_dict)
end

@testset "nary, einsum" begin
     size_dict = Dict(1=>3,2=>3,3=>3,4=>4,5=>5)
    ix = (1,2,3,3,4)
    x = randn(3,3,3,3,4)
    iy = (3,5,1)
    y = randn(3,5,3)
    iz = (1,2,3,4,5,5)
    z = randn(3,3,3,4,5,5)
    @test einsum!((ix, iy, iz), (), (x, y, z), fill(1.0), true, false, size_dict) ≈ loop_einsum(EinCode((ix, iy, iz), ()), (x, y, z), size_dict)
end

@testset "get output array" begin
    xs = (randn(4,4), randn(3))
    @test OMEinsum.get_output_array(xs, (5, 5), false) isa Array{Float64}
    xs = (randn(4,4), randn(ComplexF64, 3))
    @test OMEinsum.get_output_array(xs, (5, 5), false) isa Array{ComplexF64}
end

@testset "tensor order check" begin
    ixs = ((1,2), (2,3))
    a = randn(3,3)
    @test_throws ArgumentError get_size_dict(ixs, (a,a,a))
    a = randn(3,3,3)
    @test_throws ArgumentError get_size_dict(ixs, (a,a))
end

@testset "get size dict" begin
    a = randn(3,2)
    sizedict = get_size_dict(((1,2), (2,3)), (a, a'))
    @test (sizedict[1], sizedict[2], sizedict[3]) == (3,2,3)
    sizedict = get_size_dict((('i','j'), ('k','j')), (a, a))
    @test (sizedict['i'], sizedict['j'], sizedict['k']) == (3,2,3)
    @test_throws DimensionMismatch get_size_dict((('i','j'), ('j','k')), (a, a))
end

@testset "einsum" begin
    # matrix and vector multiplication
    a,b,c = randn(2,2), rand(2,2), rand(2,2)
    v = rand(2)
    t = randn(2,2,2,2)
    @test einsum(ein"ijkl -> ijkl", (t,)) ≈ t
    @test einsum(ein"αβγδ -> αβγδ", (t,)) ≈ t
    @test einsum(EinCode(((1,2),(2,3),(3,4)),(1,4)), (a,b,c)) ≈ a * b * c
    @test einsum(EinCode(((1,20),(20,3),(3,4)), (1,4)), (a,b,c)) ≈ a * b * c
    @test einsum(EinCode(((1,2),(2,3),(3,4)),(4,1)), (a,b,c)) ≈ permutedims(a*b*c, (2,1))
    @test einsum(EinCode(((1,2),(2,)), (1,)), (a,v)) ≈ a * v

    # more matmul
    @test ein"ij,jk -> ik"(a,a) ≈ a * a
    @test ein"ij,jk -> ki"(a,a) ≈ transpose(a * a)
    @test ein"ij,kj -> ik"(a,a) ≈ a * transpose(a)
    @test ein"ij,kj -> ki"(a,a) ≈ transpose(a * transpose(a))
    @test ein"ji,jk -> ik"(a,a) ≈ transpose(a) * a
    @test ein"ji,jk -> ki"(a,a) ≈ transpose(transpose(a) * a)
    @test ein"ji,kj -> ik"(a,a) ≈ transpose(a) * transpose(a)
    @test ein"ji,kj -> ki"(a,a) ≈ transpose(transpose(a) * transpose(a))

    # contract to 0-dim array
    @test einsum(EinCode(((1,2),(1,2)), ()), (a,a))[] ≈ sum(a .* a)

    # trace
    @test einsum(EinCode(((1,1),),()), (a,))[] ≈ sum(a[i,i] for i in 1:2)
    @test einsum(EinCode(((1,1),),()), (a,)) isa Array
    aa = rand(2,4,4,2)
    @test einsum(EinCode(((1,2,2,1),), ()), (aa,))[] ≈ sum(aa[i,j,j,i] for i in 1:2, j in 1:4)

    # partial trace
    @test einsum(EinCode(((1,2,2,3),), (1,3)), (aa,)) ≈ sum(aa[:,i,i,:] for i in 1:4)
    # with permutation
    @test einsum(EinCode(((1,2,2,3),), (3,1)), (aa,)) ≈ transpose(sum(aa[:,i,i,:] for i in 1:4))

    # diag
    @test einsum(EinCode(((1,2,2,3),), (1,2,3)), (aa,)) ≈ aa[:,[CartesianIndex(i,i) for i in 1:4],:]

    # permutation
    @test einsum(EinCode(((1,2),), (2,1)), (a,)) ≈ permutedims(a,(2,1))
    @test einsum(EinCode(((1,2,3,4),),(2,3,1,4)), (t,)) ≈ permutedims(t,(2,3,1,4))

    # tensor contraction
    ta = zeros(size(t)[[1,2]]...)
    for (i,j,k,l) in Iterators.product(1:2,1:2,1:2,1:2)
        ta[i,l] += t[i,j,k,l] * a[j,k]
    end
    @test einsum(EinCode(((1,2,3,4), (2,3)), (1,4)), (t,a)) ≈  ta

    ta = zeros(size(t)[[1,2]]...)
    for (i,j,k,l) in Iterators.product(1:2,1:2,1:2,1:2)
        ta[i,l] += t[l,k,j,i] * a[j,k]
    end
    @test einsum(EinCode(((4,3,2,1), (2,3)),(1,4)), (t,a)) ≈  ta

    # star-contraction
    aaa = zeros(2,2,2);
    for (i,j,k,l) in Iterators.product(1:2,1:2,1:2,1:2)
        aaa[j,k,l] += a[i,j] * a[i,k] * a[i,l]
    end
    @test aaa ≈ einsum(EinCode(((1,2),(1,3),(1,4)),(2,3,4)), (a,a,a))

    # star and contract
    aaa = zeros(2);
    for (i,j,l) in Iterators.product(1:2,1:2,1:2)
        aaa[l] += a[i,j] * a[i,j] * a[i,l]
    end
    @test einsum(EinCode(((1,2),(1,2),(1,3)), (3,)), (a,a,a)) ≈ aaa

    # index-sum
    a = rand(2,2,5)
    @test einsum(EinCode(((1,2,3),),(1,2)),(a,)) ≈ sum(a, dims=3)
    # with permutation
    @test ein"ijk -> ki"(a) ≈ transpose(dropdims(sum(a,dims=2),dims=2))
    @test ein"ijk -> "(a)[] ≈ sum(a)

    # Hadamard product
    a = rand(2,3)
    b = rand(2,3)
    @test einsum(EinCode(((1,2),(1,2)), (1,2)), (a,b)) ≈ a .* b

    # Outer
    a = rand(2,3)
    b = rand(2,3)
    @test einsum(EinCode(((1,2),(3,4)),(1,2,3,4)),(a,b)) ≈ reshape(a,2,3,1,1) .* reshape(b,1,1,2,3)

    # Broadcasting
    @test ein"->ii"(OMEinsum.asarray(1); size_info=Dict('i'=>5)) == Matrix(I, 5, 5)

    # trivil
    @test ein"->ii"(asarray(1); size_info=Dict('i'=>5)) == Matrix(I, 5, 5)
    res = ein"->"(asarray(3))
    @test res isa Array
    @test res[] === 3
    res = ein",->"(asarray(3), asarray(4))
    @test res isa Array
    @test res[] === 12

    # Projecting to diag
    a = rand(2,2)
    a2 = [a[1] 0; 0 a[4]]
    @test einsum(EinCode(((1,1),), (1,1)), (a,)) ≈ a2

    ## operations that can be combined
    a = rand(2,2,2,2)
    @test einsum(EinCode(((1,1,2,2),), ()), (a,))[] ≈ sum(a[[CartesianIndex(i,i) for i in 1:2], [CartesianIndex(i,i) for i in 1:2]])

    @test einsum(EinCode(((1,2,3,4), (3,4,5,6)), (1,2,5,6)), (a,a)) ≈ reshape(reshape(a,4,4) * reshape(a,4,4),2,2,2,2)
end

@testset "fallback" begin
    # while we expect some scaling in the allocations for multiple inputs, it
    # shouldn't increase too much
    a = rand(100,100)
    b = rand(100,100)
    einsum(EinCode(((1,2),(2,3)),(1,3)), (a,b))
    allocs1 = @allocated einsum(EinCode(((1,2),(2,3)),(1,3)), (a,b))
    @test allocs1 < 10^5
    einsum(EinCode(((1,2),(2,3),(3,4)),(1,4)), (a,b,b))
    allocs2 = @allocated einsum(EinCode(((1,2),(2,3),(3,4)),(1,4)), (a,b,b))
    # doing twice the work (two multiplications instead of one) shouldn't
    # incure much more than twice the allocations.
    @test allocs2 < 2.1 * allocs1

    @test_throws MethodError einsum(((1,2),(2,3)), (a,a))
end

@testset "error handling" begin
    a = randn(3,3)
    b = randn(4,4)
    @test_throws DimensionMismatch einsum(EinCode(((1,2), (2,3)), (1,3)), (a, b))
end

@testset "string input" begin
    a = randn(3,3)
    @test einsum(ein"ij,jk -> ik", (a,a)) ≈ einsum(EinCode(((1,2),(2,3)), (1,3)), (a,a))
    @test ein"ij,jk -> ik"(a,a) ≈ einsum(EinCode(((1,2),(2,3)), (1,3)), (a,a))
    @test ein"αβ,βγ -> αγ"(a,a) ≈ a * a
    # Note: the following statement is nolonger testable, since will cause load error now!
    #@test_throws ArgumentError einsum(ein"ij,123 -> k", (a,a))
end

@testset "non inplace macro input" begin
    a = randn(2,2)
    @test a * a ≈ @ein [i,k] := a[i,j] * a[j,k]
    @test sum(a[i,i] for i in 1:2) ≈ (@ein [] := a[i,i])[]
    @test [a[1,1] 0; 0 a[2,2]] ≈ @ein [i,i] := a[i,i]
    @test permutedims(a) ≈ @ein [α,a] := a[a,α]
    @test permutedims(a) ≈ @ein [α,1] := a[1,α]
end

@testset "inplace macro input" begin
    a = randn(2,2)
    b = randn(2,2)
    c = randn(2,2)
    t = randn(2,2)
    cc = copy(c)
    @ein! t[i,k] := a[i,j] * b[j,k]
    @ein! c[i,k] += a[i,j] * b[j,k]
    @test a * b ≈ t
    @test cc + a * b ≈ c
end

@testset "argument checks" begin
    @test_throws ArgumentError einsum(ein"ij,jk -> ik", (rand(2,2), rand(2,2), rand(2,2)))
    @test_throws ArgumentError einsum(ein"ij,jk,k -> ik", (rand(2,2), rand(2,2)))
    @test_throws ArgumentError einsum(ein"ij,ijk -> ik", (rand(2,2), rand(2,2)))
    @test_throws DimensionMismatch einsum(ein"ij,jk -> ik", (rand(2,3), rand(2,2)))
end

@testset "isbatchmul" begin
    for (ixs, iy) in [(((1,2), (2,3)), (1,3)), (((1,2,3), (2,3)), (1,3)),
                        (((7,1,2,3), (2,4,3,7)), (1,4,3)),
                        (((3,), (3,)), (3,)), (((3,1), (3,)), (3,1))
                        ]
        xs = ([randn(ComplexF64, fill(4,length(ix))...) for ix in ixs]...,)
        @test EinCode(ixs, iy)(xs...) ≈ loop_einsum(EinCode(ixs, iy), xs, OMEinsum.get_size_dict(ixs, xs))
    end
end

@testset "issue 136" begin
    @test EinCode(((1,2,3),(2,)),(1,3))(ones(2,2,1), ones(2)) == reshape([2,2.0], 2, 1)
    @test EinCode(((1,2,3),(2,)),(1,3))(ones(2,2,0), ones(2)) == reshape(zeros(0), 2, 0)
end

@testset "fix rule cc,cb->bc" begin
    size_dict = Dict('a'=>2,'b'=>2,'c'=>2)
    for code in [ein"c,c->cc", ein"c,cc->c", ein"cc,c->cc", ein"cc,cc->cc", ein"cc,cb->bc", ein"cb,bc->cc", ein"ac,cc->ac"]
        @info code
        a = randn(fill(2, length(getixsv(code)[1]))...)
        b = randn(fill(2, length(getixsv(code)[2]))...)
        @test code(a, b) ≈ OMEinsum.loop_einsum(code, (a,b), size_dict)
    end
end

# patch for SymEngine
Base.promote_rule(::Type{Bool}, ::Type{Basic}) = Basic
@testset "allow loops" begin
    t = rand(5,5,5,5)
    a = rand(5,5)
    size_dict = Dict(zip((1,2,3,4,2,3), ((size(t)..., size(a)...))))

    OMEinsum.allow_loops(false)
    @test_throws ErrorException loop_einsum(EinCode(((1,2,3,4), (2,3)), (1,4)), (t,a), size_dict)
    OMEinsum.allow_loops(true)

    ta = loop_einsum(EinCode(((1,2,3,4), (2,3)), (1,4)), (t,a), size_dict)
    @test einsum(EinCode(((1,2,3,4), (2,3)), (1,4)), (t,a), size_dict) ≈  ta

    # index-sum
    t = Basic.(rand(5,5,5,5))
    a = Basic.(rand(5,5))
    size_dict = Dict(zip((1,2,3,4,2,3), ((size(t)..., size(a)...))))
    ta = loop_einsum(EinCode(((1,2,3,4), (2,3)), (1,4)), (t,a), size_dict)
    @test einsum(EinCode(((1,2,3,4), (2,3)), (1,4)), (t,a), size_dict) ≈  ta
end

@testset "symbolic" begin
    @test ein"ij->ijij"([1 1; 1 exp(im*Basic(π)/2)]) == [1 0; 0 0;;; 0 0; 1 0;;;; 0 1; 0 0;;; 0 0; 0 exp(im*Basic(π)/2)]
end

using OMEinsum

N = 100
ca = randn(Float32, N, N)
ct = randn(Float32, N, N, N)
cq = randn(Float32, N, N, N, N)

function bfunc_star_cpu()
    ein"ji,kl,li->jkl"(ca,ca,ca)
end

function bfunc_t3_cpu()
    ein"ji,kli,li->jkl"(ca,ct,ca)
end

function bfunc_psum_cpu()
    ein"iikl->"(cq)
end

using BenchmarkTools
display(@benchmark bfunc_star_cpu() seconds = 1)
display(@benchmark bfunc_t3_cpu() seconds = 1)
display(@benchmark bfunc_psum_cpu() seconds = 1)

# Application

## List of packages using OMEinsum
- [GenericTensorNetworks](https://github.com/QuEraComputing/GenericTensorNetworks.jl), solving combinational optimization problems by generic tensor networks.
- [TensorInference](https://github.com/TensorBFS/TensorInference.jl), probabilistic inference using contraction of tensor networks
- [YaoToEinsum](https://github.com/QuantumBFS/Yao.jl), the tensor network simulation backend for quantum circuits.
- [TensorNetworkAD2](https://github.com/YidaiZhang/TensorNetworkAD2.jl), using differential programming tensor networks to solve quantum many-body problems.
- [TensorQEC](https://github.com/nzy1997/TensorQEC.jl), tensor networks for quantum error correction.

## Example: Solving a 3-coloring problem on the Petersen graph
Let us focus on graphs
with vertices with three edges each. A question one might ask is:
How many different ways are there to colour the edges of the graph with
three different colours such that no vertex has a duplicate colour on its edges?

The counting problem can be transformed into a contraction of rank-3 tensors
representing the edges. Consider the tensor `s` defined as
```@repl coloring
using OMEinsum
s = map(x->Int(length(unique(x.I)) == 3), CartesianIndices((3,3,3)))
```

Then we can simply contract `s` tensors to get the number of 3 colourings satisfying the above condition!
E.g. for two vertices, we get 6 distinct colourings:
```@repl coloring
ein"ijk,ijk->"(s,s)[]
```

Using that method, it's easy to find that e.g. the peterson graph allows no 3 colouring, since
```@repl coloring
code = ein"afl,bhn,cjf,dlh,enj,ago,big,cki,dmk,eom->"
afl, bhn, cjf, dlh, enj, ago, big, cki, dmk, eom 
code(fill(s, 10)...)[]
```

The peterson graph consists of 10 vertices and 15 edges and looks like a pentagram
embedded in a pentagon as depicted here:

![](https://upload.wikimedia.org/wikipedia/commons/thumb/f/f5/Petersen_graph.svg/252px-Petersen_graph.svg.png)

`OMEinsum` does not optimie the contraction order by default, so the above contraction can be time consuming. To speed up the contraction, we can use `optimize_code` to optimize the contraction order:
```@repl coloring
optcode = optimize_code(code, uniformsize(code, 3), TreeSA())
contraction_complexity(optcode, uniformsize(optcode, 3))
optcode(fill(s, 10)...)[]
```
We can see the time complexity of the optimized code is much smaller than the original one. To know more about the contraction order optimization, please check the Julia package [`OMEinsumContractionOrders.jl`](https://github.com/TensorBFS/OMEinsumContractionOrders.jl).

Confronted with the above result, we can ask whether the peterson graph allows a relaxed variation of 3 colouring, having one vertex that might accept duplicate colours. The answer to that can be found using the gradient w.r.t a vertex:
```@repl coloring
using Zygote: gradient
gradient(x->optcode(x,s,s,s,s,s,s,s,s,s)[], s)[1] |> sum
```
This tells us that even if we allow duplicates on one vertex, there are no 3-colourings for the peterson graph.

# Contraction order optimization

## Constructing a code
The [`@ein_str`](@ref) string literal does not optimize the contraction order for more than two input tensors.
We first use a graph to construct a [`DynamicEinCode`](@ref) object for demonstration.

```@repl order
using OMEinsum, OMEinsumContractionOrders, OMEinsumContractionOrders.Graphs

graph = random_regular_graph(20, 3; seed=42)

code = EinCode([[e.src, e.dst] for e in edges(graph)], Int[])
```

The return value is a [`StaticEinCode`](@ref) object that does not contain a contraction order.
The time and space complexity can be obtained by calling the [`contraction_complexity`](@ref) function.
```@repl order
size_dict = uniformsize(code, 2)  # size of the labels are set to 2

contraction_complexity(code, size_dict)  # time and space complexity
```

The return values are `log2` values of the number of iterations, number of elements of the largest tensor and the number of elementwise read-write operations.

## Optimizing the contraction order
To optimize the contraction order, we can use the [`optimize_code`](@ref) function.

```@repl order
optcode = optimize_code(code, size_dict, TreeSA(ntrials=1))
```

The output value is a binary contraction tree with type [`SlicedEinsum`](@ref) or [`NestedEinsum`](@ref).
The `TreeSA` is a local search algorithm that optimizes the contraction order. More algorithms can be found in the
[OMEinsumContractionOrders documentation](https://tensorbfs.github.io/OMEinsumContractionOrders.jl/dev/).

After optimizing the contraction order, the time and readwrite complexities are significantly reduced.

```@repl order
contraction_complexity(optcode, size_dict)
```

## Slicing the code
In some cases, the memory usage of the contraction is too large.
Slicing is a technique to reduce the time and space complexity of the contraction.
The slicing is done by using the [`slice_code`](@ref) function.
```@repl order
slicer = TreeSASlicer(score=ScoreFunction(sc_target=2))
scode = slice_code(optcode, size_dict, slicer);
contraction_complexity(scode, size_dict)
scode.slicing
```
The return value is a [`SlicedEinsum`](@ref) object. The space complexity is reduced to 2, while the time complexity is increased as a trade-off.

## Using `optein` string literal
For convenience, the optimized contraction can be directly contructed by using the [`@optein_str`](@ref) string literal.
```@repl order
optein"ij,jk,kl,li->"  # optimized contraction, without knowing the size of the tensors
```
`@optein_str` optimizes the contraction order with the assumption that each index has the same size 2, hence the resulting contraction order might not be optimal.

## Manual optimization
One can also manually specify the contraction order by using the [`@ein_str`](@ref) string literal.
```@repl order
ein"((ij,jk),kl),li->ik"  # manually optimized contraction
```

## Flatten the code

Given an optimized code, one can flatten it to get a code without contraction order with type [`EinCode`](@ref).

```@repl order
OMEinsum.flatten(optcode)
```

# Automatic differentiation

There are two ways to compute the gradient of an einsum expression. The first one is to use the `OMEinsum` package, which is a custom implementation of the reverse-mode automatic differentiation. The second one is to use the [`Zygote`](https://github.com/FluxML/Zygote.jl) package, which is a source-to-source automatic differentiation tool.

## Built-in automatic differentiation
The `OMEinsum` package provides a built-in function [`cost_and_gradient`](@ref) to compute the cost and the gradient of an einsum expression.

```@repl autodiff
using OMEinsum  # the 1st way
A, B, C = randn(2, 3), randn(3, 4), randn(4, 2);
y, g = cost_and_gradient(ein"(ij, jk), ki->", (A, B, C))
```
This built-in automatic differentiation is designed for tensor contractions and is more efficient than the general-purpose automatic differentiation tools.

For complex valued tensors, the automatic differentiation is defined in a convention that treat the real and imaginary parts as independent variables.

## Using Zygote
The backward rule for the basic einsum operation is ported to the [`ChainRulesCore`](https://github.com/JuliaDiff/ChainRulesCore.jl), which is used by the `Zygote` package.
Zygote is a source-to-source automatic differentiation tool that can be used to compute the gradient of an einsum expression.
It is more general and can be used for any Julia code.
```@repl autodiff
using Zygote  # the 2nd way
Zygote.gradient((A, B, C)->ein"(ij, jk), ki->"(A, B, C)[], A, B, C)
```

# OMEinsum.jl

This package provides
- The einsum notation, which is similar to the einsum function in `numpy`, although some details are different.
- Highly optimized algorithms to optimize the contraction of tensors.

The source code is available at [OMEinsum.jl](https://github.com/under-Peter/OMEinsum.jl).

## Quick start

You can find a set up guide in the [README](https://github.com/under-Peter/OMEinsum.jl). To get started, open a Julia REPL and type the following code.

```@repl intro
using OMEinsum
code = ein"ij,jk,kl,lm->im" # define the einsum operation
optcode = optimize_code(code, uniformsize(code, 100), TreeSA())  # optimize the contraction order
optcode(randn(100, 100), randn(100, 100), randn(100, 100), randn(100, 100))  # compute the result
```

# Basic Usage

In the following example, we demonstrate the einsum notation for basic tensor operations.

## Einsum notation
To specify the operation, the user can either use the [`@ein_str`](@ref)-string literal or the [`EinCode`](@ref) object.
For example, both the following code snippets define the matrix multiplication operation:
```@repl tensor
using OMEinsum
code1 = ein"ij,jk -> ik"  # the string literal
ixs = [[1, 2], [2, 3]]  # the input indices
iy = [1, 3]  # the output indices
code2 = EinCode(ixs, iy)  # the EinCode object (equivalent to the string literal)
```

The [`@ein_str`](@ref) macro can be used to define the einsum notation directly in the function call.
```@repl tensor
A, B = randn(2, 3), randn(3, 4);
code1(A, B)  # matrix multiplication
size_dict = OMEinsum.get_size_dict(getixsv(code1), (A, B))  # get the size of the labels
einsum(code1, (A, B), size_dict)  # lower-level function
einsum!(code1, (A, B), zeros(2, 4), true, false, size_dict)  # the in-place operation
@ein C[i,k] := A[i,j] * B[j,k]  # all-in-one macro
```
Here, we show that the [`@ein`](@ref) macro combines the einsum notation defintion and the operation in a single line, which is more convenient for simple operations.
Separating the einsum notation and the operation (the first approach) can be useful for reusing the einsum notation for multiple input tensors.
Lower level functions, [`einsum`](@ref) and [`einsum!`](@ref), can be used for more control over the operation.

For more than two input tensors, *the [`@ein_str`](@ref) macro does not optimize the contraction order*. In such cases, the user can use the [`@optein_str`](@ref) string literal to optimize the contraction order or specify the contraction order manually.
```@repl tensor
tensors = [randn(100, 100) for _ in 1:4];
optein"ij,jk,kl,lm->im"(tensors...)  # optimized contraction (without knowing the size)
ein"(ij,jk),(kl,lm)->im"(tensors...)  # manually specified contraction
```

Sometimes, manually optimizing the contraction order can be beneficial. Please check [Contraction order optimization](@ref) for more details.

## Einsum examples
We first define the tensors and then demonstrate the einsum notation for various tensor operations.
```@repl tensor
using OMEinsum
s = fill(1)  # scalar
w, v = [1, 2], [4, 5];  # vectors
A, B = [1 2; 3 4], [5 6; 7 8]; # matrices
T1, T2 = reshape(1:8, 2, 2, 2), reshape(9:16, 2, 2, 2); # 3D tensor
```
### Unary examples
```@repl tensor
ein"i->"(w)  # sum of the elements of a vector.
ein"ij->i"(A)  # sum of the rows of a matrix.
ein"ii->"(A)  # sum of the diagonal elements of a matrix, i.e., the trace.
ein"ij->"(A)  # sum of the elements of a matrix.
ein"i->ii"(w)  # create a diagonal matrix.
ein"i->ij"(w; size_info=Dict('j'=>2))  # repeat a vector to form a matrix.
ein"ijk->ikj"(T1)  # permute the dimensions of a tensor.
```

### Binary examples
```@repl tensor
ein"ij, jk -> ik"(A, B)  # matrix multiplication.
ein"ijb,jkb->ikb"(T1, T2)  # batch matrix multiplication.
ein"ij,ij->ij"(A, B)  # element-wise multiplication.
ein"ij,ij->"(A, B)  # sum of the element-wise multiplication.
ein"ij,->ij"(A, s)  # element-wise multiplication by a scalar.
```

### Nary examples
```@repl tensor
optein"ai,aj,ak->ijk"(A, A, B)  # star contraction.
optein"ia,ajb,bkc,cld,dm->ijklm"(A, T1, T2, T1, A)  # tensor train contraction.
```

# Background Knowledge

## Tensors and Tensor Networks
Tensor networks serve as a fundamental tool for modeling and analyzing correlated systems. This section reviews the fundamental concepts of tensor
networks.

A tensor is a mathematical object that generalizes scalars, vectors, and matrices. It can have multiple dimensions and is used to represent data in various mathematical and physical contexts. It is formally defined as follows:

*Definition* (Tensor): A tensor $T$ associated to a set of discrete variables $V$ is defined as a function that maps each possible instantiation of the variables in its scope $\mathcal{D}_V = \prod_{v\in V} \mathcal{D}_{v}$ to an element in the set $\mathcal{E}$, given by
```math
T_{V}: \prod_{v \in V} \mathcal{D}_{v} \rightarrow \mathcal{E}.
```
Within the context of probabilistic modeling, the elements in $\mathcal{E}$ are non-negative real numbers, while in other scenarios, they can be of generic types. The diagrammatic representation of a tensor is given by a node with the variables $V$ as labels on its edges, as shown below:

```@raw html
<img src="../assets/tensors.svg" width=500 style="margin-left:auto; margin-right:auto; display:block"/>
```

*Definition* (Tensor Network): A tensor network is a mathematical framework for defining multilinear maps, which can be represented by a triple $\mathcal{N} = (\Lambda, \mathcal{T}, V_0)$, where:
*  $\Lambda$ is the set of variables present in the network $\mathcal{N}$.
*  $\mathcal{T} = \{ T_{V_k} \}_{k=1}^{K}$ is the set of input tensors, where each tensor $T_{V_k}$ is associated with the labels $V_k$.
*  $V_0$ specifies the labels of the output tensor.

Specifically, each tensor $T_{V_k} \in \mathcal{T}$ is labeled by a set of variables $V_k \subseteq \Lambda$, where the cardinality $|V_k|$ equals the rank of $T_{V_k}$. The multilinear map, or the **contraction**, applied to this triple is defined as
```math
T_{V_0} = \texttt{contract}(\Lambda, \mathcal{T}, V_0) \overset{\mathrm{def}}{=} \sum_{m \in \mathcal{D}_{\Lambda\setminus V_0}} \prod_{T_V \in \mathcal{T}} T_{V|M=m},
```
where $M = \Lambda \setminus V_0$. $T_{V|M=m}$ denotes a slicing of the tensor $T_{V}$ with the variables $M$ fixed to the values $m$. The summation runs over all possible configurations of the variables in $M$.

For instance, matrix multiplication can be described as the contraction of a tensor network given by
```math
(AB)_{\{i, k\}} = \texttt{contract}\left(\{i,j,k\}, \{A_{\{i, j\}}, B_{\{j, k\}}\}, \{i, k\}\right),
```
where matrices $A$ and $B$ are input tensors containing the variable sets $\{i, j\}, \{j, k\}$, respectively, which are subsets of $\Lambda = \{i, j, k\}$. The output tensor is comprised of variables $\{i, k\}$ and the summation runs over variables $\Lambda \setminus \{i, k\} = \{j\}$. The contraction corresponds to
```math
(A B)_{\{i, k\}} = \sum_j A_{\{i,j\}}B_{\{j, k\}}.
```

Diagrammatically, a tensor network can be represented as an *open hypergraph*, where each tensor is mapped to a vertex and each variable is mapped to a hyperedge. Two vertices are connected by the same hyperedge if and only if they share a common variable. The diagrammatic representation of the matrix multiplication is given as follows: 

```@raw html
<img src="../assets/matmul.png" width=500 style="margin-left:auto; margin-right:auto; display:block"/>
```

Here, we use different colors to denote different hyperedges. Hyperedges for $i$ and $k$ are left open to denote variables of the output tensor. A slightly more complex example of this is the star contraction:
```math
\texttt{contract}(\{i,j,k,l\}, \{A_{\{i, l\}}, B_{\{j, l\}}, C_{\{k, l\}}\}, \{i,j,k\}) \\
= \sum_{l}A_{\{i,l\}} B_{\{j,l\}} C_{\{k,l\}}.
```
Note that the variable $l$ is shared by all three tensors, making regular edges, which by definition connect two nodes, insufficient for its representation. This motivates the need for hyperedges, which can connect a single variable to any number of nodes. The hypergraph representation is given as:

```@raw html
<img src="../assets/starcontract.png" width=500 style="margin-left:auto; margin-right:auto; display:block"/>
```

## Einsum notation
The einsum notation is a compact way to specify tensor contractions with a string. In this notation, an index (subscripts) is represented by a char, and the tensors are represented by the indices. The input tensors and the output tensor are separated by an arrow `->` and input tensors are separated by comma `,`. For example, the matrix multiplication $\left(\{i,j,k\}, \{A_{\{i, j\}}, B_{\{j, k\}}\}, \{i, k\}\right)$ can be concisely written as `"ij,jk->ik"`. A general contraction can be defined with pseudocode as follows:
```
Let A, B, C, ... be input tensors, O be the output tensor
for indices in domain_of_unique_indices(einsum_notation)
    O[indices in O] += A[indices in A] * B[indices in B] * ...
end
```

#### Examples
| einsum notation             | meaning         |
| ---------------- | --------------- |
| `ij,jk->ik`   | matrix matrix multiplication |
| `ijl,jkl->ikl`   | batched - matrix matrix multiplication |
| `ij,j->i`   | matrix vector multiplication |
| `ij,ik,il->jkl`   | star contraction |
| `ii->`   | trace |
| `ij->i` | sum |
| `ii->i` | take the diagonal part of a matrix |
| `ijkl->ilkj` | permute the dimensions of a tensor |
| `i->ii` | construct a diagonal matrix |
| `->ii`  | broadcast a scalar to the diagonal part of a matrix |
| `ij,ij->ij`  | element wise product |
| `ij,kl->ijkl`  | outer product |


Please [Einsum examples](@ref) for code examples.

# CUDA Acceleration

OMEinsum supports GPU acceleration through CUDA.jl. By uploading your data to the GPU, you can significantly accelerate tensor contractions.

## Basic CUDA Usage

```julia repl
julia> using CUDA, OMEinsum

julia> code = ein"ij,jk,kl,li->"  # the einsum notation
ij, jk, kl, li -> 

julia> A, B, C, D = rand(1000, 1000), rand(1000, 300), rand(300, 800), rand(800, 1000);

julia> size_dict = OMEinsum.get_size_dict(getixsv(code), (A, B, C, D))  # get the size of the labels
Dict{Char, Int64} with 4 entries:
  'j' => 1000
  'i' => 1000
  'k' => 300
  'l' => 800

julia> optcode = optimize_code(code, size_dict, TreeSA())  # optimize the contraction order
SlicedEinsum{Char, DynamicNestedEinsum{Char}}(Char[], kl, kl -> 
├─ ki, li -> kl
│  ├─ jk, ij -> ki
│  │  ├─ jk
│  │  └─ ij
│  └─ li
└─ kl
)
```

The contraction order is optimized. Now, let's benchmark the contraction on the CPU.

```julia repl
julia> using BenchmarkTools

julia> @btime optcode($A, $B, $C, $D)  # the contraction on CPU
  6.053 ms (308 allocations: 20.16 MiB)
0-dimensional Array{Float64, 0}:
1.4984046443610943e10
```

The contraction on the CPU takes about 6 ms. Now, let's upload the data to the GPU and perform the contraction on the GPU.
```julia repl
julia> cuA, cuB, cuC, cuD = CuArray(A), CuArray(B), CuArray(C), CuArray(D);

julia> @btime CUDA.@sync optcode($cuA, $cuB, $cuC, $cuD)  # the contraction on GPU
  243.888 μs (763 allocations: 28.56 KiB)
0-dimensional CuArray{Float64, 0, CUDA.DeviceMemory}:
1.4984046443610939e10
```

## GPU Backends

OMEinsum provides two backends for GPU tensor contractions:

| Backend | Library | Best For |
|---------|---------|----------|
| `DefaultBackend()` | CUBLAS | Matrix-like contractions (GEMM patterns) |
| `CuTensorBackend()` | cuTENSOR | General tensor contractions |

### DefaultBackend (CUBLAS)

The default backend uses NVIDIA's CUBLAS library. It works by:
1. Analyzing the contraction pattern
2. Reshaping tensors to fit matrix multiplication (GEMM) format
3. Calling `CUBLAS.gemm_strided_batched!`
4. Reshaping the result back

This approach works well for contractions that naturally map to matrix multiplication, such as:
- `ein"ij,jk->ik"` (matrix multiplication)
- `ein"ijl,jkl->ikl"` (batched matrix multiplication)

### CuTensorBackend (cuTENSOR)

The cuTENSOR backend uses NVIDIA's cuTENSOR library, which provides **native tensor contraction** without the reshape/permute overhead. This is especially beneficial for:

- **Non-GEMM patterns**: Contractions like `ein"ijk,jkl->il"` that don't naturally fit GEMM
- **High-dimensional tensors**: Avoids costly permutations
- **Complex index patterns**: Direct support for arbitrary contraction patterns

## Using the cuTENSOR Backend

### Prerequisites

cuTENSOR requires:
- NVIDIA GPU with compute capability ≥ 6.0
- CUDA.jl v5.0 or later
- cuTENSOR.jl package (install with `Pkg.add("cuTENSOR")`)

### Check Availability

```julia
using CUDA
using cuTENSOR  # Must be loaded to enable the cuTENSOR backend
using OMEinsum

# Check if cuTENSOR is available
if cuTENSOR.has_cutensor()
    println("cuTENSOR is available!")
else
    println("cuTENSOR is not available")
end
```

!!! important "Loading cuTENSOR"
    cuTENSOR.jl is a **separate package**. You must:
    1. Install it: `Pkg.add("cuTENSOR")`
    2. Load it **before** or alongside OMEinsum: `using cuTENSOR`
    
    This triggers OMEinsum's `CuTENSORExt` extension, which provides the cuTENSOR backend functionality.

### Enable cuTENSOR Backend

```julia
using CUDA
using cuTENSOR  # ← Required! This loads the CuTENSORExt extension
using OMEinsum

# Set the backend globally
set_einsum_backend!(CuTensorBackend())

# Now all GPU einsum operations will use cuTENSOR
A = CUDA.rand(Float32, 100, 200, 300)
B = CUDA.rand(Float32, 200, 300, 400)
C = ein"ijk,jkl->il"(A, B)  # Uses cuTENSOR

# Reset to default backend
set_einsum_backend!(DefaultBackend())
```

!!! warning "Forgetting to load cuTENSOR"
    If you set `CuTensorBackend()` without loading cuTENSOR.jl, you'll see:
    ```
    ┌ Warning: CuTensorBackend: cuTENSOR.jl not loaded - run `using cuTENSOR` first. Will fall back to CUBLAS.
    ```
    The computation will still work (using CUBLAS), but you won't get the cuTENSOR optimization.

### Supported Data Types

The cuTENSOR backend supports BLAS-compatible types:
- `Float16`, `Float32`, `Float64`
- `ComplexF16`, `ComplexF32`, `ComplexF64`

For other types (e.g., `Double64`, custom number types), the cuTENSOR backend automatically falls back to the DefaultBackend (CUBLAS-based) implementation.

### Example: Performance Comparison

```julia
using CUDA
using cuTENSOR  # Required for cuTENSOR backend
using OMEinsum, BenchmarkTools

# Create test tensors (non-GEMM pattern)
A = CUDA.rand(Float32, 64, 64, 64)
B = CUDA.rand(Float32, 64, 64, 64)

# Benchmark with DefaultBackend (CUBLAS)
set_einsum_backend!(DefaultBackend())
@btime CUDA.@sync ein"ijk,jkl->il"($A, $B)
# Requires: permute → reshape → GEMM → reshape

# Benchmark with CuTensorBackend
set_einsum_backend!(CuTensorBackend())
@btime CUDA.@sync ein"ijk,jkl->il"($A, $B)
# Direct tensor contraction - no intermediate steps!
```

### When to Use cuTENSOR

| Use Case | Recommended Backend |
|----------|-------------------|
| Matrix multiplication `ij,jk->ik` | Either (similar performance) |
| Batched matmul `ijl,jkl->ikl` | Either (similar performance) |
| Tensor contraction `ijk,jkl->il` | **CuTensorBackend** |
| High-dimensional `ijkl,klmn->ijmn` | **CuTensorBackend** |
| MPS/PEPS contractions | **CuTensorBackend** |
| Non-BLAS types (Double64, etc.) | DefaultBackend |

### Best Practices

1. **Use cuTENSOR for tensor networks**: If you're doing MPS, PEPS, or general tensor network contractions, cuTENSOR typically provides better performance.

2. **Profile your workload**: The relative performance depends on tensor sizes and contraction patterns. Use `BenchmarkTools` to measure.

3. **Keep data on GPU**: Minimize CPU-GPU transfers by keeping intermediate results on the GPU.

4. **Batch operations**: When contracting many small tensors, consider batching them together.

```julia
# Good: Keep data on GPU throughout
cuA, cuB, cuC = CuArray.((A, B, C))
result = ein"(ij,jk),kl->il"(cuA, cuB, cuC)

# Avoid: Repeated transfers
result = ein"ij,jk->ik"(CuArray(A), CuArray(B))  # Transfer every call
```

## Nested Contractions with cuTENSOR

The cuTENSOR backend works seamlessly with optimized contraction orders:

```julia
using CUDA, cuTENSOR, OMEinsum

set_einsum_backend!(CuTensorBackend())

# Define a tensor network
code = ein"ij,jk,kl,lm->im"

# Optimize contraction order
size_dict = Dict('i'=>100, 'j'=>100, 'k'=>100, 'l'=>100, 'm'=>100)
optcode = optimize_code(code, size_dict, TreeSA())

# Execute with cuTENSOR (each pairwise contraction uses cuTENSOR)
A, B, C, D = [CUDA.rand(Float32, 100, 100) for _ in 1:4]
result = optcode(A, B, C, D)
```

## Troubleshooting

### cuTENSOR not detected

If `has_cutensor()` returns `false`:

1. **Check CUDA.jl version**: Ensure you have CUDA.jl v5.0+
   ```julia
   using Pkg
   Pkg.status("CUDA")
   ```

2. **Check GPU compatibility**: cuTENSOR requires compute capability ≥ 6.0
   ```julia
   using CUDA
   CUDA.capability(CUDA.device())
   ```

3. **Reinstall CUDA artifacts**:
   ```julia
   using CUDA
   CUDA.versioninfo()  # Check if cuTENSOR is listed
   ```

### Performance not as expected

1. **Ensure synchronization**: Use `CUDA.@sync` when benchmarking
2. **Check tensor sizes**: cuTENSOR has more overhead for very small tensors
3. **Verify backend is active**: Check `get_einsum_backend()`

## Video Tutorial

To learn more about using GPU and autodiff, please check out the following asciinema video.
[![asciicast](https://asciinema.org/a/wE4CtIzWUC3R0GkVV28rVBRFb.svg)](https://asciinema.org/a/wE4CtIzWUC3R0GkVV28rVBRFb)
